"Main interface for pinpoint service type defs"
from __future__ import annotations

from datetime import datetime
from typing import Dict, List
from mypy_boto3.type_defs import Literal, TypedDict


__all__ = (
    "ClientCreateAppCreateApplicationRequestTypeDef",
    "ClientCreateAppResponseApplicationResponseTypeDef",
    "ClientCreateAppResponseTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseHookTypeDef",
    "ClientCreateCampaignResponseCampaignResponseLimitsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    "ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    "ClientCreateCampaignResponseCampaignResponseScheduleTypeDef",
    "ClientCreateCampaignResponseCampaignResponseStateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    "ClientCreateCampaignResponseCampaignResponseTypeDef",
    "ClientCreateCampaignResponseTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestHookTypeDef",
    "ClientCreateCampaignWriteCampaignRequestLimitsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef",
    "ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef",
    "ClientCreateCampaignWriteCampaignRequestScheduleTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef",
    "ClientCreateCampaignWriteCampaignRequestTypeDef",
    "ClientCreateEmailTemplateEmailTemplateRequestTypeDef",
    "ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef",
    "ClientCreateEmailTemplateResponseTypeDef",
    "ClientCreateExportJobExportJobRequestTypeDef",
    "ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef",
    "ClientCreateExportJobResponseExportJobResponseTypeDef",
    "ClientCreateExportJobResponseTypeDef",
    "ClientCreateImportJobImportJobRequestTypeDef",
    "ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef",
    "ClientCreateImportJobResponseImportJobResponseTypeDef",
    "ClientCreateImportJobResponseTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    "ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef",
    "ClientCreateJourneyResponseJourneyResponseLimitsTypeDef",
    "ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef",
    "ClientCreateJourneyResponseJourneyResponseScheduleTypeDef",
    "ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef",
    "ClientCreateJourneyResponseJourneyResponseTypeDef",
    "ClientCreateJourneyResponseTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef",
    "ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef",
    "ClientCreateJourneyWriteJourneyRequestLimitsTypeDef",
    "ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef",
    "ClientCreateJourneyWriteJourneyRequestScheduleTypeDef",
    "ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef",
    "ClientCreateJourneyWriteJourneyRequestTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef",
    "ClientCreatePushTemplatePushNotificationTemplateRequestTypeDef",
    "ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef",
    "ClientCreatePushTemplateResponseTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    "ClientCreateSegmentResponseSegmentResponseTypeDef",
    "ClientCreateSegmentResponseTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef",
    "ClientCreateSegmentWriteSegmentRequestTypeDef",
    "ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef",
    "ClientCreateSmsTemplateResponseTypeDef",
    "ClientCreateSmsTemplateSMSTemplateRequestTypeDef",
    "ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef",
    "ClientCreateVoiceTemplateResponseTypeDef",
    "ClientCreateVoiceTemplateVoiceTemplateRequestTypeDef",
    "ClientDeleteAdmChannelResponseADMChannelResponseTypeDef",
    "ClientDeleteAdmChannelResponseTypeDef",
    "ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef",
    "ClientDeleteApnsChannelResponseTypeDef",
    "ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    "ClientDeleteApnsSandboxChannelResponseTypeDef",
    "ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    "ClientDeleteApnsVoipChannelResponseTypeDef",
    "ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    "ClientDeleteApnsVoipSandboxChannelResponseTypeDef",
    "ClientDeleteAppResponseApplicationResponseTypeDef",
    "ClientDeleteAppResponseTypeDef",
    "ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef",
    "ClientDeleteBaiduChannelResponseTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseHookTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseStateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    "ClientDeleteCampaignResponseCampaignResponseTypeDef",
    "ClientDeleteCampaignResponseTypeDef",
    "ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef",
    "ClientDeleteEmailChannelResponseTypeDef",
    "ClientDeleteEmailTemplateResponseMessageBodyTypeDef",
    "ClientDeleteEmailTemplateResponseTypeDef",
    "ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef",
    "ClientDeleteEndpointResponseEndpointResponseLocationTypeDef",
    "ClientDeleteEndpointResponseEndpointResponseUserTypeDef",
    "ClientDeleteEndpointResponseEndpointResponseTypeDef",
    "ClientDeleteEndpointResponseTypeDef",
    "ClientDeleteEventStreamResponseEventStreamTypeDef",
    "ClientDeleteEventStreamResponseTypeDef",
    "ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef",
    "ClientDeleteGcmChannelResponseTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef",
    "ClientDeleteJourneyResponseJourneyResponseTypeDef",
    "ClientDeleteJourneyResponseTypeDef",
    "ClientDeletePushTemplateResponseMessageBodyTypeDef",
    "ClientDeletePushTemplateResponseTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    "ClientDeleteSegmentResponseSegmentResponseTypeDef",
    "ClientDeleteSegmentResponseTypeDef",
    "ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef",
    "ClientDeleteSmsChannelResponseTypeDef",
    "ClientDeleteSmsTemplateResponseMessageBodyTypeDef",
    "ClientDeleteSmsTemplateResponseTypeDef",
    "ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef",
    "ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef",
    "ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef",
    "ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef",
    "ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef",
    "ClientDeleteUserEndpointsResponseTypeDef",
    "ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef",
    "ClientDeleteVoiceChannelResponseTypeDef",
    "ClientDeleteVoiceTemplateResponseMessageBodyTypeDef",
    "ClientDeleteVoiceTemplateResponseTypeDef",
    "ClientGetAdmChannelResponseADMChannelResponseTypeDef",
    "ClientGetAdmChannelResponseTypeDef",
    "ClientGetApnsChannelResponseAPNSChannelResponseTypeDef",
    "ClientGetApnsChannelResponseTypeDef",
    "ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    "ClientGetApnsSandboxChannelResponseTypeDef",
    "ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    "ClientGetApnsVoipChannelResponseTypeDef",
    "ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    "ClientGetApnsVoipSandboxChannelResponseTypeDef",
    "ClientGetAppResponseApplicationResponseTypeDef",
    "ClientGetAppResponseTypeDef",
    "ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    "ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    "ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef",
    "ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef",
    "ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef",
    "ClientGetApplicationDateRangeKpiResponseTypeDef",
    "ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef",
    "ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef",
    "ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef",
    "ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef",
    "ClientGetApplicationSettingsResponseTypeDef",
    "ClientGetAppsResponseApplicationsResponseItemTypeDef",
    "ClientGetAppsResponseApplicationsResponseTypeDef",
    "ClientGetAppsResponseTypeDef",
    "ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef",
    "ClientGetBaiduChannelResponseTypeDef",
    "ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef",
    "ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef",
    "ClientGetCampaignActivitiesResponseTypeDef",
    "ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    "ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    "ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef",
    "ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef",
    "ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef",
    "ClientGetCampaignDateRangeKpiResponseTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    "ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef",
    "ClientGetCampaignResponseCampaignResponseHookTypeDef",
    "ClientGetCampaignResponseCampaignResponseLimitsTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    "ClientGetCampaignResponseCampaignResponseScheduleTypeDef",
    "ClientGetCampaignResponseCampaignResponseStateTypeDef",
    "ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    "ClientGetCampaignResponseCampaignResponseTypeDef",
    "ClientGetCampaignResponseTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseHookTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseStateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef",
    "ClientGetCampaignVersionResponseCampaignResponseTypeDef",
    "ClientGetCampaignVersionResponseTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef",
    "ClientGetCampaignVersionsResponseCampaignsResponseTypeDef",
    "ClientGetCampaignVersionsResponseTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseItemTypeDef",
    "ClientGetCampaignsResponseCampaignsResponseTypeDef",
    "ClientGetCampaignsResponseTypeDef",
    "ClientGetChannelsResponseChannelsResponseChannelsTypeDef",
    "ClientGetChannelsResponseChannelsResponseTypeDef",
    "ClientGetChannelsResponseTypeDef",
    "ClientGetEmailChannelResponseEmailChannelResponseTypeDef",
    "ClientGetEmailChannelResponseTypeDef",
    "ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef",
    "ClientGetEmailTemplateResponseTypeDef",
    "ClientGetEndpointResponseEndpointResponseDemographicTypeDef",
    "ClientGetEndpointResponseEndpointResponseLocationTypeDef",
    "ClientGetEndpointResponseEndpointResponseUserTypeDef",
    "ClientGetEndpointResponseEndpointResponseTypeDef",
    "ClientGetEndpointResponseTypeDef",
    "ClientGetEventStreamResponseEventStreamTypeDef",
    "ClientGetEventStreamResponseTypeDef",
    "ClientGetExportJobResponseExportJobResponseDefinitionTypeDef",
    "ClientGetExportJobResponseExportJobResponseTypeDef",
    "ClientGetExportJobResponseTypeDef",
    "ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef",
    "ClientGetExportJobsResponseExportJobsResponseItemTypeDef",
    "ClientGetExportJobsResponseExportJobsResponseTypeDef",
    "ClientGetExportJobsResponseTypeDef",
    "ClientGetGcmChannelResponseGCMChannelResponseTypeDef",
    "ClientGetGcmChannelResponseTypeDef",
    "ClientGetImportJobResponseImportJobResponseDefinitionTypeDef",
    "ClientGetImportJobResponseImportJobResponseTypeDef",
    "ClientGetImportJobResponseTypeDef",
    "ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef",
    "ClientGetImportJobsResponseImportJobsResponseItemTypeDef",
    "ClientGetImportJobsResponseImportJobsResponseTypeDef",
    "ClientGetImportJobsResponseTypeDef",
    "ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    "ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    "ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef",
    "ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef",
    "ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef",
    "ClientGetJourneyDateRangeKpiResponseTypeDef",
    "ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef",
    "ClientGetJourneyExecutionActivityMetricsResponseTypeDef",
    "ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef",
    "ClientGetJourneyExecutionMetricsResponseTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    "ClientGetJourneyResponseJourneyResponseActivitiesTypeDef",
    "ClientGetJourneyResponseJourneyResponseLimitsTypeDef",
    "ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef",
    "ClientGetJourneyResponseJourneyResponseScheduleTypeDef",
    "ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseStartConditionTypeDef",
    "ClientGetJourneyResponseJourneyResponseTypeDef",
    "ClientGetJourneyResponseTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef",
    "ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef",
    "ClientGetPushTemplateResponseTypeDef",
    "ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef",
    "ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef",
    "ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef",
    "ClientGetSegmentExportJobsResponseTypeDef",
    "ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef",
    "ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef",
    "ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef",
    "ClientGetSegmentImportJobsResponseTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    "ClientGetSegmentResponseSegmentResponseDimensionsTypeDef",
    "ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    "ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    "ClientGetSegmentResponseSegmentResponseTypeDef",
    "ClientGetSegmentResponseTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef",
    "ClientGetSegmentVersionResponseSegmentResponseTypeDef",
    "ClientGetSegmentVersionResponseTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef",
    "ClientGetSegmentVersionsResponseSegmentsResponseTypeDef",
    "ClientGetSegmentVersionsResponseTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseItemTypeDef",
    "ClientGetSegmentsResponseSegmentsResponseTypeDef",
    "ClientGetSegmentsResponseTypeDef",
    "ClientGetSmsChannelResponseSMSChannelResponseTypeDef",
    "ClientGetSmsChannelResponseTypeDef",
    "ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef",
    "ClientGetSmsTemplateResponseTypeDef",
    "ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef",
    "ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef",
    "ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef",
    "ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef",
    "ClientGetUserEndpointsResponseEndpointsResponseTypeDef",
    "ClientGetUserEndpointsResponseTypeDef",
    "ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef",
    "ClientGetVoiceChannelResponseTypeDef",
    "ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef",
    "ClientGetVoiceTemplateResponseTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef",
    "ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef",
    "ClientListJourneysResponseJourneysResponseItemLimitsTypeDef",
    "ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef",
    "ClientListJourneysResponseJourneysResponseItemScheduleTypeDef",
    "ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef",
    "ClientListJourneysResponseJourneysResponseItemTypeDef",
    "ClientListJourneysResponseJourneysResponseTypeDef",
    "ClientListJourneysResponseTypeDef",
    "ClientListTagsForResourceResponseTagsModelTypeDef",
    "ClientListTagsForResourceResponseTypeDef",
    "ClientListTemplatesResponseTemplatesResponseItemTypeDef",
    "ClientListTemplatesResponseTemplatesResponseTypeDef",
    "ClientListTemplatesResponseTypeDef",
    "ClientPhoneNumberValidateNumberValidateRequestTypeDef",
    "ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef",
    "ClientPhoneNumberValidateResponseTypeDef",
    "ClientPutEventStreamResponseEventStreamTypeDef",
    "ClientPutEventStreamResponseTypeDef",
    "ClientPutEventStreamWriteEventStreamTypeDef",
    "ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef",
    "ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef",
    "ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef",
    "ClientPutEventsEventsRequestBatchItemEndpointTypeDef",
    "ClientPutEventsEventsRequestBatchItemEventsSessionTypeDef",
    "ClientPutEventsEventsRequestBatchItemEventsTypeDef",
    "ClientPutEventsEventsRequestBatchItemTypeDef",
    "ClientPutEventsEventsRequestTypeDef",
    "ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef",
    "ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef",
    "ClientPutEventsResponseEventsResponseResultsTypeDef",
    "ClientPutEventsResponseEventsResponseTypeDef",
    "ClientPutEventsResponseTypeDef",
    "ClientRemoveAttributesResponseAttributesResourceTypeDef",
    "ClientRemoveAttributesResponseTypeDef",
    "ClientRemoveAttributesUpdateAttributesRequestTypeDef",
    "ClientSendMessagesMessageRequestAddressesTypeDef",
    "ClientSendMessagesMessageRequestEndpointsTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef",
    "ClientSendMessagesMessageRequestMessageConfigurationTypeDef",
    "ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef",
    "ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef",
    "ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef",
    "ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef",
    "ClientSendMessagesMessageRequestTemplateConfigurationTypeDef",
    "ClientSendMessagesMessageRequestTypeDef",
    "ClientSendMessagesResponseMessageResponseEndpointResultTypeDef",
    "ClientSendMessagesResponseMessageResponseResultTypeDef",
    "ClientSendMessagesResponseMessageResponseTypeDef",
    "ClientSendMessagesResponseTypeDef",
    "ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef",
    "ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef",
    "ClientSendUsersMessagesResponseTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef",
    "ClientSendUsersMessagesSendUsersMessageRequestTypeDef",
    "ClientTagResourceTagsModelTypeDef",
    "ClientUpdateAdmChannelADMChannelRequestTypeDef",
    "ClientUpdateAdmChannelResponseADMChannelResponseTypeDef",
    "ClientUpdateAdmChannelResponseTypeDef",
    "ClientUpdateApnsChannelAPNSChannelRequestTypeDef",
    "ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef",
    "ClientUpdateApnsChannelResponseTypeDef",
    "ClientUpdateApnsSandboxChannelAPNSSandboxChannelRequestTypeDef",
    "ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    "ClientUpdateApnsSandboxChannelResponseTypeDef",
    "ClientUpdateApnsVoipChannelAPNSVoipChannelRequestTypeDef",
    "ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    "ClientUpdateApnsVoipChannelResponseTypeDef",
    "ClientUpdateApnsVoipSandboxChannelAPNSVoipSandboxChannelRequestTypeDef",
    "ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    "ClientUpdateApnsVoipSandboxChannelResponseTypeDef",
    "ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef",
    "ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef",
    "ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef",
    "ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef",
    "ClientUpdateApplicationSettingsResponseTypeDef",
    "ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef",
    "ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef",
    "ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef",
    "ClientUpdateApplicationSettingsWriteApplicationSettingsRequestTypeDef",
    "ClientUpdateBaiduChannelBaiduChannelRequestTypeDef",
    "ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef",
    "ClientUpdateBaiduChannelResponseTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseHookTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseStateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    "ClientUpdateCampaignResponseCampaignResponseTypeDef",
    "ClientUpdateCampaignResponseTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestHookTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestScheduleTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef",
    "ClientUpdateCampaignWriteCampaignRequestTypeDef",
    "ClientUpdateEmailChannelEmailChannelRequestTypeDef",
    "ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef",
    "ClientUpdateEmailChannelResponseTypeDef",
    "ClientUpdateEmailTemplateEmailTemplateRequestTypeDef",
    "ClientUpdateEmailTemplateResponseMessageBodyTypeDef",
    "ClientUpdateEmailTemplateResponseTypeDef",
    "ClientUpdateEndpointEndpointRequestDemographicTypeDef",
    "ClientUpdateEndpointEndpointRequestLocationTypeDef",
    "ClientUpdateEndpointEndpointRequestUserTypeDef",
    "ClientUpdateEndpointEndpointRequestTypeDef",
    "ClientUpdateEndpointResponseMessageBodyTypeDef",
    "ClientUpdateEndpointResponseTypeDef",
    "ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef",
    "ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef",
    "ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef",
    "ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef",
    "ClientUpdateEndpointsBatchEndpointBatchRequestTypeDef",
    "ClientUpdateEndpointsBatchResponseMessageBodyTypeDef",
    "ClientUpdateEndpointsBatchResponseTypeDef",
    "ClientUpdateGcmChannelGCMChannelRequestTypeDef",
    "ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef",
    "ClientUpdateGcmChannelResponseTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef",
    "ClientUpdateJourneyResponseJourneyResponseTypeDef",
    "ClientUpdateJourneyResponseTypeDef",
    "ClientUpdateJourneyStateJourneyStateRequestTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef",
    "ClientUpdateJourneyStateResponseJourneyResponseTypeDef",
    "ClientUpdateJourneyStateResponseTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef",
    "ClientUpdateJourneyWriteJourneyRequestTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef",
    "ClientUpdatePushTemplatePushNotificationTemplateRequestTypeDef",
    "ClientUpdatePushTemplateResponseMessageBodyTypeDef",
    "ClientUpdatePushTemplateResponseTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    "ClientUpdateSegmentResponseSegmentResponseTypeDef",
    "ClientUpdateSegmentResponseTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef",
    "ClientUpdateSegmentWriteSegmentRequestTypeDef",
    "ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef",
    "ClientUpdateSmsChannelResponseTypeDef",
    "ClientUpdateSmsChannelSMSChannelRequestTypeDef",
    "ClientUpdateSmsTemplateResponseMessageBodyTypeDef",
    "ClientUpdateSmsTemplateResponseTypeDef",
    "ClientUpdateSmsTemplateSMSTemplateRequestTypeDef",
    "ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef",
    "ClientUpdateVoiceChannelResponseTypeDef",
    "ClientUpdateVoiceChannelVoiceChannelRequestTypeDef",
    "ClientUpdateVoiceTemplateResponseMessageBodyTypeDef",
    "ClientUpdateVoiceTemplateResponseTypeDef",
    "ClientUpdateVoiceTemplateVoiceTemplateRequestTypeDef",
)


_RequiredClientCreateAppCreateApplicationRequestTypeDef = TypedDict(
    "_RequiredClientCreateAppCreateApplicationRequestTypeDef", {"Name": str}
)
_OptionalClientCreateAppCreateApplicationRequestTypeDef = TypedDict(
    "_OptionalClientCreateAppCreateApplicationRequestTypeDef", {"tags": Dict[str, str]}, total=False
)


class ClientCreateAppCreateApplicationRequestTypeDef(
    _RequiredClientCreateAppCreateApplicationRequestTypeDef,
    _OptionalClientCreateAppCreateApplicationRequestTypeDef,
):
    """
    Specifies the display name of an application and the tags to associate with the application.
    - **Name** *(string) --***[REQUIRED]**

      The display name of the application. This name is displayed as the **Project name** on the
      Amazon Pinpoint console.
    """


_ClientCreateAppResponseApplicationResponseTypeDef = TypedDict(
    "_ClientCreateAppResponseApplicationResponseTypeDef",
    {"Arn": str, "Id": str, "Name": str, "tags": Dict[str, str]},
    total=False,
)


class ClientCreateAppResponseApplicationResponseTypeDef(
    _ClientCreateAppResponseApplicationResponseTypeDef
):
    """
    - **ApplicationResponse** *(dict) --*

      Provides information about an application.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the application.
    """


_ClientCreateAppResponseTypeDef = TypedDict(
    "_ClientCreateAppResponseTypeDef",
    {"ApplicationResponse": ClientCreateAppResponseApplicationResponseTypeDef},
    total=False,
)


class ClientCreateAppResponseTypeDef(_ClientCreateAppResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded and the specified resource was created.
      - **ApplicationResponse** *(dict) --*

        Provides information about an application.
        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the application.
    """


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
):
    """
    - *(dict) --*

      Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
      that's used for A/B testing of a campaign.
      - **Id** *(string) --*

        The unique identifier for the treatment.
    """


_ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseHookTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseHookTypeDef(
    _ClientCreateCampaignResponseCampaignResponseHookTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseLimitsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseLimitsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseLimitsTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientCreateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef(
    _ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientCreateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseScheduleTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientCreateCampaignResponseCampaignResponseScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientCreateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseScheduleTypeDef(
    _ClientCreateCampaignResponseCampaignResponseScheduleTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseStateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseStateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseStateTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientCreateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientCreateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientCreateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientCreateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef
):
    pass


_ClientCreateCampaignResponseCampaignResponseTypeDef = TypedDict(
    "_ClientCreateCampaignResponseCampaignResponseTypeDef",
    {
        "AdditionalTreatments": List[
            ClientCreateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientCreateCampaignResponseCampaignResponseDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientCreateCampaignResponseCampaignResponseHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientCreateCampaignResponseCampaignResponseLimitsTypeDef,
        "MessageConfiguration": ClientCreateCampaignResponseCampaignResponseMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientCreateCampaignResponseCampaignResponseScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientCreateCampaignResponseCampaignResponseStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientCreateCampaignResponseCampaignResponseTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientCreateCampaignResponseCampaignResponseTypeDef(
    _ClientCreateCampaignResponseCampaignResponseTypeDef
):
    """
    - **CampaignResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.
      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.
        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.
          - **Id** *(string) --*

            The unique identifier for the treatment.
    """


_ClientCreateCampaignResponseTypeDef = TypedDict(
    "_ClientCreateCampaignResponseTypeDef",
    {"CampaignResponse": ClientCreateCampaignResponseCampaignResponseTypeDef},
    total=False,
)


class ClientCreateCampaignResponseTypeDef(_ClientCreateCampaignResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded and the specified resource was created.
      - **CampaignResponse** *(dict) --*

        Provides information about the status, configuration, and other settings for a campaign.
        - **AdditionalTreatments** *(list) --*

          An array of responses, one for each treatment that you defined for the campaign, in
          addition to the default treatment.
          - *(dict) --*

            Specifies the settings for a campaign treatment. A treatment is a variation of a
            campaign that's used for A/B testing of a campaign.
            - **Id** *(string) --*

              The unique identifier for the treatment.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    """
    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.
      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:
        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.
        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.
        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef
):
    """
    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the treatment.
      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.
        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:
          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.
          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.
          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.
    """


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef",
    {
        "MessageConfiguration": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "TemplateConfiguration": ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef(
    _ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef
):
    """
    - *(dict) --*

      Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
      that's used for A/B testing of a campaign.
      - **MessageConfiguration** *(dict) --*

        The message configuration settings for the treatment.
        - **ADMMessage** *(dict) --*

          The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
          This message overrides the default message.
          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:
            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.
            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.
            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.
    """


_ClientCreateCampaignWriteCampaignRequestHookTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestHookTypeDef(
    _ClientCreateCampaignWriteCampaignRequestHookTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestLimitsTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestLimitsTypeDef(
    _ClientCreateCampaignWriteCampaignRequestLimitsTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientCreateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef(
    _ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str, ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef
        ],
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef(
    _ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientCreateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef(
    _ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef(
    _ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestScheduleTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientCreateCampaignWriteCampaignRequestScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientCreateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestScheduleTypeDef(
    _ClientCreateCampaignWriteCampaignRequestScheduleTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientCreateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientCreateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientCreateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientCreateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef
):
    pass


_ClientCreateCampaignWriteCampaignRequestTypeDef = TypedDict(
    "_ClientCreateCampaignWriteCampaignRequestTypeDef",
    {
        "AdditionalTreatments": List[
            ClientCreateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef
        ],
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientCreateCampaignWriteCampaignRequestHookTypeDef,
        "IsPaused": bool,
        "Limits": ClientCreateCampaignWriteCampaignRequestLimitsTypeDef,
        "MessageConfiguration": ClientCreateCampaignWriteCampaignRequestMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientCreateCampaignWriteCampaignRequestScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientCreateCampaignWriteCampaignRequestTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientCreateCampaignWriteCampaignRequestTypeDef(
    _ClientCreateCampaignWriteCampaignRequestTypeDef
):
    """
    Specifies the configuration and other settings for a campaign.
    - **AdditionalTreatments** *(list) --*

      An array of requests that defines additional treatments for the campaign, in addition to the
      default treatment for the campaign.
      - *(dict) --*

        Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
        that's used for A/B testing of a campaign.
        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the treatment.
          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.
            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:
              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.
              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.
              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.
    """


_ClientCreateEmailTemplateEmailTemplateRequestTypeDef = TypedDict(
    "_ClientCreateEmailTemplateEmailTemplateRequestTypeDef",
    {
        "DefaultSubstitutions": str,
        "HtmlPart": str,
        "Subject": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TextPart": str,
    },
    total=False,
)


class ClientCreateEmailTemplateEmailTemplateRequestTypeDef(
    _ClientCreateEmailTemplateEmailTemplateRequestTypeDef
):
    """
    Creates a new message template that you can use in messages that are sent through the email
    channel.
    - **DefaultSubstitutions** *(string) --*

      A JSON object that specifies the default values to use for message variables in the message
      template. This object is a set of key-value pairs. Each key defines a message variable in the
      template. The corresponding value defines the default value for that variable. When you create
      a message that's based on the template, you can override these defaults with message-specific
      and address-specific variables and values.
    """


_ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef = TypedDict(
    "_ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef",
    {"Arn": str, "Message": str, "RequestID": str},
    total=False,
)


class ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef(
    _ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef
):
    """
    - **CreateTemplateMessageBody** *(dict) --*

      Provides information about a request to create a message template.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template that was created.
    """


_ClientCreateEmailTemplateResponseTypeDef = TypedDict(
    "_ClientCreateEmailTemplateResponseTypeDef",
    {
        "CreateTemplateMessageBody": ClientCreateEmailTemplateResponseCreateTemplateMessageBodyTypeDef
    },
    total=False,
)


class ClientCreateEmailTemplateResponseTypeDef(_ClientCreateEmailTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded and the specified resource was created.
      - **CreateTemplateMessageBody** *(dict) --*

        Provides information about a request to create a message template.
        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the message template that was created.
    """


_RequiredClientCreateExportJobExportJobRequestTypeDef = TypedDict(
    "_RequiredClientCreateExportJobExportJobRequestTypeDef", {"RoleArn": str}
)
_OptionalClientCreateExportJobExportJobRequestTypeDef = TypedDict(
    "_OptionalClientCreateExportJobExportJobRequestTypeDef",
    {"S3UrlPrefix": str, "SegmentId": str, "SegmentVersion": int},
    total=False,
)


class ClientCreateExportJobExportJobRequestTypeDef(
    _RequiredClientCreateExportJobExportJobRequestTypeDef,
    _OptionalClientCreateExportJobExportJobRequestTypeDef,
):
    """
    Specifies the settings for a job that exports endpoint definitions to an Amazon Simple Storage
    Service (Amazon S3) bucket.
    - **RoleArn** *(string) --***[REQUIRED]**

      The Amazon Resource Name (ARN) of the AWS Identity and Access Management (IAM) role that
      authorizes Amazon Pinpoint to access the Amazon S3 location where you want to export endpoint
      definitions to.
    """


_ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef = TypedDict(
    "_ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef",
    {"RoleArn": str, "S3UrlPrefix": str, "SegmentId": str, "SegmentVersion": int},
    total=False,
)


class ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef(
    _ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef
):
    pass


_ClientCreateExportJobResponseExportJobResponseTypeDef = TypedDict(
    "_ClientCreateExportJobResponseExportJobResponseTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientCreateExportJobResponseExportJobResponseDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": Literal[
            "CREATED",
            "PREPARING_FOR_INITIALIZATION",
            "INITIALIZING",
            "PROCESSING",
            "PENDING_JOB",
            "COMPLETING",
            "COMPLETED",
            "FAILING",
            "FAILED",
        ],
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientCreateExportJobResponseExportJobResponseTypeDef(
    _ClientCreateExportJobResponseExportJobResponseTypeDef
):
    """
    - **ExportJobResponse** *(dict) --*

      Provides information about the status and settings of a job that exports endpoint definitions
      to a file. The file can be added directly to an Amazon Simple Storage Service (Amazon S3)
      bucket by using the Amazon Pinpoint API or downloaded directly to a computer by using the
      Amazon Pinpoint console.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the export job.
    """


_ClientCreateExportJobResponseTypeDef = TypedDict(
    "_ClientCreateExportJobResponseTypeDef",
    {"ExportJobResponse": ClientCreateExportJobResponseExportJobResponseTypeDef},
    total=False,
)


class ClientCreateExportJobResponseTypeDef(_ClientCreateExportJobResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **ExportJobResponse** *(dict) --*

        Provides information about the status and settings of a job that exports endpoint
        definitions to a file. The file can be added directly to an Amazon Simple Storage Service
        (Amazon S3) bucket by using the Amazon Pinpoint API or downloaded directly to a computer by
        using the Amazon Pinpoint console.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that's associated with the export job.
    """


_ClientCreateImportJobImportJobRequestTypeDef = TypedDict(
    "_ClientCreateImportJobImportJobRequestTypeDef",
    {
        "DefineSegment": bool,
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RegisterEndpoints": bool,
        "RoleArn": str,
        "S3Url": str,
        "SegmentId": str,
        "SegmentName": str,
    },
    total=False,
)


class ClientCreateImportJobImportJobRequestTypeDef(_ClientCreateImportJobImportJobRequestTypeDef):
    """
    Specifies the settings for a job that imports endpoint definitions from an Amazon Simple Storage
    Service (Amazon S3) bucket.
    - **DefineSegment** *(boolean) --*

      Specifies whether to create a segment that contains the endpoints, when the endpoint
      definitions are imported.
    """


_ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef = TypedDict(
    "_ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef",
    {
        "DefineSegment": bool,
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RegisterEndpoints": bool,
        "RoleArn": str,
        "S3Url": str,
        "SegmentId": str,
        "SegmentName": str,
    },
    total=False,
)


class ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef(
    _ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef
):
    pass


_ClientCreateImportJobResponseImportJobResponseTypeDef = TypedDict(
    "_ClientCreateImportJobResponseImportJobResponseTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientCreateImportJobResponseImportJobResponseDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": Literal[
            "CREATED",
            "PREPARING_FOR_INITIALIZATION",
            "INITIALIZING",
            "PROCESSING",
            "PENDING_JOB",
            "COMPLETING",
            "COMPLETED",
            "FAILING",
            "FAILED",
        ],
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientCreateImportJobResponseImportJobResponseTypeDef(
    _ClientCreateImportJobResponseImportJobResponseTypeDef
):
    """
    - **ImportJobResponse** *(dict) --*

      Provides information about the status and settings of a job that imports endpoint definitions
      from one or more files. The files can be stored in an Amazon Simple Storage Service (Amazon
      S3) bucket or uploaded directly from a computer by using the Amazon Pinpoint console.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the import job.
    """


_ClientCreateImportJobResponseTypeDef = TypedDict(
    "_ClientCreateImportJobResponseTypeDef",
    {"ImportJobResponse": ClientCreateImportJobResponseImportJobResponseTypeDef},
    total=False,
)


class ClientCreateImportJobResponseTypeDef(_ClientCreateImportJobResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded and the specified resource was created.
      - **ImportJobResponse** *(dict) --*

        Provides information about the status and settings of a job that imports endpoint
        definitions from one or more files. The files can be stored in an Amazon Simple Storage
        Service (Amazon S3) bucket or uploaded directly from a computer by using the Amazon Pinpoint
        console.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that's associated with the import job.
    """


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": Literal["ALL", "ANY"],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientCreateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    {
        "Branches": List[
            ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
        ]
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientCreateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef",
    {
        "ConditionalSplit": ClientCreateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientCreateJourneyResponseJourneyResponseActivitiesEMAILTypeDef,
        "Holdout": ClientCreateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef,
        "MultiCondition": ClientCreateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientCreateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef,
        "Wait": ClientCreateJourneyResponseJourneyResponseActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef(
    _ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseLimitsTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseLimitsTypeDef(
    _ClientCreateJourneyResponseJourneyResponseLimitsTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef(
    _ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseScheduleTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseScheduleTypeDef(
    _ClientCreateJourneyResponseJourneyResponseScheduleTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientCreateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef(
    _ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef
):
    pass


_ClientCreateJourneyResponseJourneyResponseTypeDef = TypedDict(
    "_ClientCreateJourneyResponseJourneyResponseTypeDef",
    {
        "Activities": Dict[str, ClientCreateJourneyResponseJourneyResponseActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientCreateJourneyResponseJourneyResponseLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientCreateJourneyResponseJourneyResponseQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientCreateJourneyResponseJourneyResponseScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientCreateJourneyResponseJourneyResponseStartConditionTypeDef,
        "State": Literal["DRAFT", "ACTIVE", "COMPLETED", "CANCELLED", "CLOSED"],
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientCreateJourneyResponseJourneyResponseTypeDef(
    _ClientCreateJourneyResponseJourneyResponseTypeDef
):
    """
    - **JourneyResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a journey.
      - **Activities** *(dict) --*

        The configuration and other settings for the activities that comprise the journey.
        - *(string) --*

          - *(dict) --*

            Specifies the configuration and other settings for an activity in a journey.
            - **ConditionalSplit** *(dict) --*

              The settings for a yes/no split activity. This type of activity sends participants
              down one of two paths in a journey, based on conditions that you specify.
              - **Condition** *(dict) --*

                The conditions that define the paths for the activity, and the relationship between
                the conditions.
                - **Conditions** *(list) --*

                  The conditions to evaluate for the activity.
                  - *(dict) --*

                    Specifies a condition to evaluate for an activity in a journey.
                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.
                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.
                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.
                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.
                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.
    """


_ClientCreateJourneyResponseTypeDef = TypedDict(
    "_ClientCreateJourneyResponseTypeDef",
    {"JourneyResponse": ClientCreateJourneyResponseJourneyResponseTypeDef},
    total=False,
)


class ClientCreateJourneyResponseTypeDef(_ClientCreateJourneyResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded and the specified resource was created.
      - **JourneyResponse** *(dict) --*

        Provides information about the status, configuration, and other settings for a journey.
        - **Activities** *(dict) --*

          The configuration and other settings for the activities that comprise the journey.
          - *(string) --*

            - *(dict) --*

              Specifies the configuration and other settings for an activity in a journey.
              - **ConditionalSplit** *(dict) --*

                The settings for a yes/no split activity. This type of activity sends participants
                down one of two paths in a journey, based on conditions that you specify.
                - **Condition** *(dict) --*

                  The conditions that define the paths for the activity, and the relationship
                  between the conditions.
                  - **Conditions** *(list) --*

                    The conditions to evaluate for the activity.
                    - *(dict) --*

                      Specifies a condition to evaluate for an activity in a journey.
                      - **EventCondition** *(dict) --*

                        The dimension settings for the event that's associated with the activity.
                        - **Dimensions** *(dict) --*

                          The dimensions for the event filter to use for the activity.
                          - **Attributes** *(dict) --*

                            One or more custom attributes that your application reports to Amazon
                            Pinpoint. You can use these attributes as selection criteria when you
                            create an event filter.
                            - *(string) --*

                              - *(dict) --*

                                Specifies attribute-based criteria for including or excluding
                                endpoints from a segment.
                                - **AttributeType** *(string) --*

                                  The type of segment dimension to use. Valid values are: INCLUSIVE,
                                  endpoints that match the criteria are included in the segment;
                                  and, EXCLUSIVE, endpoints that match the criteria are excluded
                                  from the segment.
    """


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": Literal["ALL", "ANY"],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientCreateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef",
    {"Branches": List[ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef]},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientCreateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef",
    {
        "ConditionalSplit": ClientCreateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientCreateJourneyWriteJourneyRequestActivitiesEMAILTypeDef,
        "Holdout": ClientCreateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef,
        "MultiCondition": ClientCreateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientCreateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef,
        "Wait": ClientCreateJourneyWriteJourneyRequestActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef(
    _ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestLimitsTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestLimitsTypeDef(
    _ClientCreateJourneyWriteJourneyRequestLimitsTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef(
    _ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestScheduleTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestScheduleTypeDef(
    _ClientCreateJourneyWriteJourneyRequestScheduleTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientCreateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef(
    _ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef
):
    pass


_ClientCreateJourneyWriteJourneyRequestTypeDef = TypedDict(
    "_ClientCreateJourneyWriteJourneyRequestTypeDef",
    {
        "Activities": Dict[str, ClientCreateJourneyWriteJourneyRequestActivitiesTypeDef],
        "CreationDate": str,
        "LastModifiedDate": str,
        "Limits": ClientCreateJourneyWriteJourneyRequestLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientCreateJourneyWriteJourneyRequestQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientCreateJourneyWriteJourneyRequestScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientCreateJourneyWriteJourneyRequestStartConditionTypeDef,
        "State": Literal["DRAFT", "ACTIVE", "COMPLETED", "CANCELLED", "CLOSED"],
    },
    total=False,
)


class ClientCreateJourneyWriteJourneyRequestTypeDef(_ClientCreateJourneyWriteJourneyRequestTypeDef):
    """
    Specifies the configuration and other settings for a journey.
    - **Activities** *(dict) --*

      The configuration and other settings for the activities that comprise the journey.
      - *(string) --*

        - *(dict) --*

          Specifies the configuration and other settings for an activity in a journey.
          - **ConditionalSplit** *(dict) --*

            The settings for a yes/no split activity. This type of activity sends participants down
            one of two paths in a journey, based on conditions that you specify.
            - **Condition** *(dict) --*

              The conditions that define the paths for the activity, and the relationship between
              the conditions.
              - **Conditions** *(list) --*

                The conditions to evaluate for the activity.
                - *(dict) --*

                  Specifies a condition to evaluate for an activity in a journey.
                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.
                    - **Dimensions** *(dict) --***[REQUIRED]**

                      The dimensions for the event filter to use for the activity.
                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.
                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.
                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.
    """


_ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef
):
    """
    - **ADM** *(dict) --*

      The message template to use for the ADM (Amazon Device Messaging) channel. This message
      template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).
      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:
        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.
        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.
        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.
    """


_ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "MediaUrl": str,
        "RawContent": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef
):
    pass


_ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef
):
    pass


_ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef
):
    pass


_ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef
):
    pass


_ClientCreatePushTemplatePushNotificationTemplateRequestTypeDef = TypedDict(
    "_ClientCreatePushTemplatePushNotificationTemplateRequestTypeDef",
    {
        "ADM": ClientCreatePushTemplatePushNotificationTemplateRequestADMTypeDef,
        "APNS": ClientCreatePushTemplatePushNotificationTemplateRequestAPNSTypeDef,
        "Baidu": ClientCreatePushTemplatePushNotificationTemplateRequestBaiduTypeDef,
        "Default": ClientCreatePushTemplatePushNotificationTemplateRequestDefaultTypeDef,
        "DefaultSubstitutions": str,
        "GCM": ClientCreatePushTemplatePushNotificationTemplateRequestGCMTypeDef,
        "tags": Dict[str, str],
        "TemplateDescription": str,
    },
    total=False,
)


class ClientCreatePushTemplatePushNotificationTemplateRequestTypeDef(
    _ClientCreatePushTemplatePushNotificationTemplateRequestTypeDef
):
    """
    Creates a message template that you can use in messages that are sent through a push
    notification channel.
    - **ADM** *(dict) --*

      The message template to use for the ADM (Amazon Device Messaging) channel. This message
      template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).
      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:
        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.
        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.
        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.
    """


_ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef = TypedDict(
    "_ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef",
    {"Arn": str, "Message": str, "RequestID": str},
    total=False,
)


class ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef(
    _ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef
):
    """
    - **CreateTemplateMessageBody** *(dict) --*

      Provides information about a request to create a message template.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template that was created.
    """


_ClientCreatePushTemplateResponseTypeDef = TypedDict(
    "_ClientCreatePushTemplateResponseTypeDef",
    {"CreateTemplateMessageBody": ClientCreatePushTemplateResponseCreateTemplateMessageBodyTypeDef},
    total=False,
)


class ClientCreatePushTemplateResponseTypeDef(_ClientCreatePushTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded and the specified resource was created.
      - **CreateTemplateMessageBody** *(dict) --*

        Provides information about a request to create a message template.
        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the message template that was created.
    """


_ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    {"Recency": ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    {
        "Country": ClientCreateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientCreateSegmentResponseSegmentResponseDimensionsAttributesTypeDef
        ],
        "Behavior": ClientCreateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateSegmentResponseSegmentResponseDimensionsDemographicTypeDef,
        "Location": ClientCreateSegmentResponseSegmentResponseDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientCreateSegmentResponseSegmentResponseDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientCreateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef(
    _ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": Literal["ALL", "ANY", "NONE"],
        "Type": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    {
        "Groups": List[ClientCreateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef],
        "Include": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef(
    _ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef
):
    pass


_ClientCreateSegmentResponseSegmentResponseTypeDef = TypedDict(
    "_ClientCreateSegmentResponseSegmentResponseTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientCreateSegmentResponseSegmentResponseDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientCreateSegmentResponseSegmentResponseImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientCreateSegmentResponseSegmentResponseSegmentGroupsTypeDef,
        "SegmentType": Literal["DIMENSIONAL", "IMPORT"],
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientCreateSegmentResponseSegmentResponseTypeDef(
    _ClientCreateSegmentResponseSegmentResponseTypeDef
):
    """
    - **SegmentResponse** *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.
    """


_ClientCreateSegmentResponseTypeDef = TypedDict(
    "_ClientCreateSegmentResponseTypeDef",
    {"SegmentResponse": ClientCreateSegmentResponseSegmentResponseTypeDef},
    total=False,
)


class ClientCreateSegmentResponseTypeDef(_ClientCreateSegmentResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded and the specified resource was created.
      - **SegmentResponse** *(dict) --*

        Provides information about the configuration, dimension, and other settings for a segment.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the segment is associated with.
    """


_ClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef",
    {"Recency": ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef",
    {
        "Country": ClientCreateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef",
    {
        "Attributes": Dict[str, ClientCreateSegmentWriteSegmentRequestDimensionsAttributesTypeDef],
        "Behavior": ClientCreateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateSegmentWriteSegmentRequestDimensionsDemographicTypeDef,
        "Location": ClientCreateSegmentWriteSegmentRequestDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientCreateSegmentWriteSegmentRequestDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientCreateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef
):
    """
    - **Dimensions** *(dict) --*

      The criteria that define the dimensions for the segment.
      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.
        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.
            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.
    """


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str, ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef
        ],
        "UserAttributes": Dict[
            str,
            ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": Literal["ALL", "ANY", "NONE"],
        "Type": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef",
    {
        "Groups": List[ClientCreateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef],
        "Include": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef(
    _ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef
):
    pass


_ClientCreateSegmentWriteSegmentRequestTypeDef = TypedDict(
    "_ClientCreateSegmentWriteSegmentRequestTypeDef",
    {
        "Dimensions": ClientCreateSegmentWriteSegmentRequestDimensionsTypeDef,
        "Name": str,
        "SegmentGroups": ClientCreateSegmentWriteSegmentRequestSegmentGroupsTypeDef,
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientCreateSegmentWriteSegmentRequestTypeDef(_ClientCreateSegmentWriteSegmentRequestTypeDef):
    """
    Specifies the configuration, dimension, and other settings for a segment. A WriteSegmentRequest
    object can include a Dimensions object or a SegmentGroups object, but not both.
    - **Dimensions** *(dict) --*

      The criteria that define the dimensions for the segment.
      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.
        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.
            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.
    """


_ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef = TypedDict(
    "_ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef",
    {"Arn": str, "Message": str, "RequestID": str},
    total=False,
)


class ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef(
    _ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef
):
    """
    - **CreateTemplateMessageBody** *(dict) --*

      Provides information about a request to create a message template.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template that was created.
    """


_ClientCreateSmsTemplateResponseTypeDef = TypedDict(
    "_ClientCreateSmsTemplateResponseTypeDef",
    {"CreateTemplateMessageBody": ClientCreateSmsTemplateResponseCreateTemplateMessageBodyTypeDef},
    total=False,
)


class ClientCreateSmsTemplateResponseTypeDef(_ClientCreateSmsTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded and the specified resource was created.
      - **CreateTemplateMessageBody** *(dict) --*

        Provides information about a request to create a message template.
        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the message template that was created.
    """


_ClientCreateSmsTemplateSMSTemplateRequestTypeDef = TypedDict(
    "_ClientCreateSmsTemplateSMSTemplateRequestTypeDef",
    {"Body": str, "DefaultSubstitutions": str, "tags": Dict[str, str], "TemplateDescription": str},
    total=False,
)


class ClientCreateSmsTemplateSMSTemplateRequestTypeDef(
    _ClientCreateSmsTemplateSMSTemplateRequestTypeDef
):
    """
    Creates a message template that you can use in messages that are sent through the SMS channel.
    - **Body** *(string) --*

      The message body to use in text messages that are based on the message template.
    """


_ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef = TypedDict(
    "_ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef",
    {"Arn": str, "Message": str, "RequestID": str},
    total=False,
)


class ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef(
    _ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef
):
    """
    - **CreateTemplateMessageBody** *(dict) --*

      Provides information about a request to create a message template.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template that was created.
    """


_ClientCreateVoiceTemplateResponseTypeDef = TypedDict(
    "_ClientCreateVoiceTemplateResponseTypeDef",
    {
        "CreateTemplateMessageBody": ClientCreateVoiceTemplateResponseCreateTemplateMessageBodyTypeDef
    },
    total=False,
)


class ClientCreateVoiceTemplateResponseTypeDef(_ClientCreateVoiceTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded and the specified resource was created.
      - **CreateTemplateMessageBody** *(dict) --*

        Provides information about a request to create a message template.
        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the message template that was created.
    """


_ClientCreateVoiceTemplateVoiceTemplateRequestTypeDef = TypedDict(
    "_ClientCreateVoiceTemplateVoiceTemplateRequestTypeDef",
    {
        "Body": str,
        "DefaultSubstitutions": str,
        "LanguageCode": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "VoiceId": str,
    },
    total=False,
)


class ClientCreateVoiceTemplateVoiceTemplateRequestTypeDef(
    _ClientCreateVoiceTemplateVoiceTemplateRequestTypeDef
):
    """
    Specifies the content and settings for a message template that can be used in messages that are
    sent through the voice channel.
    - **Body** *(string) --*

      The text of the script to use in messages that are based on the message template, in plain
      text format.
    """


_ClientDeleteAdmChannelResponseADMChannelResponseTypeDef = TypedDict(
    "_ClientDeleteAdmChannelResponseADMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteAdmChannelResponseADMChannelResponseTypeDef(
    _ClientDeleteAdmChannelResponseADMChannelResponseTypeDef
):
    """
    - **ADMChannelResponse** *(dict) --*

      Provides information about the status and settings of the ADM (Amazon Device Messaging)
      channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the ADM channel applies to.
    """


_ClientDeleteAdmChannelResponseTypeDef = TypedDict(
    "_ClientDeleteAdmChannelResponseTypeDef",
    {"ADMChannelResponse": ClientDeleteAdmChannelResponseADMChannelResponseTypeDef},
    total=False,
)


class ClientDeleteAdmChannelResponseTypeDef(_ClientDeleteAdmChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ADMChannelResponse** *(dict) --*

        Provides information about the status and settings of the ADM (Amazon Device Messaging)
        channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the ADM channel applies to.
    """


_ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef(
    _ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef
):
    """
    - **APNSChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs channel applies to.
    """


_ClientDeleteApnsChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsChannelResponseTypeDef",
    {"APNSChannelResponse": ClientDeleteApnsChannelResponseAPNSChannelResponseTypeDef},
    total=False,
)


class ClientDeleteApnsChannelResponseTypeDef(_ClientDeleteApnsChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs channel applies to.
    """


_ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef(
    _ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
):
    """
    - **APNSSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) sandbox channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs sandbox channel applies to.
    """


_ClientDeleteApnsSandboxChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsSandboxChannelResponseTypeDef",
    {
        "APNSSandboxChannelResponse": ClientDeleteApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientDeleteApnsSandboxChannelResponseTypeDef(_ClientDeleteApnsSandboxChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSSandboxChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) sandbox channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs sandbox channel applies to.
    """


_ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef(
    _ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef
):
    """
    - **APNSVoipChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP channel applies to.
    """


_ClientDeleteApnsVoipChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsVoipChannelResponseTypeDef",
    {"APNSVoipChannelResponse": ClientDeleteApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef},
    total=False,
)


class ClientDeleteApnsVoipChannelResponseTypeDef(_ClientDeleteApnsVoipChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSVoipChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) VoIP channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs VoIP channel applies to.
    """


_ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef(
    _ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
):
    """
    - **APNSVoipSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP sandbox channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP sandbox channel applies to.
    """


_ClientDeleteApnsVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientDeleteApnsVoipSandboxChannelResponseTypeDef",
    {
        "APNSVoipSandboxChannelResponse": ClientDeleteApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientDeleteApnsVoipSandboxChannelResponseTypeDef(
    _ClientDeleteApnsVoipSandboxChannelResponseTypeDef
):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSVoipSandboxChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) VoIP sandbox channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs VoIP sandbox channel applies to.
    """


_ClientDeleteAppResponseApplicationResponseTypeDef = TypedDict(
    "_ClientDeleteAppResponseApplicationResponseTypeDef",
    {"Arn": str, "Id": str, "Name": str, "tags": Dict[str, str]},
    total=False,
)


class ClientDeleteAppResponseApplicationResponseTypeDef(
    _ClientDeleteAppResponseApplicationResponseTypeDef
):
    """
    - **ApplicationResponse** *(dict) --*

      Provides information about an application.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the application.
    """


_ClientDeleteAppResponseTypeDef = TypedDict(
    "_ClientDeleteAppResponseTypeDef",
    {"ApplicationResponse": ClientDeleteAppResponseApplicationResponseTypeDef},
    total=False,
)


class ClientDeleteAppResponseTypeDef(_ClientDeleteAppResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ApplicationResponse** *(dict) --*

        Provides information about an application.
        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the application.
    """


_ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef = TypedDict(
    "_ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef(
    _ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef
):
    """
    - **BaiduChannelResponse** *(dict) --*

      Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel for
      an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the Baidu channel applies to.
    """


_ClientDeleteBaiduChannelResponseTypeDef = TypedDict(
    "_ClientDeleteBaiduChannelResponseTypeDef",
    {"BaiduChannelResponse": ClientDeleteBaiduChannelResponseBaiduChannelResponseTypeDef},
    total=False,
)


class ClientDeleteBaiduChannelResponseTypeDef(_ClientDeleteBaiduChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **BaiduChannelResponse** *(dict) --*

        Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel
        for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the Baidu channel applies to.
    """


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
):
    """
    - *(dict) --*

      Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
      that's used for A/B testing of a campaign.
      - **Id** *(string) --*

        The unique identifier for the treatment.
    """


_ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseHookTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseHookTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseHookTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientDeleteCampaignResponseCampaignResponseScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientDeleteCampaignResponseCampaignResponseScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseStateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseStateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseStateTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef
):
    pass


_ClientDeleteCampaignResponseCampaignResponseTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseCampaignResponseTypeDef",
    {
        "AdditionalTreatments": List[
            ClientDeleteCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientDeleteCampaignResponseCampaignResponseDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientDeleteCampaignResponseCampaignResponseHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientDeleteCampaignResponseCampaignResponseLimitsTypeDef,
        "MessageConfiguration": ClientDeleteCampaignResponseCampaignResponseMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientDeleteCampaignResponseCampaignResponseScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientDeleteCampaignResponseCampaignResponseStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientDeleteCampaignResponseCampaignResponseTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteCampaignResponseCampaignResponseTypeDef(
    _ClientDeleteCampaignResponseCampaignResponseTypeDef
):
    """
    - **CampaignResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.
      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.
        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.
          - **Id** *(string) --*

            The unique identifier for the treatment.
    """


_ClientDeleteCampaignResponseTypeDef = TypedDict(
    "_ClientDeleteCampaignResponseTypeDef",
    {"CampaignResponse": ClientDeleteCampaignResponseCampaignResponseTypeDef},
    total=False,
)


class ClientDeleteCampaignResponseTypeDef(_ClientDeleteCampaignResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **CampaignResponse** *(dict) --*

        Provides information about the status, configuration, and other settings for a campaign.
        - **AdditionalTreatments** *(list) --*

          An array of responses, one for each treatment that you defined for the campaign, in
          addition to the default treatment.
          - *(dict) --*

            Specifies the settings for a campaign treatment. A treatment is a variation of a
            campaign that's used for A/B testing of a campaign.
            - **Id** *(string) --*

              The unique identifier for the treatment.
    """


_ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef = TypedDict(
    "_ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "ConfigurationSet": str,
        "CreationDate": str,
        "Enabled": bool,
        "FromAddress": str,
        "HasCredential": bool,
        "Id": str,
        "Identity": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "MessagesPerSecond": int,
        "Platform": str,
        "RoleArn": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef(
    _ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef
):
    """
    - **EmailChannelResponse** *(dict) --*

      Provides information about the status and settings of the email channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the email channel applies to.
    """


_ClientDeleteEmailChannelResponseTypeDef = TypedDict(
    "_ClientDeleteEmailChannelResponseTypeDef",
    {"EmailChannelResponse": ClientDeleteEmailChannelResponseEmailChannelResponseTypeDef},
    total=False,
)


class ClientDeleteEmailChannelResponseTypeDef(_ClientDeleteEmailChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **EmailChannelResponse** *(dict) --*

        Provides information about the status and settings of the email channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the email channel applies to.
    """


_ClientDeleteEmailTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientDeleteEmailTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientDeleteEmailTemplateResponseMessageBodyTypeDef(
    _ClientDeleteEmailTemplateResponseMessageBodyTypeDef
):
    """
    - **MessageBody** *(dict) --*

      Provides information about an API request or response.
      - **Message** *(string) --*

        The message that's returned from the API.
    """


_ClientDeleteEmailTemplateResponseTypeDef = TypedDict(
    "_ClientDeleteEmailTemplateResponseTypeDef",
    {"MessageBody": ClientDeleteEmailTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientDeleteEmailTemplateResponseTypeDef(_ClientDeleteEmailTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **MessageBody** *(dict) --*

        Provides information about an API request or response.
        - **Message** *(string) --*

          The message that's returned from the API.
    """


_ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef = TypedDict(
    "_ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef(
    _ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef
):
    pass


_ClientDeleteEndpointResponseEndpointResponseLocationTypeDef = TypedDict(
    "_ClientDeleteEndpointResponseEndpointResponseLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientDeleteEndpointResponseEndpointResponseLocationTypeDef(
    _ClientDeleteEndpointResponseEndpointResponseLocationTypeDef
):
    pass


_ClientDeleteEndpointResponseEndpointResponseUserTypeDef = TypedDict(
    "_ClientDeleteEndpointResponseEndpointResponseUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientDeleteEndpointResponseEndpointResponseUserTypeDef(
    _ClientDeleteEndpointResponseEndpointResponseUserTypeDef
):
    pass


_ClientDeleteEndpointResponseEndpointResponseTypeDef = TypedDict(
    "_ClientDeleteEndpointResponseEndpointResponseTypeDef",
    {
        "Address": str,
        "ApplicationId": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": Literal[
            "GCM",
            "APNS",
            "APNS_SANDBOX",
            "APNS_VOIP",
            "APNS_VOIP_SANDBOX",
            "ADM",
            "SMS",
            "VOICE",
            "EMAIL",
            "BAIDU",
            "CUSTOM",
        ],
        "CohortId": str,
        "CreationDate": str,
        "Demographic": ClientDeleteEndpointResponseEndpointResponseDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Id": str,
        "Location": ClientDeleteEndpointResponseEndpointResponseLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientDeleteEndpointResponseEndpointResponseUserTypeDef,
    },
    total=False,
)


class ClientDeleteEndpointResponseEndpointResponseTypeDef(
    _ClientDeleteEndpointResponseEndpointResponseTypeDef
):
    """
    - **EndpointResponse** *(dict) --*

      Provides information about the channel type and other settings for an endpoint.
      - **Address** *(string) --*

        The destination address for messages or push notifications that you send to the endpoint.
        The address varies by channel. For example, the address for a push-notification channel is
        typically the token provided by a push notification service, such as an Apple Push
        Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
        token. The address for the SMS channel is a phone number in E.164 format, such as
        +12065550100. The address for the email channel is an email address.
    """


_ClientDeleteEndpointResponseTypeDef = TypedDict(
    "_ClientDeleteEndpointResponseTypeDef",
    {"EndpointResponse": ClientDeleteEndpointResponseEndpointResponseTypeDef},
    total=False,
)


class ClientDeleteEndpointResponseTypeDef(_ClientDeleteEndpointResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **EndpointResponse** *(dict) --*

        Provides information about the channel type and other settings for an endpoint.
        - **Address** *(string) --*

          The destination address for messages or push notifications that you send to the endpoint.
          The address varies by channel. For example, the address for a push-notification channel is
          typically the token provided by a push notification service, such as an Apple Push
          Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
          token. The address for the SMS channel is a phone number in E.164 format, such as
          +12065550100. The address for the email channel is an email address.
    """


_ClientDeleteEventStreamResponseEventStreamTypeDef = TypedDict(
    "_ClientDeleteEventStreamResponseEventStreamTypeDef",
    {
        "ApplicationId": str,
        "DestinationStreamArn": str,
        "ExternalId": str,
        "LastModifiedDate": str,
        "LastUpdatedBy": str,
        "RoleArn": str,
    },
    total=False,
)


class ClientDeleteEventStreamResponseEventStreamTypeDef(
    _ClientDeleteEventStreamResponseEventStreamTypeDef
):
    """
    - **EventStream** *(dict) --*

      Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
      Kinesis Data Firehose delivery stream.
      - **ApplicationId** *(string) --*

        The unique identifier for the application to publish event data for.
    """


_ClientDeleteEventStreamResponseTypeDef = TypedDict(
    "_ClientDeleteEventStreamResponseTypeDef",
    {"EventStream": ClientDeleteEventStreamResponseEventStreamTypeDef},
    total=False,
)


class ClientDeleteEventStreamResponseTypeDef(_ClientDeleteEventStreamResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **EventStream** *(dict) --*

        Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
        Kinesis Data Firehose delivery stream.
        - **ApplicationId** *(string) --*

          The unique identifier for the application to publish event data for.
    """


_ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef = TypedDict(
    "_ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef(
    _ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef
):
    """
    - **GCMChannelResponse** *(dict) --*

      Provides information about the status and settings of the GCM channel for an application. The
      GCM channel enables Amazon Pinpoint to send push notifications through the Firebase Cloud
      Messaging (FCM), formerly Google Cloud Messaging (GCM), service.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the GCM channel applies to.
    """


_ClientDeleteGcmChannelResponseTypeDef = TypedDict(
    "_ClientDeleteGcmChannelResponseTypeDef",
    {"GCMChannelResponse": ClientDeleteGcmChannelResponseGCMChannelResponseTypeDef},
    total=False,
)


class ClientDeleteGcmChannelResponseTypeDef(_ClientDeleteGcmChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **GCMChannelResponse** *(dict) --*

        Provides information about the status and settings of the GCM channel for an application.
        The GCM channel enables Amazon Pinpoint to send push notifications through the Firebase
        Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the GCM channel applies to.
    """


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": Literal["ALL", "ANY"],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    {
        "Branches": List[
            ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
        ]
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientDeleteJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef",
    {
        "ConditionalSplit": ClientDeleteJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientDeleteJourneyResponseJourneyResponseActivitiesEMAILTypeDef,
        "Holdout": ClientDeleteJourneyResponseJourneyResponseActivitiesHoldoutTypeDef,
        "MultiCondition": ClientDeleteJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientDeleteJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef,
        "Wait": ClientDeleteJourneyResponseJourneyResponseActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientDeleteJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef
):
    pass


_ClientDeleteJourneyResponseJourneyResponseTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseJourneyResponseTypeDef",
    {
        "Activities": Dict[str, ClientDeleteJourneyResponseJourneyResponseActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientDeleteJourneyResponseJourneyResponseLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientDeleteJourneyResponseJourneyResponseQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientDeleteJourneyResponseJourneyResponseScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientDeleteJourneyResponseJourneyResponseStartConditionTypeDef,
        "State": Literal["DRAFT", "ACTIVE", "COMPLETED", "CANCELLED", "CLOSED"],
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientDeleteJourneyResponseJourneyResponseTypeDef(
    _ClientDeleteJourneyResponseJourneyResponseTypeDef
):
    """
    - **JourneyResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a journey.
      - **Activities** *(dict) --*

        The configuration and other settings for the activities that comprise the journey.
        - *(string) --*

          - *(dict) --*

            Specifies the configuration and other settings for an activity in a journey.
            - **ConditionalSplit** *(dict) --*

              The settings for a yes/no split activity. This type of activity sends participants
              down one of two paths in a journey, based on conditions that you specify.
              - **Condition** *(dict) --*

                The conditions that define the paths for the activity, and the relationship between
                the conditions.
                - **Conditions** *(list) --*

                  The conditions to evaluate for the activity.
                  - *(dict) --*

                    Specifies a condition to evaluate for an activity in a journey.
                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.
                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.
                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.
                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.
                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.
    """


_ClientDeleteJourneyResponseTypeDef = TypedDict(
    "_ClientDeleteJourneyResponseTypeDef",
    {"JourneyResponse": ClientDeleteJourneyResponseJourneyResponseTypeDef},
    total=False,
)


class ClientDeleteJourneyResponseTypeDef(_ClientDeleteJourneyResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **JourneyResponse** *(dict) --*

        Provides information about the status, configuration, and other settings for a journey.
        - **Activities** *(dict) --*

          The configuration and other settings for the activities that comprise the journey.
          - *(string) --*

            - *(dict) --*

              Specifies the configuration and other settings for an activity in a journey.
              - **ConditionalSplit** *(dict) --*

                The settings for a yes/no split activity. This type of activity sends participants
                down one of two paths in a journey, based on conditions that you specify.
                - **Condition** *(dict) --*

                  The conditions that define the paths for the activity, and the relationship
                  between the conditions.
                  - **Conditions** *(list) --*

                    The conditions to evaluate for the activity.
                    - *(dict) --*

                      Specifies a condition to evaluate for an activity in a journey.
                      - **EventCondition** *(dict) --*

                        The dimension settings for the event that's associated with the activity.
                        - **Dimensions** *(dict) --*

                          The dimensions for the event filter to use for the activity.
                          - **Attributes** *(dict) --*

                            One or more custom attributes that your application reports to Amazon
                            Pinpoint. You can use these attributes as selection criteria when you
                            create an event filter.
                            - *(string) --*

                              - *(dict) --*

                                Specifies attribute-based criteria for including or excluding
                                endpoints from a segment.
                                - **AttributeType** *(string) --*

                                  The type of segment dimension to use. Valid values are: INCLUSIVE,
                                  endpoints that match the criteria are included in the segment;
                                  and, EXCLUSIVE, endpoints that match the criteria are excluded
                                  from the segment.
    """


_ClientDeletePushTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientDeletePushTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientDeletePushTemplateResponseMessageBodyTypeDef(
    _ClientDeletePushTemplateResponseMessageBodyTypeDef
):
    """
    - **MessageBody** *(dict) --*

      Provides information about an API request or response.
      - **Message** *(string) --*

        The message that's returned from the API.
    """


_ClientDeletePushTemplateResponseTypeDef = TypedDict(
    "_ClientDeletePushTemplateResponseTypeDef",
    {"MessageBody": ClientDeletePushTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientDeletePushTemplateResponseTypeDef(_ClientDeletePushTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **MessageBody** *(dict) --*

        Provides information about an API request or response.
        - **Message** *(string) --*

          The message that's returned from the API.
    """


_ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    {"Recency": ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef,
        "Model": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef,
        "Platform": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    {
        "Country": ClientDeleteSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientDeleteSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientDeleteSegmentResponseSegmentResponseDimensionsAttributesTypeDef
        ],
        "Behavior": ClientDeleteSegmentResponseSegmentResponseDimensionsBehaviorTypeDef,
        "Demographic": ClientDeleteSegmentResponseSegmentResponseDimensionsDemographicTypeDef,
        "Location": ClientDeleteSegmentResponseSegmentResponseDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientDeleteSegmentResponseSegmentResponseDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientDeleteSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": Literal["ALL", "ANY", "NONE"],
        "Type": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    {
        "Groups": List[ClientDeleteSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef],
        "Include": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef
):
    pass


_ClientDeleteSegmentResponseSegmentResponseTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseSegmentResponseTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientDeleteSegmentResponseSegmentResponseDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientDeleteSegmentResponseSegmentResponseImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientDeleteSegmentResponseSegmentResponseSegmentGroupsTypeDef,
        "SegmentType": Literal["DIMENSIONAL", "IMPORT"],
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientDeleteSegmentResponseSegmentResponseTypeDef(
    _ClientDeleteSegmentResponseSegmentResponseTypeDef
):
    """
    - **SegmentResponse** *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.
    """


_ClientDeleteSegmentResponseTypeDef = TypedDict(
    "_ClientDeleteSegmentResponseTypeDef",
    {"SegmentResponse": ClientDeleteSegmentResponseSegmentResponseTypeDef},
    total=False,
)


class ClientDeleteSegmentResponseTypeDef(_ClientDeleteSegmentResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **SegmentResponse** *(dict) --*

        Provides information about the configuration, dimension, and other settings for a segment.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the segment is associated with.
    """


_ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef = TypedDict(
    "_ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "PromotionalMessagesPerSecond": int,
        "SenderId": str,
        "ShortCode": str,
        "TransactionalMessagesPerSecond": int,
        "Version": int,
    },
    total=False,
)


class ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef(
    _ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef
):
    """
    - **SMSChannelResponse** *(dict) --*

      Provides information about the status and settings of the SMS channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the SMS channel applies to.
    """


_ClientDeleteSmsChannelResponseTypeDef = TypedDict(
    "_ClientDeleteSmsChannelResponseTypeDef",
    {"SMSChannelResponse": ClientDeleteSmsChannelResponseSMSChannelResponseTypeDef},
    total=False,
)


class ClientDeleteSmsChannelResponseTypeDef(_ClientDeleteSmsChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **SMSChannelResponse** *(dict) --*

        Provides information about the status and settings of the SMS channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the SMS channel applies to.
    """


_ClientDeleteSmsTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientDeleteSmsTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientDeleteSmsTemplateResponseMessageBodyTypeDef(
    _ClientDeleteSmsTemplateResponseMessageBodyTypeDef
):
    """
    - **MessageBody** *(dict) --*

      Provides information about an API request or response.
      - **Message** *(string) --*

        The message that's returned from the API.
    """


_ClientDeleteSmsTemplateResponseTypeDef = TypedDict(
    "_ClientDeleteSmsTemplateResponseTypeDef",
    {"MessageBody": ClientDeleteSmsTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientDeleteSmsTemplateResponseTypeDef(_ClientDeleteSmsTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **MessageBody** *(dict) --*

        Provides information about an API request or response.
        - **Message** *(string) --*

          The message that's returned from the API.
    """


_ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef(
    _ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef
):
    pass


_ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef(
    _ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef
):
    pass


_ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef(
    _ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef
):
    pass


_ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef",
    {
        "Address": str,
        "ApplicationId": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": Literal[
            "GCM",
            "APNS",
            "APNS_SANDBOX",
            "APNS_VOIP",
            "APNS_VOIP_SANDBOX",
            "ADM",
            "SMS",
            "VOICE",
            "EMAIL",
            "BAIDU",
            "CUSTOM",
        ],
        "CohortId": str,
        "CreationDate": str,
        "Demographic": ClientDeleteUserEndpointsResponseEndpointsResponseItemDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Id": str,
        "Location": ClientDeleteUserEndpointsResponseEndpointsResponseItemLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientDeleteUserEndpointsResponseEndpointsResponseItemUserTypeDef,
    },
    total=False,
)


class ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef(
    _ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about the channel type and other settings for an endpoint.
      - **Address** *(string) --*

        The destination address for messages or push notifications that you send to the endpoint.
        The address varies by channel. For example, the address for a push-notification channel is
        typically the token provided by a push notification service, such as an Apple Push
        Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
        token. The address for the SMS channel is a phone number in E.164 format, such as
        +12065550100. The address for the email channel is an email address.
    """


_ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef",
    {"Item": List[ClientDeleteUserEndpointsResponseEndpointsResponseItemTypeDef]},
    total=False,
)


class ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef(
    _ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef
):
    """
    - **EndpointsResponse** *(dict) --*

      Provides information about all the endpoints that are associated with a user ID.
      - **Item** *(list) --*

        An array of responses, one for each endpoint that's associated with the user ID.
        - *(dict) --*

          Provides information about the channel type and other settings for an endpoint.
          - **Address** *(string) --*

            The destination address for messages or push notifications that you send to the
            endpoint. The address varies by channel. For example, the address for a
            push-notification channel is typically the token provided by a push notification
            service, such as an Apple Push Notification service (APNs) device token or a Firebase
            Cloud Messaging (FCM) registration token. The address for the SMS channel is a phone
            number in E.164 format, such as +12065550100. The address for the email channel is an
            email address.
    """


_ClientDeleteUserEndpointsResponseTypeDef = TypedDict(
    "_ClientDeleteUserEndpointsResponseTypeDef",
    {"EndpointsResponse": ClientDeleteUserEndpointsResponseEndpointsResponseTypeDef},
    total=False,
)


class ClientDeleteUserEndpointsResponseTypeDef(_ClientDeleteUserEndpointsResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **EndpointsResponse** *(dict) --*

        Provides information about all the endpoints that are associated with a user ID.
        - **Item** *(list) --*

          An array of responses, one for each endpoint that's associated with the user ID.
          - *(dict) --*

            Provides information about the channel type and other settings for an endpoint.
            - **Address** *(string) --*

              The destination address for messages or push notifications that you send to the
              endpoint. The address varies by channel. For example, the address for a
              push-notification channel is typically the token provided by a push notification
              service, such as an Apple Push Notification service (APNs) device token or a Firebase
              Cloud Messaging (FCM) registration token. The address for the SMS channel is a phone
              number in E.164 format, such as +12065550100. The address for the email channel is an
              email address.
    """


_ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef = TypedDict(
    "_ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef(
    _ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef
):
    """
    - **VoiceChannelResponse** *(dict) --*

      Provides information about the status and settings of the voice channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the voice channel applies to.
    """


_ClientDeleteVoiceChannelResponseTypeDef = TypedDict(
    "_ClientDeleteVoiceChannelResponseTypeDef",
    {"VoiceChannelResponse": ClientDeleteVoiceChannelResponseVoiceChannelResponseTypeDef},
    total=False,
)


class ClientDeleteVoiceChannelResponseTypeDef(_ClientDeleteVoiceChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **VoiceChannelResponse** *(dict) --*

        Provides information about the status and settings of the voice channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the voice channel applies to.
    """


_ClientDeleteVoiceTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientDeleteVoiceTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientDeleteVoiceTemplateResponseMessageBodyTypeDef(
    _ClientDeleteVoiceTemplateResponseMessageBodyTypeDef
):
    """
    - **MessageBody** *(dict) --*

      Provides information about an API request or response.
      - **Message** *(string) --*

        The message that's returned from the API.
    """


_ClientDeleteVoiceTemplateResponseTypeDef = TypedDict(
    "_ClientDeleteVoiceTemplateResponseTypeDef",
    {"MessageBody": ClientDeleteVoiceTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientDeleteVoiceTemplateResponseTypeDef(_ClientDeleteVoiceTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **MessageBody** *(dict) --*

        Provides information about an API request or response.
        - **Message** *(string) --*

          The message that's returned from the API.
    """


_ClientGetAdmChannelResponseADMChannelResponseTypeDef = TypedDict(
    "_ClientGetAdmChannelResponseADMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetAdmChannelResponseADMChannelResponseTypeDef(
    _ClientGetAdmChannelResponseADMChannelResponseTypeDef
):
    """
    - **ADMChannelResponse** *(dict) --*

      Provides information about the status and settings of the ADM (Amazon Device Messaging)
      channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the ADM channel applies to.
    """


_ClientGetAdmChannelResponseTypeDef = TypedDict(
    "_ClientGetAdmChannelResponseTypeDef",
    {"ADMChannelResponse": ClientGetAdmChannelResponseADMChannelResponseTypeDef},
    total=False,
)


class ClientGetAdmChannelResponseTypeDef(_ClientGetAdmChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ADMChannelResponse** *(dict) --*

        Provides information about the status and settings of the ADM (Amazon Device Messaging)
        channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the ADM channel applies to.
    """


_ClientGetApnsChannelResponseAPNSChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsChannelResponseAPNSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetApnsChannelResponseAPNSChannelResponseTypeDef(
    _ClientGetApnsChannelResponseAPNSChannelResponseTypeDef
):
    """
    - **APNSChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs channel applies to.
    """


_ClientGetApnsChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsChannelResponseTypeDef",
    {"APNSChannelResponse": ClientGetApnsChannelResponseAPNSChannelResponseTypeDef},
    total=False,
)


class ClientGetApnsChannelResponseTypeDef(_ClientGetApnsChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs channel applies to.
    """


_ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef(
    _ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
):
    """
    - **APNSSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) sandbox channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs sandbox channel applies to.
    """


_ClientGetApnsSandboxChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsSandboxChannelResponseTypeDef",
    {
        "APNSSandboxChannelResponse": ClientGetApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientGetApnsSandboxChannelResponseTypeDef(_ClientGetApnsSandboxChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSSandboxChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) sandbox channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs sandbox channel applies to.
    """


_ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef(
    _ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef
):
    """
    - **APNSVoipChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP channel applies to.
    """


_ClientGetApnsVoipChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsVoipChannelResponseTypeDef",
    {"APNSVoipChannelResponse": ClientGetApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef},
    total=False,
)


class ClientGetApnsVoipChannelResponseTypeDef(_ClientGetApnsVoipChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSVoipChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) VoIP channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs VoIP channel applies to.
    """


_ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef(
    _ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
):
    """
    - **APNSVoipSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP sandbox channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP sandbox channel applies to.
    """


_ClientGetApnsVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientGetApnsVoipSandboxChannelResponseTypeDef",
    {
        "APNSVoipSandboxChannelResponse": ClientGetApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientGetApnsVoipSandboxChannelResponseTypeDef(
    _ClientGetApnsVoipSandboxChannelResponseTypeDef
):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSVoipSandboxChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) VoIP sandbox channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs VoIP sandbox channel applies to.
    """


_ClientGetAppResponseApplicationResponseTypeDef = TypedDict(
    "_ClientGetAppResponseApplicationResponseTypeDef",
    {"Arn": str, "Id": str, "Name": str, "tags": Dict[str, str]},
    total=False,
)


class ClientGetAppResponseApplicationResponseTypeDef(
    _ClientGetAppResponseApplicationResponseTypeDef
):
    """
    - **ApplicationResponse** *(dict) --*

      Provides information about an application.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the application.
    """


_ClientGetAppResponseTypeDef = TypedDict(
    "_ClientGetAppResponseTypeDef",
    {"ApplicationResponse": ClientGetAppResponseApplicationResponseTypeDef},
    total=False,
)


class ClientGetAppResponseTypeDef(_ClientGetAppResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ApplicationResponse** *(dict) --*

        Provides information about an application.
        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the application.
    """


_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef(
    _ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
):
    pass


_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef(
    _ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef
):
    pass


_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef",
    {
        "GroupedBys": List[
            ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
        ],
        "Values": List[
            ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsValuesTypeDef
        ],
    },
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef(
    _ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef
):
    pass


_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef",
    {
        "Rows": List[
            ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultRowsTypeDef
        ]
    },
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef(
    _ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef
):
    pass


_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef",
    {
        "ApplicationId": str,
        "EndTime": datetime,
        "KpiName": str,
        "KpiResult": ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseKpiResultTypeDef,
        "NextToken": str,
        "StartTime": datetime,
    },
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef(
    _ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef
):
    """
    - **ApplicationDateRangeKpiResponse** *(dict) --*

      Provides the results of a query that retrieved the data for a standard metric that applies to
      an application, and provides information about that query.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the metric applies to.
    """


_ClientGetApplicationDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetApplicationDateRangeKpiResponseTypeDef",
    {
        "ApplicationDateRangeKpiResponse": ClientGetApplicationDateRangeKpiResponseApplicationDateRangeKpiResponseTypeDef
    },
    total=False,
)


class ClientGetApplicationDateRangeKpiResponseTypeDef(
    _ClientGetApplicationDateRangeKpiResponseTypeDef
):
    """
    - *(dict) --*

      The request succeeded.
      - **ApplicationDateRangeKpiResponse** *(dict) --*

        Provides the results of a query that retrieved the data for a standard metric that applies
        to an application, and provides information about that query.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the metric applies to.
    """


_ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef = TypedDict(
    "_ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef(
    _ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef
):
    pass


_ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef = TypedDict(
    "_ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef(
    _ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef
):
    pass


_ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef = TypedDict(
    "_ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef(
    _ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef
):
    pass


_ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef = TypedDict(
    "_ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef",
    {
        "ApplicationId": str,
        "CampaignHook": ClientGetApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef,
        "LastModifiedDate": str,
        "Limits": ClientGetApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef,
        "QuietTime": ClientGetApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef,
    },
    total=False,
)


class ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef(
    _ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef
):
    """
    - **ApplicationSettingsResource** *(dict) --*

      Provides information about an application, including the default settings for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application. This identifier is displayed as the **Project
        ID** on the Amazon Pinpoint console.
    """


_ClientGetApplicationSettingsResponseTypeDef = TypedDict(
    "_ClientGetApplicationSettingsResponseTypeDef",
    {
        "ApplicationSettingsResource": ClientGetApplicationSettingsResponseApplicationSettingsResourceTypeDef
    },
    total=False,
)


class ClientGetApplicationSettingsResponseTypeDef(_ClientGetApplicationSettingsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ApplicationSettingsResource** *(dict) --*

        Provides information about an application, including the default settings for an
        application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application. This identifier is displayed as the **Project
          ID** on the Amazon Pinpoint console.
    """


_ClientGetAppsResponseApplicationsResponseItemTypeDef = TypedDict(
    "_ClientGetAppsResponseApplicationsResponseItemTypeDef",
    {"Arn": str, "Id": str, "Name": str, "tags": Dict[str, str]},
    total=False,
)


class ClientGetAppsResponseApplicationsResponseItemTypeDef(
    _ClientGetAppsResponseApplicationsResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about an application.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the application.
    """


_ClientGetAppsResponseApplicationsResponseTypeDef = TypedDict(
    "_ClientGetAppsResponseApplicationsResponseTypeDef",
    {"Item": List[ClientGetAppsResponseApplicationsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetAppsResponseApplicationsResponseTypeDef(
    _ClientGetAppsResponseApplicationsResponseTypeDef
):
    """
    - **ApplicationsResponse** *(dict) --*

      Provides information about all of your applications.
      - **Item** *(list) --*

        An array of responses, one for each application that was returned.
        - *(dict) --*

          Provides information about an application.
          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the application.
    """


_ClientGetAppsResponseTypeDef = TypedDict(
    "_ClientGetAppsResponseTypeDef",
    {"ApplicationsResponse": ClientGetAppsResponseApplicationsResponseTypeDef},
    total=False,
)


class ClientGetAppsResponseTypeDef(_ClientGetAppsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ApplicationsResponse** *(dict) --*

        Provides information about all of your applications.
        - **Item** *(list) --*

          An array of responses, one for each application that was returned.
          - *(dict) --*

            Provides information about an application.
            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the application.
    """


_ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef = TypedDict(
    "_ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef(
    _ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef
):
    """
    - **BaiduChannelResponse** *(dict) --*

      Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel for
      an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the Baidu channel applies to.
    """


_ClientGetBaiduChannelResponseTypeDef = TypedDict(
    "_ClientGetBaiduChannelResponseTypeDef",
    {"BaiduChannelResponse": ClientGetBaiduChannelResponseBaiduChannelResponseTypeDef},
    total=False,
)


class ClientGetBaiduChannelResponseTypeDef(_ClientGetBaiduChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **BaiduChannelResponse** *(dict) --*

        Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel
        for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the Baidu channel applies to.
    """


_ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef = TypedDict(
    "_ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef",
    {
        "ApplicationId": str,
        "CampaignId": str,
        "End": str,
        "Id": str,
        "Result": str,
        "ScheduledStart": str,
        "Start": str,
        "State": str,
        "SuccessfulEndpointCount": int,
        "TimezonesCompletedCount": int,
        "TimezonesTotalCount": int,
        "TotalEndpointCount": int,
        "TreatmentId": str,
    },
    total=False,
)


class ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef(
    _ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about an activity that was performed by a campaign.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the campaign applies to.
    """


_ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef = TypedDict(
    "_ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef",
    {
        "Item": List[ClientGetCampaignActivitiesResponseActivitiesResponseItemTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef(
    _ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef
):
    """
    - **ActivitiesResponse** *(dict) --*

      Provides information about the activities that were performed by a campaign.
      - **Item** *(list) --*

        An array of responses, one for each activity that was performed by the campaign.
        - *(dict) --*

          Provides information about an activity that was performed by a campaign.
          - **ApplicationId** *(string) --*

            The unique identifier for the application that the campaign applies to.
    """


_ClientGetCampaignActivitiesResponseTypeDef = TypedDict(
    "_ClientGetCampaignActivitiesResponseTypeDef",
    {"ActivitiesResponse": ClientGetCampaignActivitiesResponseActivitiesResponseTypeDef},
    total=False,
)


class ClientGetCampaignActivitiesResponseTypeDef(_ClientGetCampaignActivitiesResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ActivitiesResponse** *(dict) --*

        Provides information about the activities that were performed by a campaign.
        - **Item** *(list) --*

          An array of responses, one for each activity that was performed by the campaign.
          - *(dict) --*

            Provides information about an activity that was performed by a campaign.
            - **ApplicationId** *(string) --*

              The unique identifier for the application that the campaign applies to.
    """


_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef(
    _ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
):
    pass


_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef(
    _ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef
):
    pass


_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef",
    {
        "GroupedBys": List[
            ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
        ],
        "Values": List[
            ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsValuesTypeDef
        ],
    },
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef(
    _ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef
):
    pass


_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef",
    {
        "Rows": List[
            ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultRowsTypeDef
        ]
    },
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef(
    _ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef
):
    pass


_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef",
    {
        "ApplicationId": str,
        "CampaignId": str,
        "EndTime": datetime,
        "KpiName": str,
        "KpiResult": ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseKpiResultTypeDef,
        "NextToken": str,
        "StartTime": datetime,
    },
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef(
    _ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef
):
    """
    - **CampaignDateRangeKpiResponse** *(dict) --*

      Provides the results of a query that retrieved the data for a standard metric that applies to
      a campaign, and provides information about that query.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the metric applies to.
    """


_ClientGetCampaignDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetCampaignDateRangeKpiResponseTypeDef",
    {
        "CampaignDateRangeKpiResponse": ClientGetCampaignDateRangeKpiResponseCampaignDateRangeKpiResponseTypeDef
    },
    total=False,
)


class ClientGetCampaignDateRangeKpiResponseTypeDef(_ClientGetCampaignDateRangeKpiResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **CampaignDateRangeKpiResponse** *(dict) --*

        Provides the results of a query that retrieved the data for a standard metric that applies
        to a campaign, and provides information about that query.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the metric applies to.
    """


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef(
    _ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
):
    """
    - *(dict) --*

      Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
      that's used for A/B testing of a campaign.
      - **Id** *(string) --*

        The unique identifier for the treatment.
    """


_ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef(
    _ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseHookTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseHookTypeDef(
    _ClientGetCampaignResponseCampaignResponseHookTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseLimitsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseLimitsTypeDef(
    _ClientGetCampaignResponseCampaignResponseLimitsTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef(
    _ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseScheduleTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignResponseCampaignResponseScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignResponseCampaignResponseScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseScheduleTypeDef(
    _ClientGetCampaignResponseCampaignResponseScheduleTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseStateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseStateTypeDef(
    _ClientGetCampaignResponseCampaignResponseStateTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef(
    _ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef
):
    pass


_ClientGetCampaignResponseCampaignResponseTypeDef = TypedDict(
    "_ClientGetCampaignResponseCampaignResponseTypeDef",
    {
        "AdditionalTreatments": List[
            ClientGetCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientGetCampaignResponseCampaignResponseDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientGetCampaignResponseCampaignResponseHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientGetCampaignResponseCampaignResponseLimitsTypeDef,
        "MessageConfiguration": ClientGetCampaignResponseCampaignResponseMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientGetCampaignResponseCampaignResponseScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientGetCampaignResponseCampaignResponseStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientGetCampaignResponseCampaignResponseTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientGetCampaignResponseCampaignResponseTypeDef(
    _ClientGetCampaignResponseCampaignResponseTypeDef
):
    """
    - **CampaignResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.
      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.
        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.
          - **Id** *(string) --*

            The unique identifier for the treatment.
    """


_ClientGetCampaignResponseTypeDef = TypedDict(
    "_ClientGetCampaignResponseTypeDef",
    {"CampaignResponse": ClientGetCampaignResponseCampaignResponseTypeDef},
    total=False,
)


class ClientGetCampaignResponseTypeDef(_ClientGetCampaignResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **CampaignResponse** *(dict) --*

        Provides information about the status, configuration, and other settings for a campaign.
        - **AdditionalTreatments** *(list) --*

          An array of responses, one for each treatment that you defined for the campaign, in
          addition to the default treatment.
          - *(dict) --*

            Specifies the settings for a campaign treatment. A treatment is a variation of a
            campaign that's used for A/B testing of a campaign.
            - **Id** *(string) --*

              The unique identifier for the treatment.
    """


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef
):
    """
    - *(dict) --*

      Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
      that's used for A/B testing of a campaign.
      - **Id** *(string) --*

        The unique identifier for the treatment.
    """


_ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseHookTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseHookTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseHookTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignVersionResponseCampaignResponseScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignVersionResponseCampaignResponseScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseStateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseStateTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef
):
    pass


_ClientGetCampaignVersionResponseCampaignResponseTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseCampaignResponseTypeDef",
    {
        "AdditionalTreatments": List[
            ClientGetCampaignVersionResponseCampaignResponseAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientGetCampaignVersionResponseCampaignResponseDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientGetCampaignVersionResponseCampaignResponseHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientGetCampaignVersionResponseCampaignResponseLimitsTypeDef,
        "MessageConfiguration": ClientGetCampaignVersionResponseCampaignResponseMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientGetCampaignVersionResponseCampaignResponseScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientGetCampaignVersionResponseCampaignResponseStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientGetCampaignVersionResponseCampaignResponseTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientGetCampaignVersionResponseCampaignResponseTypeDef(
    _ClientGetCampaignVersionResponseCampaignResponseTypeDef
):
    """
    - **CampaignResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.
      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.
        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.
          - **Id** *(string) --*

            The unique identifier for the treatment.
    """


_ClientGetCampaignVersionResponseTypeDef = TypedDict(
    "_ClientGetCampaignVersionResponseTypeDef",
    {"CampaignResponse": ClientGetCampaignVersionResponseCampaignResponseTypeDef},
    total=False,
)


class ClientGetCampaignVersionResponseTypeDef(_ClientGetCampaignVersionResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **CampaignResponse** *(dict) --*

        Provides information about the status, configuration, and other settings for a campaign.
        - **AdditionalTreatments** *(list) --*

          An array of responses, one for each treatment that you defined for the campaign, in
          addition to the default treatment.
          - *(dict) --*

            Specifies the settings for a campaign treatment. A treatment is a variation of a
            campaign that's used for A/B testing of a campaign.
            - **Id** *(string) --*

              The unique identifier for the treatment.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef
):
    """
    - *(dict) --*

      Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
      that's used for A/B testing of a campaign.
      - **Id** *(string) --*

        The unique identifier for the treatment.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef
):
    pass


_ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef",
    {
        "AdditionalTreatments": List[
            ClientGetCampaignVersionsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientGetCampaignVersionsResponseCampaignsResponseItemDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientGetCampaignVersionsResponseCampaignsResponseItemHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientGetCampaignVersionsResponseCampaignsResponseItemLimitsTypeDef,
        "MessageConfiguration": ClientGetCampaignVersionsResponseCampaignsResponseItemMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientGetCampaignVersionsResponseCampaignsResponseItemScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientGetCampaignVersionsResponseCampaignsResponseItemStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientGetCampaignVersionsResponseCampaignsResponseItemTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.
      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.
        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.
          - **Id** *(string) --*

            The unique identifier for the treatment.
    """


_ClientGetCampaignVersionsResponseCampaignsResponseTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseCampaignsResponseTypeDef",
    {"Item": List[ClientGetCampaignVersionsResponseCampaignsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetCampaignVersionsResponseCampaignsResponseTypeDef(
    _ClientGetCampaignVersionsResponseCampaignsResponseTypeDef
):
    """
    - **CampaignsResponse** *(dict) --*

      Provides information about the configuration and other settings for all the campaigns that are
      associated with an application.
      - **Item** *(list) --*

        An array of responses, one for each campaign that's associated with the application.
        - *(dict) --*

          Provides information about the status, configuration, and other settings for a campaign.
          - **AdditionalTreatments** *(list) --*

            An array of responses, one for each treatment that you defined for the campaign, in
            addition to the default treatment.
            - *(dict) --*

              Specifies the settings for a campaign treatment. A treatment is a variation of a
              campaign that's used for A/B testing of a campaign.
              - **Id** *(string) --*

                The unique identifier for the treatment.
    """


_ClientGetCampaignVersionsResponseTypeDef = TypedDict(
    "_ClientGetCampaignVersionsResponseTypeDef",
    {"CampaignsResponse": ClientGetCampaignVersionsResponseCampaignsResponseTypeDef},
    total=False,
)


class ClientGetCampaignVersionsResponseTypeDef(_ClientGetCampaignVersionsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **CampaignsResponse** *(dict) --*

        Provides information about the configuration and other settings for all the campaigns that
        are associated with an application.
        - **Item** *(list) --*

          An array of responses, one for each campaign that's associated with the application.
          - *(dict) --*

            Provides information about the status, configuration, and other settings for a campaign.
            - **AdditionalTreatments** *(list) --*

              An array of responses, one for each treatment that you defined for the campaign, in
              addition to the default treatment.
              - *(dict) --*

                Specifies the settings for a campaign treatment. A treatment is a variation of a
                campaign that's used for A/B testing of a campaign.
                - **Id** *(string) --*

                  The unique identifier for the treatment.
    """


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef
):
    """
    - *(dict) --*

      Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
      that's used for A/B testing of a campaign.
      - **Id** *(string) --*

        The unique identifier for the treatment.
    """


_ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientGetCampaignsResponseCampaignsResponseItemScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientGetCampaignsResponseCampaignsResponseItemScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef
):
    pass


_ClientGetCampaignsResponseCampaignsResponseItemTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseItemTypeDef",
    {
        "AdditionalTreatments": List[
            ClientGetCampaignsResponseCampaignsResponseItemAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientGetCampaignsResponseCampaignsResponseItemDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientGetCampaignsResponseCampaignsResponseItemHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientGetCampaignsResponseCampaignsResponseItemLimitsTypeDef,
        "MessageConfiguration": ClientGetCampaignsResponseCampaignsResponseItemMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientGetCampaignsResponseCampaignsResponseItemScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientGetCampaignsResponseCampaignsResponseItemStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientGetCampaignsResponseCampaignsResponseItemTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseItemTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.
      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.
        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.
          - **Id** *(string) --*

            The unique identifier for the treatment.
    """


_ClientGetCampaignsResponseCampaignsResponseTypeDef = TypedDict(
    "_ClientGetCampaignsResponseCampaignsResponseTypeDef",
    {"Item": List[ClientGetCampaignsResponseCampaignsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetCampaignsResponseCampaignsResponseTypeDef(
    _ClientGetCampaignsResponseCampaignsResponseTypeDef
):
    """
    - **CampaignsResponse** *(dict) --*

      Provides information about the configuration and other settings for all the campaigns that are
      associated with an application.
      - **Item** *(list) --*

        An array of responses, one for each campaign that's associated with the application.
        - *(dict) --*

          Provides information about the status, configuration, and other settings for a campaign.
          - **AdditionalTreatments** *(list) --*

            An array of responses, one for each treatment that you defined for the campaign, in
            addition to the default treatment.
            - *(dict) --*

              Specifies the settings for a campaign treatment. A treatment is a variation of a
              campaign that's used for A/B testing of a campaign.
              - **Id** *(string) --*

                The unique identifier for the treatment.
    """


_ClientGetCampaignsResponseTypeDef = TypedDict(
    "_ClientGetCampaignsResponseTypeDef",
    {"CampaignsResponse": ClientGetCampaignsResponseCampaignsResponseTypeDef},
    total=False,
)


class ClientGetCampaignsResponseTypeDef(_ClientGetCampaignsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **CampaignsResponse** *(dict) --*

        Provides information about the configuration and other settings for all the campaigns that
        are associated with an application.
        - **Item** *(list) --*

          An array of responses, one for each campaign that's associated with the application.
          - *(dict) --*

            Provides information about the status, configuration, and other settings for a campaign.
            - **AdditionalTreatments** *(list) --*

              An array of responses, one for each treatment that you defined for the campaign, in
              addition to the default treatment.
              - *(dict) --*

                Specifies the settings for a campaign treatment. A treatment is a variation of a
                campaign that's used for A/B testing of a campaign.
                - **Id** *(string) --*

                  The unique identifier for the treatment.
    """


_ClientGetChannelsResponseChannelsResponseChannelsTypeDef = TypedDict(
    "_ClientGetChannelsResponseChannelsResponseChannelsTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Version": int,
    },
    total=False,
)


class ClientGetChannelsResponseChannelsResponseChannelsTypeDef(
    _ClientGetChannelsResponseChannelsResponseChannelsTypeDef
):
    pass


_ClientGetChannelsResponseChannelsResponseTypeDef = TypedDict(
    "_ClientGetChannelsResponseChannelsResponseTypeDef",
    {"Channels": Dict[str, ClientGetChannelsResponseChannelsResponseChannelsTypeDef]},
    total=False,
)


class ClientGetChannelsResponseChannelsResponseTypeDef(
    _ClientGetChannelsResponseChannelsResponseTypeDef
):
    """
    - **ChannelsResponse** *(dict) --*

      Provides information about the general settings and status of all channels for an application,
      including channels that aren't enabled for the application.
      - **Channels** *(dict) --*

        A map that contains a multipart response for each channel. For each item in this object, the
        ChannelType is the key and the Channel is the value.
        - *(string) --*

          - *(dict) --*

            Provides information about the general settings and status of a channel for an
            application.
            - **ApplicationId** *(string) --*

              The unique identifier for the application.
    """


_ClientGetChannelsResponseTypeDef = TypedDict(
    "_ClientGetChannelsResponseTypeDef",
    {"ChannelsResponse": ClientGetChannelsResponseChannelsResponseTypeDef},
    total=False,
)


class ClientGetChannelsResponseTypeDef(_ClientGetChannelsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ChannelsResponse** *(dict) --*

        Provides information about the general settings and status of all channels for an
        application, including channels that aren't enabled for the application.
        - **Channels** *(dict) --*

          A map that contains a multipart response for each channel. For each item in this object,
          the ChannelType is the key and the Channel is the value.
          - *(string) --*

            - *(dict) --*

              Provides information about the general settings and status of a channel for an
              application.
              - **ApplicationId** *(string) --*

                The unique identifier for the application.
    """


_ClientGetEmailChannelResponseEmailChannelResponseTypeDef = TypedDict(
    "_ClientGetEmailChannelResponseEmailChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "ConfigurationSet": str,
        "CreationDate": str,
        "Enabled": bool,
        "FromAddress": str,
        "HasCredential": bool,
        "Id": str,
        "Identity": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "MessagesPerSecond": int,
        "Platform": str,
        "RoleArn": str,
        "Version": int,
    },
    total=False,
)


class ClientGetEmailChannelResponseEmailChannelResponseTypeDef(
    _ClientGetEmailChannelResponseEmailChannelResponseTypeDef
):
    """
    - **EmailChannelResponse** *(dict) --*

      Provides information about the status and settings of the email channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the email channel applies to.
    """


_ClientGetEmailChannelResponseTypeDef = TypedDict(
    "_ClientGetEmailChannelResponseTypeDef",
    {"EmailChannelResponse": ClientGetEmailChannelResponseEmailChannelResponseTypeDef},
    total=False,
)


class ClientGetEmailChannelResponseTypeDef(_ClientGetEmailChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **EmailChannelResponse** *(dict) --*

        Provides information about the status and settings of the email channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the email channel applies to.
    """


_ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef = TypedDict(
    "_ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef",
    {
        "Arn": str,
        "CreationDate": str,
        "DefaultSubstitutions": str,
        "HtmlPart": str,
        "LastModifiedDate": str,
        "Subject": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TemplateName": str,
        "TemplateType": Literal["EMAIL", "SMS", "VOICE", "PUSH"],
        "TextPart": str,
    },
    total=False,
)


class ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef(
    _ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef
):
    """
    - **EmailTemplateResponse** *(dict) --*

      Provides information about the content and settings for a message template that can be used in
      messages that are sent through the email channel.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template.
    """


_ClientGetEmailTemplateResponseTypeDef = TypedDict(
    "_ClientGetEmailTemplateResponseTypeDef",
    {"EmailTemplateResponse": ClientGetEmailTemplateResponseEmailTemplateResponseTypeDef},
    total=False,
)


class ClientGetEmailTemplateResponseTypeDef(_ClientGetEmailTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **EmailTemplateResponse** *(dict) --*

        Provides information about the content and settings for a message template that can be used
        in messages that are sent through the email channel.
        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the message template.
    """


_ClientGetEndpointResponseEndpointResponseDemographicTypeDef = TypedDict(
    "_ClientGetEndpointResponseEndpointResponseDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetEndpointResponseEndpointResponseDemographicTypeDef(
    _ClientGetEndpointResponseEndpointResponseDemographicTypeDef
):
    pass


_ClientGetEndpointResponseEndpointResponseLocationTypeDef = TypedDict(
    "_ClientGetEndpointResponseEndpointResponseLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientGetEndpointResponseEndpointResponseLocationTypeDef(
    _ClientGetEndpointResponseEndpointResponseLocationTypeDef
):
    pass


_ClientGetEndpointResponseEndpointResponseUserTypeDef = TypedDict(
    "_ClientGetEndpointResponseEndpointResponseUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientGetEndpointResponseEndpointResponseUserTypeDef(
    _ClientGetEndpointResponseEndpointResponseUserTypeDef
):
    pass


_ClientGetEndpointResponseEndpointResponseTypeDef = TypedDict(
    "_ClientGetEndpointResponseEndpointResponseTypeDef",
    {
        "Address": str,
        "ApplicationId": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": Literal[
            "GCM",
            "APNS",
            "APNS_SANDBOX",
            "APNS_VOIP",
            "APNS_VOIP_SANDBOX",
            "ADM",
            "SMS",
            "VOICE",
            "EMAIL",
            "BAIDU",
            "CUSTOM",
        ],
        "CohortId": str,
        "CreationDate": str,
        "Demographic": ClientGetEndpointResponseEndpointResponseDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Id": str,
        "Location": ClientGetEndpointResponseEndpointResponseLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientGetEndpointResponseEndpointResponseUserTypeDef,
    },
    total=False,
)


class ClientGetEndpointResponseEndpointResponseTypeDef(
    _ClientGetEndpointResponseEndpointResponseTypeDef
):
    """
    - **EndpointResponse** *(dict) --*

      Provides information about the channel type and other settings for an endpoint.
      - **Address** *(string) --*

        The destination address for messages or push notifications that you send to the endpoint.
        The address varies by channel. For example, the address for a push-notification channel is
        typically the token provided by a push notification service, such as an Apple Push
        Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
        token. The address for the SMS channel is a phone number in E.164 format, such as
        +12065550100. The address for the email channel is an email address.
    """


_ClientGetEndpointResponseTypeDef = TypedDict(
    "_ClientGetEndpointResponseTypeDef",
    {"EndpointResponse": ClientGetEndpointResponseEndpointResponseTypeDef},
    total=False,
)


class ClientGetEndpointResponseTypeDef(_ClientGetEndpointResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **EndpointResponse** *(dict) --*

        Provides information about the channel type and other settings for an endpoint.
        - **Address** *(string) --*

          The destination address for messages or push notifications that you send to the endpoint.
          The address varies by channel. For example, the address for a push-notification channel is
          typically the token provided by a push notification service, such as an Apple Push
          Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
          token. The address for the SMS channel is a phone number in E.164 format, such as
          +12065550100. The address for the email channel is an email address.
    """


_ClientGetEventStreamResponseEventStreamTypeDef = TypedDict(
    "_ClientGetEventStreamResponseEventStreamTypeDef",
    {
        "ApplicationId": str,
        "DestinationStreamArn": str,
        "ExternalId": str,
        "LastModifiedDate": str,
        "LastUpdatedBy": str,
        "RoleArn": str,
    },
    total=False,
)


class ClientGetEventStreamResponseEventStreamTypeDef(
    _ClientGetEventStreamResponseEventStreamTypeDef
):
    """
    - **EventStream** *(dict) --*

      Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
      Kinesis Data Firehose delivery stream.
      - **ApplicationId** *(string) --*

        The unique identifier for the application to publish event data for.
    """


_ClientGetEventStreamResponseTypeDef = TypedDict(
    "_ClientGetEventStreamResponseTypeDef",
    {"EventStream": ClientGetEventStreamResponseEventStreamTypeDef},
    total=False,
)


class ClientGetEventStreamResponseTypeDef(_ClientGetEventStreamResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **EventStream** *(dict) --*

        Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
        Kinesis Data Firehose delivery stream.
        - **ApplicationId** *(string) --*

          The unique identifier for the application to publish event data for.
    """


_ClientGetExportJobResponseExportJobResponseDefinitionTypeDef = TypedDict(
    "_ClientGetExportJobResponseExportJobResponseDefinitionTypeDef",
    {"RoleArn": str, "S3UrlPrefix": str, "SegmentId": str, "SegmentVersion": int},
    total=False,
)


class ClientGetExportJobResponseExportJobResponseDefinitionTypeDef(
    _ClientGetExportJobResponseExportJobResponseDefinitionTypeDef
):
    pass


_ClientGetExportJobResponseExportJobResponseTypeDef = TypedDict(
    "_ClientGetExportJobResponseExportJobResponseTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetExportJobResponseExportJobResponseDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": Literal[
            "CREATED",
            "PREPARING_FOR_INITIALIZATION",
            "INITIALIZING",
            "PROCESSING",
            "PENDING_JOB",
            "COMPLETING",
            "COMPLETED",
            "FAILING",
            "FAILED",
        ],
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetExportJobResponseExportJobResponseTypeDef(
    _ClientGetExportJobResponseExportJobResponseTypeDef
):
    """
    - **ExportJobResponse** *(dict) --*

      Provides information about the status and settings of a job that exports endpoint definitions
      to a file. The file can be added directly to an Amazon Simple Storage Service (Amazon S3)
      bucket by using the Amazon Pinpoint API or downloaded directly to a computer by using the
      Amazon Pinpoint console.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the export job.
    """


_ClientGetExportJobResponseTypeDef = TypedDict(
    "_ClientGetExportJobResponseTypeDef",
    {"ExportJobResponse": ClientGetExportJobResponseExportJobResponseTypeDef},
    total=False,
)


class ClientGetExportJobResponseTypeDef(_ClientGetExportJobResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ExportJobResponse** *(dict) --*

        Provides information about the status and settings of a job that exports endpoint
        definitions to a file. The file can be added directly to an Amazon Simple Storage Service
        (Amazon S3) bucket by using the Amazon Pinpoint API or downloaded directly to a computer by
        using the Amazon Pinpoint console.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that's associated with the export job.
    """


_ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef = TypedDict(
    "_ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef",
    {"RoleArn": str, "S3UrlPrefix": str, "SegmentId": str, "SegmentVersion": int},
    total=False,
)


class ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef(
    _ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef
):
    pass


_ClientGetExportJobsResponseExportJobsResponseItemTypeDef = TypedDict(
    "_ClientGetExportJobsResponseExportJobsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetExportJobsResponseExportJobsResponseItemDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": Literal[
            "CREATED",
            "PREPARING_FOR_INITIALIZATION",
            "INITIALIZING",
            "PROCESSING",
            "PENDING_JOB",
            "COMPLETING",
            "COMPLETED",
            "FAILING",
            "FAILED",
        ],
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetExportJobsResponseExportJobsResponseItemTypeDef(
    _ClientGetExportJobsResponseExportJobsResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about the status and settings of a job that exports endpoint definitions
      to a file. The file can be added directly to an Amazon Simple Storage Service (Amazon S3)
      bucket by using the Amazon Pinpoint API or downloaded directly to a computer by using the
      Amazon Pinpoint console.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the export job.
    """


_ClientGetExportJobsResponseExportJobsResponseTypeDef = TypedDict(
    "_ClientGetExportJobsResponseExportJobsResponseTypeDef",
    {"Item": List[ClientGetExportJobsResponseExportJobsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetExportJobsResponseExportJobsResponseTypeDef(
    _ClientGetExportJobsResponseExportJobsResponseTypeDef
):
    """
    - **ExportJobsResponse** *(dict) --*

      Provides information about all the export jobs that are associated with an application or
      segment. An export job is a job that exports endpoint definitions to a file.
      - **Item** *(list) --*

        An array of responses, one for each export job that's associated with the application
        (Export Jobs resource) or segment (Segment Export Jobs resource).
        - *(dict) --*

          Provides information about the status and settings of a job that exports endpoint
          definitions to a file. The file can be added directly to an Amazon Simple Storage Service
          (Amazon S3) bucket by using the Amazon Pinpoint API or downloaded directly to a computer
          by using the Amazon Pinpoint console.
          - **ApplicationId** *(string) --*

            The unique identifier for the application that's associated with the export job.
    """


_ClientGetExportJobsResponseTypeDef = TypedDict(
    "_ClientGetExportJobsResponseTypeDef",
    {"ExportJobsResponse": ClientGetExportJobsResponseExportJobsResponseTypeDef},
    total=False,
)


class ClientGetExportJobsResponseTypeDef(_ClientGetExportJobsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ExportJobsResponse** *(dict) --*

        Provides information about all the export jobs that are associated with an application or
        segment. An export job is a job that exports endpoint definitions to a file.
        - **Item** *(list) --*

          An array of responses, one for each export job that's associated with the application
          (Export Jobs resource) or segment (Segment Export Jobs resource).
          - *(dict) --*

            Provides information about the status and settings of a job that exports endpoint
            definitions to a file. The file can be added directly to an Amazon Simple Storage
            Service (Amazon S3) bucket by using the Amazon Pinpoint API or downloaded directly to a
            computer by using the Amazon Pinpoint console.
            - **ApplicationId** *(string) --*

              The unique identifier for the application that's associated with the export job.
    """


_ClientGetGcmChannelResponseGCMChannelResponseTypeDef = TypedDict(
    "_ClientGetGcmChannelResponseGCMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetGcmChannelResponseGCMChannelResponseTypeDef(
    _ClientGetGcmChannelResponseGCMChannelResponseTypeDef
):
    """
    - **GCMChannelResponse** *(dict) --*

      Provides information about the status and settings of the GCM channel for an application. The
      GCM channel enables Amazon Pinpoint to send push notifications through the Firebase Cloud
      Messaging (FCM), formerly Google Cloud Messaging (GCM), service.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the GCM channel applies to.
    """


_ClientGetGcmChannelResponseTypeDef = TypedDict(
    "_ClientGetGcmChannelResponseTypeDef",
    {"GCMChannelResponse": ClientGetGcmChannelResponseGCMChannelResponseTypeDef},
    total=False,
)


class ClientGetGcmChannelResponseTypeDef(_ClientGetGcmChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **GCMChannelResponse** *(dict) --*

        Provides information about the status and settings of the GCM channel for an application.
        The GCM channel enables Amazon Pinpoint to send push notifications through the Firebase
        Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the GCM channel applies to.
    """


_ClientGetImportJobResponseImportJobResponseDefinitionTypeDef = TypedDict(
    "_ClientGetImportJobResponseImportJobResponseDefinitionTypeDef",
    {
        "DefineSegment": bool,
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RegisterEndpoints": bool,
        "RoleArn": str,
        "S3Url": str,
        "SegmentId": str,
        "SegmentName": str,
    },
    total=False,
)


class ClientGetImportJobResponseImportJobResponseDefinitionTypeDef(
    _ClientGetImportJobResponseImportJobResponseDefinitionTypeDef
):
    pass


_ClientGetImportJobResponseImportJobResponseTypeDef = TypedDict(
    "_ClientGetImportJobResponseImportJobResponseTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetImportJobResponseImportJobResponseDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": Literal[
            "CREATED",
            "PREPARING_FOR_INITIALIZATION",
            "INITIALIZING",
            "PROCESSING",
            "PENDING_JOB",
            "COMPLETING",
            "COMPLETED",
            "FAILING",
            "FAILED",
        ],
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetImportJobResponseImportJobResponseTypeDef(
    _ClientGetImportJobResponseImportJobResponseTypeDef
):
    """
    - **ImportJobResponse** *(dict) --*

      Provides information about the status and settings of a job that imports endpoint definitions
      from one or more files. The files can be stored in an Amazon Simple Storage Service (Amazon
      S3) bucket or uploaded directly from a computer by using the Amazon Pinpoint console.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the import job.
    """


_ClientGetImportJobResponseTypeDef = TypedDict(
    "_ClientGetImportJobResponseTypeDef",
    {"ImportJobResponse": ClientGetImportJobResponseImportJobResponseTypeDef},
    total=False,
)


class ClientGetImportJobResponseTypeDef(_ClientGetImportJobResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ImportJobResponse** *(dict) --*

        Provides information about the status and settings of a job that imports endpoint
        definitions from one or more files. The files can be stored in an Amazon Simple Storage
        Service (Amazon S3) bucket or uploaded directly from a computer by using the Amazon Pinpoint
        console.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that's associated with the import job.
    """


_ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef = TypedDict(
    "_ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef",
    {
        "DefineSegment": bool,
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RegisterEndpoints": bool,
        "RoleArn": str,
        "S3Url": str,
        "SegmentId": str,
        "SegmentName": str,
    },
    total=False,
)


class ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef(
    _ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef
):
    pass


_ClientGetImportJobsResponseImportJobsResponseItemTypeDef = TypedDict(
    "_ClientGetImportJobsResponseImportJobsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetImportJobsResponseImportJobsResponseItemDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": Literal[
            "CREATED",
            "PREPARING_FOR_INITIALIZATION",
            "INITIALIZING",
            "PROCESSING",
            "PENDING_JOB",
            "COMPLETING",
            "COMPLETED",
            "FAILING",
            "FAILED",
        ],
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetImportJobsResponseImportJobsResponseItemTypeDef(
    _ClientGetImportJobsResponseImportJobsResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about the status and settings of a job that imports endpoint definitions
      from one or more files. The files can be stored in an Amazon Simple Storage Service (Amazon
      S3) bucket or uploaded directly from a computer by using the Amazon Pinpoint console.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the import job.
    """


_ClientGetImportJobsResponseImportJobsResponseTypeDef = TypedDict(
    "_ClientGetImportJobsResponseImportJobsResponseTypeDef",
    {"Item": List[ClientGetImportJobsResponseImportJobsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetImportJobsResponseImportJobsResponseTypeDef(
    _ClientGetImportJobsResponseImportJobsResponseTypeDef
):
    """
    - **ImportJobsResponse** *(dict) --*

      Provides information about the status and settings of all the import jobs that are associated
      with an application or segment. An import job is a job that imports endpoint definitions from
      one or more files.
      - **Item** *(list) --*

        An array of responses, one for each import job that's associated with the application
        (Import Jobs resource) or segment (Segment Import Jobs resource).
        - *(dict) --*

          Provides information about the status and settings of a job that imports endpoint
          definitions from one or more files. The files can be stored in an Amazon Simple Storage
          Service (Amazon S3) bucket or uploaded directly from a computer by using the Amazon
          Pinpoint console.
          - **ApplicationId** *(string) --*

            The unique identifier for the application that's associated with the import job.
    """


_ClientGetImportJobsResponseTypeDef = TypedDict(
    "_ClientGetImportJobsResponseTypeDef",
    {"ImportJobsResponse": ClientGetImportJobsResponseImportJobsResponseTypeDef},
    total=False,
)


class ClientGetImportJobsResponseTypeDef(_ClientGetImportJobsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ImportJobsResponse** *(dict) --*

        Provides information about the status and settings of all the import jobs that are
        associated with an application or segment. An import job is a job that imports endpoint
        definitions from one or more files.
        - **Item** *(list) --*

          An array of responses, one for each import job that's associated with the application
          (Import Jobs resource) or segment (Segment Import Jobs resource).
          - *(dict) --*

            Provides information about the status and settings of a job that imports endpoint
            definitions from one or more files. The files can be stored in an Amazon Simple Storage
            Service (Amazon S3) bucket or uploaded directly from a computer by using the Amazon
            Pinpoint console.
            - **ApplicationId** *(string) --*

              The unique identifier for the application that's associated with the import job.
    """


_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef(
    _ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
):
    pass


_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef",
    {"Key": str, "Type": str, "Value": str},
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef(
    _ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef
):
    pass


_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef",
    {
        "GroupedBys": List[
            ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsGroupedBysTypeDef
        ],
        "Values": List[
            ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsValuesTypeDef
        ],
    },
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef(
    _ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef
):
    pass


_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef",
    {
        "Rows": List[
            ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultRowsTypeDef
        ]
    },
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef(
    _ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef
):
    pass


_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef",
    {
        "ApplicationId": str,
        "EndTime": datetime,
        "JourneyId": str,
        "KpiName": str,
        "KpiResult": ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseKpiResultTypeDef,
        "NextToken": str,
        "StartTime": datetime,
    },
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef(
    _ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef
):
    """
    - **JourneyDateRangeKpiResponse** *(dict) --*

      Provides the results of a query that retrieved the data for a standard engagement metric that
      applies to a journey, and provides information about that query.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the metric applies to.
    """


_ClientGetJourneyDateRangeKpiResponseTypeDef = TypedDict(
    "_ClientGetJourneyDateRangeKpiResponseTypeDef",
    {
        "JourneyDateRangeKpiResponse": ClientGetJourneyDateRangeKpiResponseJourneyDateRangeKpiResponseTypeDef
    },
    total=False,
)


class ClientGetJourneyDateRangeKpiResponseTypeDef(_ClientGetJourneyDateRangeKpiResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **JourneyDateRangeKpiResponse** *(dict) --*

        Provides the results of a query that retrieved the data for a standard engagement metric
        that applies to a journey, and provides information about that query.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the metric applies to.
    """


_ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef = TypedDict(
    "_ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef",
    {
        "ActivityType": str,
        "ApplicationId": str,
        "JourneyActivityId": str,
        "JourneyId": str,
        "LastEvaluatedTime": str,
        "Metrics": Dict[str, str],
    },
    total=False,
)


class ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef(
    _ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef
):
    """
    - **JourneyExecutionActivityMetricsResponse** *(dict) --*

      Provides the results of a query that retrieved the data for a standard execution metric that
      applies to a journey activity, and provides information about that query.
      - **ActivityType** *(string) --*

        The type of activity that the metric applies to. Possible values are:
        * CONDITIONAL_SPLIT - For a yes/no split activity, which is an activity that sends
        participants down one of two paths in a journey.
        * HOLDOUT - For a holdout activity, which is an activity that stops a journey for a
        specified percentage of participants.
        * MESSAGE - For an email activity, which is an activity that sends an email message to
        participants.
        * MULTI_CONDITIONAL_SPLIT - For a multivariate split activity, which is an activity that
        sends participants down one of as many as five paths in a journey.
        * RANDOM_SPLIT - For a random split activity, which is an activity that sends specified
        percentages of participants down one of as many as five paths in a journey.
        * WAIT - For a wait activity, which is an activity that waits for a certain amount of time
        or until a specific date and time before moving participants to the next activity in a
        journey.
    """


_ClientGetJourneyExecutionActivityMetricsResponseTypeDef = TypedDict(
    "_ClientGetJourneyExecutionActivityMetricsResponseTypeDef",
    {
        "JourneyExecutionActivityMetricsResponse": ClientGetJourneyExecutionActivityMetricsResponseJourneyExecutionActivityMetricsResponseTypeDef
    },
    total=False,
)


class ClientGetJourneyExecutionActivityMetricsResponseTypeDef(
    _ClientGetJourneyExecutionActivityMetricsResponseTypeDef
):
    """
    - *(dict) --*

      The request succeeded.
      - **JourneyExecutionActivityMetricsResponse** *(dict) --*

        Provides the results of a query that retrieved the data for a standard execution metric that
        applies to a journey activity, and provides information about that query.
        - **ActivityType** *(string) --*

          The type of activity that the metric applies to. Possible values are:
          * CONDITIONAL_SPLIT - For a yes/no split activity, which is an activity that sends
          participants down one of two paths in a journey.
          * HOLDOUT - For a holdout activity, which is an activity that stops a journey for a
          specified percentage of participants.
          * MESSAGE - For an email activity, which is an activity that sends an email message to
          participants.
          * MULTI_CONDITIONAL_SPLIT - For a multivariate split activity, which is an activity that
          sends participants down one of as many as five paths in a journey.
          * RANDOM_SPLIT - For a random split activity, which is an activity that sends specified
          percentages of participants down one of as many as five paths in a journey.
          * WAIT - For a wait activity, which is an activity that waits for a certain amount of time
          or until a specific date and time before moving participants to the next activity in a
          journey.
    """


_ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef = TypedDict(
    "_ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef",
    {"ApplicationId": str, "JourneyId": str, "LastEvaluatedTime": str, "Metrics": Dict[str, str]},
    total=False,
)


class ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef(
    _ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef
):
    """
    - **JourneyExecutionMetricsResponse** *(dict) --*

      Provides the results of a query that retrieved the data for a standard execution metric that
      applies to a journey, and provides information about that query.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the metric applies to.
    """


_ClientGetJourneyExecutionMetricsResponseTypeDef = TypedDict(
    "_ClientGetJourneyExecutionMetricsResponseTypeDef",
    {
        "JourneyExecutionMetricsResponse": ClientGetJourneyExecutionMetricsResponseJourneyExecutionMetricsResponseTypeDef
    },
    total=False,
)


class ClientGetJourneyExecutionMetricsResponseTypeDef(
    _ClientGetJourneyExecutionMetricsResponseTypeDef
):
    """
    - *(dict) --*

      The request succeeded.
      - **JourneyExecutionMetricsResponse** *(dict) --*

        Provides the results of a query that retrieved the data for a standard execution metric that
        applies to a journey, and provides information about that query.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the metric applies to.
    """


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": Literal["ALL", "ANY"],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientGetJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    {"Branches": List[ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef]},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientGetJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseActivitiesTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseActivitiesTypeDef",
    {
        "ConditionalSplit": ClientGetJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientGetJourneyResponseJourneyResponseActivitiesEMAILTypeDef,
        "Holdout": ClientGetJourneyResponseJourneyResponseActivitiesHoldoutTypeDef,
        "MultiCondition": ClientGetJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientGetJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef,
        "Wait": ClientGetJourneyResponseJourneyResponseActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseActivitiesTypeDef(
    _ClientGetJourneyResponseJourneyResponseActivitiesTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseLimitsTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseLimitsTypeDef(
    _ClientGetJourneyResponseJourneyResponseLimitsTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef(
    _ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseScheduleTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseScheduleTypeDef(
    _ClientGetJourneyResponseJourneyResponseScheduleTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseStartConditionTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientGetJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseStartConditionTypeDef(
    _ClientGetJourneyResponseJourneyResponseStartConditionTypeDef
):
    pass


_ClientGetJourneyResponseJourneyResponseTypeDef = TypedDict(
    "_ClientGetJourneyResponseJourneyResponseTypeDef",
    {
        "Activities": Dict[str, ClientGetJourneyResponseJourneyResponseActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientGetJourneyResponseJourneyResponseLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientGetJourneyResponseJourneyResponseQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientGetJourneyResponseJourneyResponseScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientGetJourneyResponseJourneyResponseStartConditionTypeDef,
        "State": Literal["DRAFT", "ACTIVE", "COMPLETED", "CANCELLED", "CLOSED"],
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientGetJourneyResponseJourneyResponseTypeDef(
    _ClientGetJourneyResponseJourneyResponseTypeDef
):
    """
    - **JourneyResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a journey.
      - **Activities** *(dict) --*

        The configuration and other settings for the activities that comprise the journey.
        - *(string) --*

          - *(dict) --*

            Specifies the configuration and other settings for an activity in a journey.
            - **ConditionalSplit** *(dict) --*

              The settings for a yes/no split activity. This type of activity sends participants
              down one of two paths in a journey, based on conditions that you specify.
              - **Condition** *(dict) --*

                The conditions that define the paths for the activity, and the relationship between
                the conditions.
                - **Conditions** *(list) --*

                  The conditions to evaluate for the activity.
                  - *(dict) --*

                    Specifies a condition to evaluate for an activity in a journey.
                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.
                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.
                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.
                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.
                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.
    """


_ClientGetJourneyResponseTypeDef = TypedDict(
    "_ClientGetJourneyResponseTypeDef",
    {"JourneyResponse": ClientGetJourneyResponseJourneyResponseTypeDef},
    total=False,
)


class ClientGetJourneyResponseTypeDef(_ClientGetJourneyResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **JourneyResponse** *(dict) --*

        Provides information about the status, configuration, and other settings for a journey.
        - **Activities** *(dict) --*

          The configuration and other settings for the activities that comprise the journey.
          - *(string) --*

            - *(dict) --*

              Specifies the configuration and other settings for an activity in a journey.
              - **ConditionalSplit** *(dict) --*

                The settings for a yes/no split activity. This type of activity sends participants
                down one of two paths in a journey, based on conditions that you specify.
                - **Condition** *(dict) --*

                  The conditions that define the paths for the activity, and the relationship
                  between the conditions.
                  - **Conditions** *(list) --*

                    The conditions to evaluate for the activity.
                    - *(dict) --*

                      Specifies a condition to evaluate for an activity in a journey.
                      - **EventCondition** *(dict) --*

                        The dimension settings for the event that's associated with the activity.
                        - **Dimensions** *(dict) --*

                          The dimensions for the event filter to use for the activity.
                          - **Attributes** *(dict) --*

                            One or more custom attributes that your application reports to Amazon
                            Pinpoint. You can use these attributes as selection criteria when you
                            create an event filter.
                            - *(string) --*

                              - *(dict) --*

                                Specifies attribute-based criteria for including or excluding
                                endpoints from a segment.
                                - **AttributeType** *(string) --*

                                  The type of segment dimension to use. Valid values are: INCLUSIVE,
                                  endpoints that match the criteria are included in the segment;
                                  and, EXCLUSIVE, endpoints that match the criteria are excluded
                                  from the segment.
    """


_ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef
):
    """
    - **ADM** *(dict) --*

      The message template that's used for the ADM (Amazon Device Messaging) channel. This message
      template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).
      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:
        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.
        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.
        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.
    """


_ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "MediaUrl": str,
        "RawContent": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef
):
    pass


_ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef
):
    pass


_ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef
):
    pass


_ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef
):
    pass


_ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef = TypedDict(
    "_ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef",
    {
        "ADM": ClientGetPushTemplateResponsePushNotificationTemplateResponseADMTypeDef,
        "APNS": ClientGetPushTemplateResponsePushNotificationTemplateResponseAPNSTypeDef,
        "Arn": str,
        "Baidu": ClientGetPushTemplateResponsePushNotificationTemplateResponseBaiduTypeDef,
        "CreationDate": str,
        "Default": ClientGetPushTemplateResponsePushNotificationTemplateResponseDefaultTypeDef,
        "DefaultSubstitutions": str,
        "GCM": ClientGetPushTemplateResponsePushNotificationTemplateResponseGCMTypeDef,
        "LastModifiedDate": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TemplateName": str,
        "TemplateType": Literal["EMAIL", "SMS", "VOICE", "PUSH"],
    },
    total=False,
)


class ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef(
    _ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef
):
    """
    - **PushNotificationTemplateResponse** *(dict) --*

      Provides information about the content and settings for a message template that can be used in
      messages that are sent through a push notification channel.
      - **ADM** *(dict) --*

        The message template that's used for the ADM (Amazon Device Messaging) channel. This message
        template overrides the default template for push notification channels
        (DefaultPushNotificationTemplate).
        - **Action** *(string) --*

          The action to occur if a recipient taps a push notification that's based on the message
          template. Valid values are:
          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.
          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          action uses the deep-linking features of the Android platform.
          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.
    """


_ClientGetPushTemplateResponseTypeDef = TypedDict(
    "_ClientGetPushTemplateResponseTypeDef",
    {
        "PushNotificationTemplateResponse": ClientGetPushTemplateResponsePushNotificationTemplateResponseTypeDef
    },
    total=False,
)


class ClientGetPushTemplateResponseTypeDef(_ClientGetPushTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **PushNotificationTemplateResponse** *(dict) --*

        Provides information about the content and settings for a message template that can be used
        in messages that are sent through a push notification channel.
        - **ADM** *(dict) --*

          The message template that's used for the ADM (Amazon Device Messaging) channel. This
          message template overrides the default template for push notification channels
          (DefaultPushNotificationTemplate).
          - **Action** *(string) --*

            The action to occur if a recipient taps a push notification that's based on the message
            template. Valid values are:
            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.
            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            action uses the deep-linking features of the Android platform.
            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.
    """


_ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef",
    {"RoleArn": str, "S3UrlPrefix": str, "SegmentId": str, "SegmentVersion": int},
    total=False,
)


class ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef(
    _ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef
):
    pass


_ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef = TypedDict(
    "_ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetSegmentExportJobsResponseExportJobsResponseItemDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": Literal[
            "CREATED",
            "PREPARING_FOR_INITIALIZATION",
            "INITIALIZING",
            "PROCESSING",
            "PENDING_JOB",
            "COMPLETING",
            "COMPLETED",
            "FAILING",
            "FAILED",
        ],
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef(
    _ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about the status and settings of a job that exports endpoint definitions
      to a file. The file can be added directly to an Amazon Simple Storage Service (Amazon S3)
      bucket by using the Amazon Pinpoint API or downloaded directly to a computer by using the
      Amazon Pinpoint console.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the export job.
    """


_ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef = TypedDict(
    "_ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef",
    {
        "Item": List[ClientGetSegmentExportJobsResponseExportJobsResponseItemTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef(
    _ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef
):
    """
    - **ExportJobsResponse** *(dict) --*

      Provides information about all the export jobs that are associated with an application or
      segment. An export job is a job that exports endpoint definitions to a file.
      - **Item** *(list) --*

        An array of responses, one for each export job that's associated with the application
        (Export Jobs resource) or segment (Segment Export Jobs resource).
        - *(dict) --*

          Provides information about the status and settings of a job that exports endpoint
          definitions to a file. The file can be added directly to an Amazon Simple Storage Service
          (Amazon S3) bucket by using the Amazon Pinpoint API or downloaded directly to a computer
          by using the Amazon Pinpoint console.
          - **ApplicationId** *(string) --*

            The unique identifier for the application that's associated with the export job.
    """


_ClientGetSegmentExportJobsResponseTypeDef = TypedDict(
    "_ClientGetSegmentExportJobsResponseTypeDef",
    {"ExportJobsResponse": ClientGetSegmentExportJobsResponseExportJobsResponseTypeDef},
    total=False,
)


class ClientGetSegmentExportJobsResponseTypeDef(_ClientGetSegmentExportJobsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ExportJobsResponse** *(dict) --*

        Provides information about all the export jobs that are associated with an application or
        segment. An export job is a job that exports endpoint definitions to a file.
        - **Item** *(list) --*

          An array of responses, one for each export job that's associated with the application
          (Export Jobs resource) or segment (Segment Export Jobs resource).
          - *(dict) --*

            Provides information about the status and settings of a job that exports endpoint
            definitions to a file. The file can be added directly to an Amazon Simple Storage
            Service (Amazon S3) bucket by using the Amazon Pinpoint API or downloaded directly to a
            computer by using the Amazon Pinpoint console.
            - **ApplicationId** *(string) --*

              The unique identifier for the application that's associated with the export job.
    """


_ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef",
    {
        "DefineSegment": bool,
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RegisterEndpoints": bool,
        "RoleArn": str,
        "S3Url": str,
        "SegmentId": str,
        "SegmentName": str,
    },
    total=False,
)


class ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef(
    _ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef
):
    pass


_ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef = TypedDict(
    "_ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "CompletedPieces": int,
        "CompletionDate": str,
        "CreationDate": str,
        "Definition": ClientGetSegmentImportJobsResponseImportJobsResponseItemDefinitionTypeDef,
        "FailedPieces": int,
        "Failures": List[str],
        "Id": str,
        "JobStatus": Literal[
            "CREATED",
            "PREPARING_FOR_INITIALIZATION",
            "INITIALIZING",
            "PROCESSING",
            "PENDING_JOB",
            "COMPLETING",
            "COMPLETED",
            "FAILING",
            "FAILED",
        ],
        "TotalFailures": int,
        "TotalPieces": int,
        "TotalProcessed": int,
        "Type": str,
    },
    total=False,
)


class ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef(
    _ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about the status and settings of a job that imports endpoint definitions
      from one or more files. The files can be stored in an Amazon Simple Storage Service (Amazon
      S3) bucket or uploaded directly from a computer by using the Amazon Pinpoint console.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that's associated with the import job.
    """


_ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef = TypedDict(
    "_ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef",
    {
        "Item": List[ClientGetSegmentImportJobsResponseImportJobsResponseItemTypeDef],
        "NextToken": str,
    },
    total=False,
)


class ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef(
    _ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef
):
    """
    - **ImportJobsResponse** *(dict) --*

      Provides information about the status and settings of all the import jobs that are associated
      with an application or segment. An import job is a job that imports endpoint definitions from
      one or more files.
      - **Item** *(list) --*

        An array of responses, one for each import job that's associated with the application
        (Import Jobs resource) or segment (Segment Import Jobs resource).
        - *(dict) --*

          Provides information about the status and settings of a job that imports endpoint
          definitions from one or more files. The files can be stored in an Amazon Simple Storage
          Service (Amazon S3) bucket or uploaded directly from a computer by using the Amazon
          Pinpoint console.
          - **ApplicationId** *(string) --*

            The unique identifier for the application that's associated with the import job.
    """


_ClientGetSegmentImportJobsResponseTypeDef = TypedDict(
    "_ClientGetSegmentImportJobsResponseTypeDef",
    {"ImportJobsResponse": ClientGetSegmentImportJobsResponseImportJobsResponseTypeDef},
    total=False,
)


class ClientGetSegmentImportJobsResponseTypeDef(_ClientGetSegmentImportJobsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ImportJobsResponse** *(dict) --*

        Provides information about the status and settings of all the import jobs that are
        associated with an application or segment. An import job is a job that imports endpoint
        definitions from one or more files.
        - **Item** *(list) --*

          An array of responses, one for each import job that's associated with the application
          (Import Jobs resource) or segment (Segment Import Jobs resource).
          - *(dict) --*

            Provides information about the status and settings of a job that imports endpoint
            definitions from one or more files. The files can be stored in an Amazon Simple Storage
            Service (Amazon S3) bucket or uploaded directly from a computer by using the Amazon
            Pinpoint console.
            - **ApplicationId** *(string) --*

              The unique identifier for the application that's associated with the import job.
    """


_ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    {"Recency": ClientGetSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseDimensionsTypeDef",
    {
        "Attributes": Dict[str, ClientGetSegmentResponseSegmentResponseDimensionsAttributesTypeDef],
        "Behavior": ClientGetSegmentResponseSegmentResponseDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentResponseSegmentResponseDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentResponseSegmentResponseDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientGetSegmentResponseSegmentResponseDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientGetSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseDimensionsTypeDef(
    _ClientGetSegmentResponseSegmentResponseDimensionsTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef(
    _ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str, ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
        ],
        "UserAttributes": Dict[
            str,
            ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": Literal["ALL", "ANY", "NONE"],
        "Type": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    {
        "Groups": List[ClientGetSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef],
        "Include": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef(
    _ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef
):
    pass


_ClientGetSegmentResponseSegmentResponseTypeDef = TypedDict(
    "_ClientGetSegmentResponseSegmentResponseTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientGetSegmentResponseSegmentResponseDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientGetSegmentResponseSegmentResponseImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientGetSegmentResponseSegmentResponseSegmentGroupsTypeDef,
        "SegmentType": Literal["DIMENSIONAL", "IMPORT"],
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientGetSegmentResponseSegmentResponseTypeDef(
    _ClientGetSegmentResponseSegmentResponseTypeDef
):
    """
    - **SegmentResponse** *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.
    """


_ClientGetSegmentResponseTypeDef = TypedDict(
    "_ClientGetSegmentResponseTypeDef",
    {"SegmentResponse": ClientGetSegmentResponseSegmentResponseTypeDef},
    total=False,
)


class ClientGetSegmentResponseTypeDef(_ClientGetSegmentResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **SegmentResponse** *(dict) --*

        Provides information about the configuration, dimension, and other settings for a segment.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the segment is associated with.
    """


_ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef",
    {"Recency": ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientGetSegmentVersionResponseSegmentResponseDimensionsAttributesTypeDef
        ],
        "Behavior": ClientGetSegmentVersionResponseSegmentResponseDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentVersionResponseSegmentResponseDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentVersionResponseSegmentResponseDimensionsLocationTypeDef,
        "Metrics": Dict[
            str, ClientGetSegmentVersionResponseSegmentResponseDimensionsMetricsTypeDef
        ],
        "UserAttributes": Dict[
            str, ClientGetSegmentVersionResponseSegmentResponseDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": Literal["ALL", "ANY", "NONE"],
        "Type": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef",
    {
        "Groups": List[ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsGroupsTypeDef],
        "Include": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef
):
    pass


_ClientGetSegmentVersionResponseSegmentResponseTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseSegmentResponseTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientGetSegmentVersionResponseSegmentResponseDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientGetSegmentVersionResponseSegmentResponseImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientGetSegmentVersionResponseSegmentResponseSegmentGroupsTypeDef,
        "SegmentType": Literal["DIMENSIONAL", "IMPORT"],
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientGetSegmentVersionResponseSegmentResponseTypeDef(
    _ClientGetSegmentVersionResponseSegmentResponseTypeDef
):
    """
    - **SegmentResponse** *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.
    """


_ClientGetSegmentVersionResponseTypeDef = TypedDict(
    "_ClientGetSegmentVersionResponseTypeDef",
    {"SegmentResponse": ClientGetSegmentVersionResponseSegmentResponseTypeDef},
    total=False,
)


class ClientGetSegmentVersionResponseTypeDef(_ClientGetSegmentVersionResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **SegmentResponse** *(dict) --*

        Provides information about the configuration, dimension, and other settings for a segment.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the segment is associated with.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsAttributesTypeDef
        ],
        "Behavior": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsLocationTypeDef,
        "Metrics": Dict[
            str, ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsMetricsTypeDef
        ],
        "UserAttributes": Dict[
            str, ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": Literal["ALL", "ANY", "NONE"],
        "Type": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef",
    {
        "Groups": List[
            ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef
        ],
        "Include": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef
):
    pass


_ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientGetSegmentVersionsResponseSegmentsResponseItemDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientGetSegmentVersionsResponseSegmentsResponseItemImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientGetSegmentVersionsResponseSegmentsResponseItemSegmentGroupsTypeDef,
        "SegmentType": Literal["DIMENSIONAL", "IMPORT"],
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.
    """


_ClientGetSegmentVersionsResponseSegmentsResponseTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseSegmentsResponseTypeDef",
    {"Item": List[ClientGetSegmentVersionsResponseSegmentsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetSegmentVersionsResponseSegmentsResponseTypeDef(
    _ClientGetSegmentVersionsResponseSegmentsResponseTypeDef
):
    """
    - **SegmentsResponse** *(dict) --*

      Provides information about all the segments that are associated with an application.
      - **Item** *(list) --*

        An array of responses, one for each segment that's associated with the application (Segments
        resource) or each version of a segment that's associated with the application (Segment
        Versions resource).
        - *(dict) --*

          Provides information about the configuration, dimension, and other settings for a segment.
          - **ApplicationId** *(string) --*

            The unique identifier for the application that the segment is associated with.
    """


_ClientGetSegmentVersionsResponseTypeDef = TypedDict(
    "_ClientGetSegmentVersionsResponseTypeDef",
    {"SegmentsResponse": ClientGetSegmentVersionsResponseSegmentsResponseTypeDef},
    total=False,
)


class ClientGetSegmentVersionsResponseTypeDef(_ClientGetSegmentVersionsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **SegmentsResponse** *(dict) --*

        Provides information about all the segments that are associated with an application.
        - **Item** *(list) --*

          An array of responses, one for each segment that's associated with the application
          (Segments resource) or each version of a segment that's associated with the application
          (Segment Versions resource).
          - *(dict) --*

            Provides information about the configuration, dimension, and other settings for a
            segment.
            - **ApplicationId** *(string) --*

              The unique identifier for the application that the segment is associated with.
    """


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef",
    {"Recency": ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientGetSegmentsResponseSegmentsResponseItemDimensionsAttributesTypeDef
        ],
        "Behavior": ClientGetSegmentsResponseSegmentsResponseItemDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentsResponseSegmentsResponseItemDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentsResponseSegmentsResponseItemDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientGetSegmentsResponseSegmentsResponseItemDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientGetSegmentsResponseSegmentsResponseItemDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": Literal["ALL", "ANY", "NONE"],
        "Type": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef",
    {
        "Groups": List[ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsGroupsTypeDef],
        "Include": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef
):
    pass


_ClientGetSegmentsResponseSegmentsResponseItemTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseItemTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientGetSegmentsResponseSegmentsResponseItemDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientGetSegmentsResponseSegmentsResponseItemImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientGetSegmentsResponseSegmentsResponseItemSegmentGroupsTypeDef,
        "SegmentType": Literal["DIMENSIONAL", "IMPORT"],
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseItemTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.
    """


_ClientGetSegmentsResponseSegmentsResponseTypeDef = TypedDict(
    "_ClientGetSegmentsResponseSegmentsResponseTypeDef",
    {"Item": List[ClientGetSegmentsResponseSegmentsResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientGetSegmentsResponseSegmentsResponseTypeDef(
    _ClientGetSegmentsResponseSegmentsResponseTypeDef
):
    """
    - **SegmentsResponse** *(dict) --*

      Provides information about all the segments that are associated with an application.
      - **Item** *(list) --*

        An array of responses, one for each segment that's associated with the application (Segments
        resource) or each version of a segment that's associated with the application (Segment
        Versions resource).
        - *(dict) --*

          Provides information about the configuration, dimension, and other settings for a segment.
          - **ApplicationId** *(string) --*

            The unique identifier for the application that the segment is associated with.
    """


_ClientGetSegmentsResponseTypeDef = TypedDict(
    "_ClientGetSegmentsResponseTypeDef",
    {"SegmentsResponse": ClientGetSegmentsResponseSegmentsResponseTypeDef},
    total=False,
)


class ClientGetSegmentsResponseTypeDef(_ClientGetSegmentsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **SegmentsResponse** *(dict) --*

        Provides information about all the segments that are associated with an application.
        - **Item** *(list) --*

          An array of responses, one for each segment that's associated with the application
          (Segments resource) or each version of a segment that's associated with the application
          (Segment Versions resource).
          - *(dict) --*

            Provides information about the configuration, dimension, and other settings for a
            segment.
            - **ApplicationId** *(string) --*

              The unique identifier for the application that the segment is associated with.
    """


_ClientGetSmsChannelResponseSMSChannelResponseTypeDef = TypedDict(
    "_ClientGetSmsChannelResponseSMSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "PromotionalMessagesPerSecond": int,
        "SenderId": str,
        "ShortCode": str,
        "TransactionalMessagesPerSecond": int,
        "Version": int,
    },
    total=False,
)


class ClientGetSmsChannelResponseSMSChannelResponseTypeDef(
    _ClientGetSmsChannelResponseSMSChannelResponseTypeDef
):
    """
    - **SMSChannelResponse** *(dict) --*

      Provides information about the status and settings of the SMS channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the SMS channel applies to.
    """


_ClientGetSmsChannelResponseTypeDef = TypedDict(
    "_ClientGetSmsChannelResponseTypeDef",
    {"SMSChannelResponse": ClientGetSmsChannelResponseSMSChannelResponseTypeDef},
    total=False,
)


class ClientGetSmsChannelResponseTypeDef(_ClientGetSmsChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **SMSChannelResponse** *(dict) --*

        Provides information about the status and settings of the SMS channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the SMS channel applies to.
    """


_ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef = TypedDict(
    "_ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef",
    {
        "Arn": str,
        "Body": str,
        "CreationDate": str,
        "DefaultSubstitutions": str,
        "LastModifiedDate": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TemplateName": str,
        "TemplateType": Literal["EMAIL", "SMS", "VOICE", "PUSH"],
    },
    total=False,
)


class ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef(
    _ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef
):
    """
    - **SMSTemplateResponse** *(dict) --*

      Provides information about the content and settings for a message template that can be used in
      text messages that are sent through the SMS channel.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template.
    """


_ClientGetSmsTemplateResponseTypeDef = TypedDict(
    "_ClientGetSmsTemplateResponseTypeDef",
    {"SMSTemplateResponse": ClientGetSmsTemplateResponseSMSTemplateResponseTypeDef},
    total=False,
)


class ClientGetSmsTemplateResponseTypeDef(_ClientGetSmsTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **SMSTemplateResponse** *(dict) --*

        Provides information about the content and settings for a message template that can be used
        in text messages that are sent through the SMS channel.
        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the message template.
    """


_ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef(
    _ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef
):
    pass


_ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef(
    _ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef
):
    pass


_ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef(
    _ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef
):
    pass


_ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef",
    {
        "Address": str,
        "ApplicationId": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": Literal[
            "GCM",
            "APNS",
            "APNS_SANDBOX",
            "APNS_VOIP",
            "APNS_VOIP_SANDBOX",
            "ADM",
            "SMS",
            "VOICE",
            "EMAIL",
            "BAIDU",
            "CUSTOM",
        ],
        "CohortId": str,
        "CreationDate": str,
        "Demographic": ClientGetUserEndpointsResponseEndpointsResponseItemDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Id": str,
        "Location": ClientGetUserEndpointsResponseEndpointsResponseItemLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientGetUserEndpointsResponseEndpointsResponseItemUserTypeDef,
    },
    total=False,
)


class ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef(
    _ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about the channel type and other settings for an endpoint.
      - **Address** *(string) --*

        The destination address for messages or push notifications that you send to the endpoint.
        The address varies by channel. For example, the address for a push-notification channel is
        typically the token provided by a push notification service, such as an Apple Push
        Notification service (APNs) device token or a Firebase Cloud Messaging (FCM) registration
        token. The address for the SMS channel is a phone number in E.164 format, such as
        +12065550100. The address for the email channel is an email address.
    """


_ClientGetUserEndpointsResponseEndpointsResponseTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseEndpointsResponseTypeDef",
    {"Item": List[ClientGetUserEndpointsResponseEndpointsResponseItemTypeDef]},
    total=False,
)


class ClientGetUserEndpointsResponseEndpointsResponseTypeDef(
    _ClientGetUserEndpointsResponseEndpointsResponseTypeDef
):
    """
    - **EndpointsResponse** *(dict) --*

      Provides information about all the endpoints that are associated with a user ID.
      - **Item** *(list) --*

        An array of responses, one for each endpoint that's associated with the user ID.
        - *(dict) --*

          Provides information about the channel type and other settings for an endpoint.
          - **Address** *(string) --*

            The destination address for messages or push notifications that you send to the
            endpoint. The address varies by channel. For example, the address for a
            push-notification channel is typically the token provided by a push notification
            service, such as an Apple Push Notification service (APNs) device token or a Firebase
            Cloud Messaging (FCM) registration token. The address for the SMS channel is a phone
            number in E.164 format, such as +12065550100. The address for the email channel is an
            email address.
    """


_ClientGetUserEndpointsResponseTypeDef = TypedDict(
    "_ClientGetUserEndpointsResponseTypeDef",
    {"EndpointsResponse": ClientGetUserEndpointsResponseEndpointsResponseTypeDef},
    total=False,
)


class ClientGetUserEndpointsResponseTypeDef(_ClientGetUserEndpointsResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **EndpointsResponse** *(dict) --*

        Provides information about all the endpoints that are associated with a user ID.
        - **Item** *(list) --*

          An array of responses, one for each endpoint that's associated with the user ID.
          - *(dict) --*

            Provides information about the channel type and other settings for an endpoint.
            - **Address** *(string) --*

              The destination address for messages or push notifications that you send to the
              endpoint. The address varies by channel. For example, the address for a
              push-notification channel is typically the token provided by a push notification
              service, such as an Apple Push Notification service (APNs) device token or a Firebase
              Cloud Messaging (FCM) registration token. The address for the SMS channel is a phone
              number in E.164 format, such as +12065550100. The address for the email channel is an
              email address.
    """


_ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef = TypedDict(
    "_ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef(
    _ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef
):
    """
    - **VoiceChannelResponse** *(dict) --*

      Provides information about the status and settings of the voice channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the voice channel applies to.
    """


_ClientGetVoiceChannelResponseTypeDef = TypedDict(
    "_ClientGetVoiceChannelResponseTypeDef",
    {"VoiceChannelResponse": ClientGetVoiceChannelResponseVoiceChannelResponseTypeDef},
    total=False,
)


class ClientGetVoiceChannelResponseTypeDef(_ClientGetVoiceChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **VoiceChannelResponse** *(dict) --*

        Provides information about the status and settings of the voice channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the voice channel applies to.
    """


_ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef = TypedDict(
    "_ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef",
    {
        "Arn": str,
        "Body": str,
        "CreationDate": str,
        "DefaultSubstitutions": str,
        "LanguageCode": str,
        "LastModifiedDate": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TemplateName": str,
        "TemplateType": Literal["EMAIL", "SMS", "VOICE", "PUSH"],
        "VoiceId": str,
    },
    total=False,
)


class ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef(
    _ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef
):
    """
    - **VoiceTemplateResponse** *(dict) --*

      Provides information about the content and settings for a message template that can be used in
      messages that are sent through the voice channel.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template.
    """


_ClientGetVoiceTemplateResponseTypeDef = TypedDict(
    "_ClientGetVoiceTemplateResponseTypeDef",
    {"VoiceTemplateResponse": ClientGetVoiceTemplateResponseVoiceTemplateResponseTypeDef},
    total=False,
)


class ClientGetVoiceTemplateResponseTypeDef(_ClientGetVoiceTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **VoiceTemplateResponse** *(dict) --*

        Provides information about the content and settings for a message template that can be used
        in messages that are sent through the voice channel.
        - **Arn** *(string) --*

          The Amazon Resource Name (ARN) of the message template.
    """


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": Literal["ALL", "ANY"],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientListJourneysResponseJourneysResponseItemActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef",
    {
        "Branches": List[
            ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitBranchesTypeDef
        ]
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientListJourneysResponseJourneysResponseItemActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef",
    {
        "ConditionalSplit": ClientListJourneysResponseJourneysResponseItemActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientListJourneysResponseJourneysResponseItemActivitiesEMAILTypeDef,
        "Holdout": ClientListJourneysResponseJourneysResponseItemActivitiesHoldoutTypeDef,
        "MultiCondition": ClientListJourneysResponseJourneysResponseItemActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientListJourneysResponseJourneysResponseItemActivitiesRandomSplitTypeDef,
        "Wait": ClientListJourneysResponseJourneysResponseItemActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef(
    _ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemLimitsTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemLimitsTypeDef(
    _ClientListJourneysResponseJourneysResponseItemLimitsTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef(
    _ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemScheduleTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemScheduleTypeDef(
    _ClientListJourneysResponseJourneysResponseItemScheduleTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientListJourneysResponseJourneysResponseItemStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef(
    _ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef
):
    pass


_ClientListJourneysResponseJourneysResponseItemTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseItemTypeDef",
    {
        "Activities": Dict[str, ClientListJourneysResponseJourneysResponseItemActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientListJourneysResponseJourneysResponseItemLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientListJourneysResponseJourneysResponseItemQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientListJourneysResponseJourneysResponseItemScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientListJourneysResponseJourneysResponseItemStartConditionTypeDef,
        "State": Literal["DRAFT", "ACTIVE", "COMPLETED", "CANCELLED", "CLOSED"],
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientListJourneysResponseJourneysResponseItemTypeDef(
    _ClientListJourneysResponseJourneysResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about the status, configuration, and other settings for a journey.
      - **Activities** *(dict) --*

        The configuration and other settings for the activities that comprise the journey.
        - *(string) --*

          - *(dict) --*

            Specifies the configuration and other settings for an activity in a journey.
            - **ConditionalSplit** *(dict) --*

              The settings for a yes/no split activity. This type of activity sends participants
              down one of two paths in a journey, based on conditions that you specify.
              - **Condition** *(dict) --*

                The conditions that define the paths for the activity, and the relationship between
                the conditions.
                - **Conditions** *(list) --*

                  The conditions to evaluate for the activity.
                  - *(dict) --*

                    Specifies a condition to evaluate for an activity in a journey.
                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.
                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.
                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.
                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.
                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.
    """


_ClientListJourneysResponseJourneysResponseTypeDef = TypedDict(
    "_ClientListJourneysResponseJourneysResponseTypeDef",
    {"Item": List[ClientListJourneysResponseJourneysResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientListJourneysResponseJourneysResponseTypeDef(
    _ClientListJourneysResponseJourneysResponseTypeDef
):
    """
    - **JourneysResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for all the journeys
      that are associated with an application.
      - **Item** *(list) --*

        An array of responses, one for each journey that's associated with the application.
        - *(dict) --*

          Provides information about the status, configuration, and other settings for a journey.
          - **Activities** *(dict) --*

            The configuration and other settings for the activities that comprise the journey.
            - *(string) --*

              - *(dict) --*

                Specifies the configuration and other settings for an activity in a journey.
                - **ConditionalSplit** *(dict) --*

                  The settings for a yes/no split activity. This type of activity sends participants
                  down one of two paths in a journey, based on conditions that you specify.
                  - **Condition** *(dict) --*

                    The conditions that define the paths for the activity, and the relationship
                    between the conditions.
                    - **Conditions** *(list) --*

                      The conditions to evaluate for the activity.
                      - *(dict) --*

                        Specifies a condition to evaluate for an activity in a journey.
                        - **EventCondition** *(dict) --*

                          The dimension settings for the event that's associated with the activity.
                          - **Dimensions** *(dict) --*

                            The dimensions for the event filter to use for the activity.
                            - **Attributes** *(dict) --*

                              One or more custom attributes that your application reports to Amazon
                              Pinpoint. You can use these attributes as selection criteria when you
                              create an event filter.
                              - *(string) --*

                                - *(dict) --*

                                  Specifies attribute-based criteria for including or excluding
                                  endpoints from a segment.
                                  - **AttributeType** *(string) --*

                                    The type of segment dimension to use. Valid values are:
                                    INCLUSIVE, endpoints that match the criteria are included in the
                                    segment; and, EXCLUSIVE, endpoints that match the criteria are
                                    excluded from the segment.
    """


_ClientListJourneysResponseTypeDef = TypedDict(
    "_ClientListJourneysResponseTypeDef",
    {"JourneysResponse": ClientListJourneysResponseJourneysResponseTypeDef},
    total=False,
)


class ClientListJourneysResponseTypeDef(_ClientListJourneysResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **JourneysResponse** *(dict) --*

        Provides information about the status, configuration, and other settings for all the
        journeys that are associated with an application.
        - **Item** *(list) --*

          An array of responses, one for each journey that's associated with the application.
          - *(dict) --*

            Provides information about the status, configuration, and other settings for a journey.
            - **Activities** *(dict) --*

              The configuration and other settings for the activities that comprise the journey.
              - *(string) --*

                - *(dict) --*

                  Specifies the configuration and other settings for an activity in a journey.
                  - **ConditionalSplit** *(dict) --*

                    The settings for a yes/no split activity. This type of activity sends
                    participants down one of two paths in a journey, based on conditions that you
                    specify.
                    - **Condition** *(dict) --*

                      The conditions that define the paths for the activity, and the relationship
                      between the conditions.
                      - **Conditions** *(list) --*

                        The conditions to evaluate for the activity.
                        - *(dict) --*

                          Specifies a condition to evaluate for an activity in a journey.
                          - **EventCondition** *(dict) --*

                            The dimension settings for the event that's associated with the
                            activity.
                            - **Dimensions** *(dict) --*

                              The dimensions for the event filter to use for the activity.
                              - **Attributes** *(dict) --*

                                One or more custom attributes that your application reports to
                                Amazon Pinpoint. You can use these attributes as selection criteria
                                when you create an event filter.
                                - *(string) --*

                                  - *(dict) --*

                                    Specifies attribute-based criteria for including or excluding
                                    endpoints from a segment.
                                    - **AttributeType** *(string) --*

                                      The type of segment dimension to use. Valid values are:
                                      INCLUSIVE, endpoints that match the criteria are included in
                                      the segment; and, EXCLUSIVE, endpoints that match the criteria
                                      are excluded from the segment.
    """


_ClientListTagsForResourceResponseTagsModelTypeDef = TypedDict(
    "_ClientListTagsForResourceResponseTagsModelTypeDef", {"tags": Dict[str, str]}, total=False
)


class ClientListTagsForResourceResponseTagsModelTypeDef(
    _ClientListTagsForResourceResponseTagsModelTypeDef
):
    """
    - **TagsModel** *(dict) --*

      Specifies the tags (keys and values) for an application, campaign, journey, message template,
      or segment.
      - **tags** *(dict) --*

        A string-to-string map of key-value pairs that defines the tags for an application,
        campaign, journey, message template, or segment. Each of these resources can have a maximum
        of 50 tags.
        Each tag consists of a required tag key and an associated tag value. The maximum length of a
        tag key is 128 characters. The maximum length of a tag value is 256 characters.
        - *(string) --*

          - *(string) --*
    """


_ClientListTagsForResourceResponseTypeDef = TypedDict(
    "_ClientListTagsForResourceResponseTypeDef",
    {"TagsModel": ClientListTagsForResourceResponseTagsModelTypeDef},
    total=False,
)


class ClientListTagsForResourceResponseTypeDef(_ClientListTagsForResourceResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **TagsModel** *(dict) --*

        Specifies the tags (keys and values) for an application, campaign, journey, message
        template, or segment.
        - **tags** *(dict) --*

          A string-to-string map of key-value pairs that defines the tags for an application,
          campaign, journey, message template, or segment. Each of these resources can have a
          maximum of 50 tags.
          Each tag consists of a required tag key and an associated tag value. The maximum length of
          a tag key is 128 characters. The maximum length of a tag value is 256 characters.
          - *(string) --*

            - *(string) --*
    """


_ClientListTemplatesResponseTemplatesResponseItemTypeDef = TypedDict(
    "_ClientListTemplatesResponseTemplatesResponseItemTypeDef",
    {
        "Arn": str,
        "CreationDate": str,
        "DefaultSubstitutions": str,
        "LastModifiedDate": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TemplateName": str,
        "TemplateType": Literal["EMAIL", "SMS", "VOICE", "PUSH"],
    },
    total=False,
)


class ClientListTemplatesResponseTemplatesResponseItemTypeDef(
    _ClientListTemplatesResponseTemplatesResponseItemTypeDef
):
    """
    - *(dict) --*

      Provides information about a message template that's associated with your Amazon Pinpoint
      account.
      - **Arn** *(string) --*

        The Amazon Resource Name (ARN) of the message template.
    """


_ClientListTemplatesResponseTemplatesResponseTypeDef = TypedDict(
    "_ClientListTemplatesResponseTemplatesResponseTypeDef",
    {"Item": List[ClientListTemplatesResponseTemplatesResponseItemTypeDef], "NextToken": str},
    total=False,
)


class ClientListTemplatesResponseTemplatesResponseTypeDef(
    _ClientListTemplatesResponseTemplatesResponseTypeDef
):
    """
    - **TemplatesResponse** *(dict) --*

      Provides information about all the message templates that are associated with your Amazon
      Pinpoint account.
      - **Item** *(list) --*

        An array of responses, one for each message template that's associated with your Amazon
        Pinpoint account and meets any filter criteria that you specified in the request.
        - *(dict) --*

          Provides information about a message template that's associated with your Amazon Pinpoint
          account.
          - **Arn** *(string) --*

            The Amazon Resource Name (ARN) of the message template.
    """


_ClientListTemplatesResponseTypeDef = TypedDict(
    "_ClientListTemplatesResponseTypeDef",
    {"TemplatesResponse": ClientListTemplatesResponseTemplatesResponseTypeDef},
    total=False,
)


class ClientListTemplatesResponseTypeDef(_ClientListTemplatesResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **TemplatesResponse** *(dict) --*

        Provides information about all the message templates that are associated with your Amazon
        Pinpoint account.
        - **Item** *(list) --*

          An array of responses, one for each message template that's associated with your Amazon
          Pinpoint account and meets any filter criteria that you specified in the request.
          - *(dict) --*

            Provides information about a message template that's associated with your Amazon
            Pinpoint account.
            - **Arn** *(string) --*

              The Amazon Resource Name (ARN) of the message template.
    """


_ClientPhoneNumberValidateNumberValidateRequestTypeDef = TypedDict(
    "_ClientPhoneNumberValidateNumberValidateRequestTypeDef",
    {"IsoCountryCode": str, "PhoneNumber": str},
    total=False,
)


class ClientPhoneNumberValidateNumberValidateRequestTypeDef(
    _ClientPhoneNumberValidateNumberValidateRequestTypeDef
):
    """
    Specifies a phone number to validate and retrieve information about.
    - **IsoCountryCode** *(string) --*

      The two-character code, in ISO 3166-1 alpha-2 format, for the country or region where the
      phone number was originally registered.
    """


_ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef = TypedDict(
    "_ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef",
    {
        "Carrier": str,
        "City": str,
        "CleansedPhoneNumberE164": str,
        "CleansedPhoneNumberNational": str,
        "Country": str,
        "CountryCodeIso2": str,
        "CountryCodeNumeric": str,
        "County": str,
        "OriginalCountryCodeIso2": str,
        "OriginalPhoneNumber": str,
        "PhoneType": str,
        "PhoneTypeCode": int,
        "Timezone": str,
        "ZipCode": str,
    },
    total=False,
)


class ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef(
    _ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef
):
    """
    - **NumberValidateResponse** *(dict) --*

      Provides information about a phone number.
      - **Carrier** *(string) --*

        The carrier or service provider that the phone number is currently registered with. In some
        countries and regions, this value may be the carrier or service provider that the phone
        number was originally registered with.
    """


_ClientPhoneNumberValidateResponseTypeDef = TypedDict(
    "_ClientPhoneNumberValidateResponseTypeDef",
    {"NumberValidateResponse": ClientPhoneNumberValidateResponseNumberValidateResponseTypeDef},
    total=False,
)


class ClientPhoneNumberValidateResponseTypeDef(_ClientPhoneNumberValidateResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **NumberValidateResponse** *(dict) --*

        Provides information about a phone number.
        - **Carrier** *(string) --*

          The carrier or service provider that the phone number is currently registered with. In
          some countries and regions, this value may be the carrier or service provider that the
          phone number was originally registered with.
    """


_ClientPutEventStreamResponseEventStreamTypeDef = TypedDict(
    "_ClientPutEventStreamResponseEventStreamTypeDef",
    {
        "ApplicationId": str,
        "DestinationStreamArn": str,
        "ExternalId": str,
        "LastModifiedDate": str,
        "LastUpdatedBy": str,
        "RoleArn": str,
    },
    total=False,
)


class ClientPutEventStreamResponseEventStreamTypeDef(
    _ClientPutEventStreamResponseEventStreamTypeDef
):
    """
    - **EventStream** *(dict) --*

      Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
      Kinesis Data Firehose delivery stream.
      - **ApplicationId** *(string) --*

        The unique identifier for the application to publish event data for.
    """


_ClientPutEventStreamResponseTypeDef = TypedDict(
    "_ClientPutEventStreamResponseTypeDef",
    {"EventStream": ClientPutEventStreamResponseEventStreamTypeDef},
    total=False,
)


class ClientPutEventStreamResponseTypeDef(_ClientPutEventStreamResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **EventStream** *(dict) --*

        Specifies settings for publishing event data to an Amazon Kinesis data stream or an Amazon
        Kinesis Data Firehose delivery stream.
        - **ApplicationId** *(string) --*

          The unique identifier for the application to publish event data for.
    """


_RequiredClientPutEventStreamWriteEventStreamTypeDef = TypedDict(
    "_RequiredClientPutEventStreamWriteEventStreamTypeDef", {"DestinationStreamArn": str}
)
_OptionalClientPutEventStreamWriteEventStreamTypeDef = TypedDict(
    "_OptionalClientPutEventStreamWriteEventStreamTypeDef", {"RoleArn": str}, total=False
)


class ClientPutEventStreamWriteEventStreamTypeDef(
    _RequiredClientPutEventStreamWriteEventStreamTypeDef,
    _OptionalClientPutEventStreamWriteEventStreamTypeDef,
):
    """
    Specifies the Amazon Resource Name (ARN) of an event stream to publish events to and the AWS
    Identity and Access Management (IAM) role to use when publishing those events.
    - **DestinationStreamArn** *(string) --***[REQUIRED]**

      The Amazon Resource Name (ARN) of the Amazon Kinesis data stream or Amazon Kinesis Data
      Firehose delivery stream that you want to publish event data to.
      For a Kinesis data stream, the ARN format is:
      arn:aws:kinesis:region:account-id:stream/stream_name
      For a Kinesis Data Firehose delivery stream, the ARN format is:
      arn:aws:firehose:region:account-id:deliverystream/stream_name
    """


_ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef(
    _ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef
):
    pass


_ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef(
    _ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef
):
    pass


_ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef(
    _ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef
):
    pass


_ClientPutEventsEventsRequestBatchItemEndpointTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemEndpointTypeDef",
    {
        "Address": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": Literal[
            "GCM",
            "APNS",
            "APNS_SANDBOX",
            "APNS_VOIP",
            "APNS_VOIP_SANDBOX",
            "ADM",
            "SMS",
            "VOICE",
            "EMAIL",
            "BAIDU",
            "CUSTOM",
        ],
        "Demographic": ClientPutEventsEventsRequestBatchItemEndpointDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Location": ClientPutEventsEventsRequestBatchItemEndpointLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientPutEventsEventsRequestBatchItemEndpointUserTypeDef,
    },
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEndpointTypeDef(
    _ClientPutEventsEventsRequestBatchItemEndpointTypeDef
):
    pass


_ClientPutEventsEventsRequestBatchItemEventsSessionTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemEventsSessionTypeDef",
    {"Duration": int, "Id": str, "StartTimestamp": str, "StopTimestamp": str},
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEventsSessionTypeDef(
    _ClientPutEventsEventsRequestBatchItemEventsSessionTypeDef
):
    pass


_ClientPutEventsEventsRequestBatchItemEventsTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemEventsTypeDef",
    {
        "AppPackageName": str,
        "AppTitle": str,
        "AppVersionCode": str,
        "Attributes": Dict[str, str],
        "ClientSdkVersion": str,
        "EventType": str,
        "Metrics": Dict[str, float],
        "SdkName": str,
        "Session": ClientPutEventsEventsRequestBatchItemEventsSessionTypeDef,
        "Timestamp": str,
    },
    total=False,
)


class ClientPutEventsEventsRequestBatchItemEventsTypeDef(
    _ClientPutEventsEventsRequestBatchItemEventsTypeDef
):
    pass


_ClientPutEventsEventsRequestBatchItemTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestBatchItemTypeDef",
    {
        "Endpoint": ClientPutEventsEventsRequestBatchItemEndpointTypeDef,
        "Events": Dict[str, ClientPutEventsEventsRequestBatchItemEventsTypeDef],
    },
    total=False,
)


class ClientPutEventsEventsRequestBatchItemTypeDef(_ClientPutEventsEventsRequestBatchItemTypeDef):
    pass


_ClientPutEventsEventsRequestTypeDef = TypedDict(
    "_ClientPutEventsEventsRequestTypeDef",
    {"BatchItem": Dict[str, ClientPutEventsEventsRequestBatchItemTypeDef]},
)


class ClientPutEventsEventsRequestTypeDef(_ClientPutEventsEventsRequestTypeDef):
    """
    Specifies a batch of events to process.
    - **BatchItem** *(dict) --***[REQUIRED]**

      The batch of events to process. For each item in a batch, the endpoint ID acts as a key that
      has an EventsBatch object as its value.
      - *(string) --*

        - *(dict) --*

          Specifies a batch of endpoints and events to process.
          - **Endpoint** *(dict) --***[REQUIRED]**

            A set of properties and attributes that are associated with the endpoint.
            - **Address** *(string) --*

              The unique identifier for the recipient, such as a device token, email address, or
              mobile phone number.
    """


_ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef = TypedDict(
    "_ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef",
    {"Message": str, "StatusCode": int},
    total=False,
)


class ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef(
    _ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef
):
    pass


_ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef = TypedDict(
    "_ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef",
    {"Message": str, "StatusCode": int},
    total=False,
)


class ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef(
    _ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef
):
    pass


_ClientPutEventsResponseEventsResponseResultsTypeDef = TypedDict(
    "_ClientPutEventsResponseEventsResponseResultsTypeDef",
    {
        "EndpointItemResponse": ClientPutEventsResponseEventsResponseResultsEndpointItemResponseTypeDef,
        "EventsItemResponse": Dict[
            str, ClientPutEventsResponseEventsResponseResultsEventsItemResponseTypeDef
        ],
    },
    total=False,
)


class ClientPutEventsResponseEventsResponseResultsTypeDef(
    _ClientPutEventsResponseEventsResponseResultsTypeDef
):
    pass


_ClientPutEventsResponseEventsResponseTypeDef = TypedDict(
    "_ClientPutEventsResponseEventsResponseTypeDef",
    {"Results": Dict[str, ClientPutEventsResponseEventsResponseResultsTypeDef]},
    total=False,
)


class ClientPutEventsResponseEventsResponseTypeDef(_ClientPutEventsResponseEventsResponseTypeDef):
    """
    - **EventsResponse** *(dict) --*

      Provides information about endpoints and the events that they're associated with.
      - **Results** *(dict) --*

        A map that contains a multipart response for each endpoint. For each item in this object,
        the endpoint ID is the key and the item response is the value. If no item response exists,
        the value can also be one of the following: 202, the request was processed successfully; or
        400, the payload wasn't valid or required fields were missing.
        - *(string) --*

          - *(dict) --*

            Provides information about the results of a request to create or update an endpoint
            that's associated with an event.
            - **EndpointItemResponse** *(dict) --*

              The response that was received after the endpoint data was accepted.
              - **Message** *(string) --*

                The custom message that's returned in the response as a result of processing the
                endpoint data.
    """


_ClientPutEventsResponseTypeDef = TypedDict(
    "_ClientPutEventsResponseTypeDef",
    {"EventsResponse": ClientPutEventsResponseEventsResponseTypeDef},
    total=False,
)


class ClientPutEventsResponseTypeDef(_ClientPutEventsResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **EventsResponse** *(dict) --*

        Provides information about endpoints and the events that they're associated with.
        - **Results** *(dict) --*

          A map that contains a multipart response for each endpoint. For each item in this object,
          the endpoint ID is the key and the item response is the value. If no item response exists,
          the value can also be one of the following: 202, the request was processed successfully;
          or 400, the payload wasn't valid or required fields were missing.
          - *(string) --*

            - *(dict) --*

              Provides information about the results of a request to create or update an endpoint
              that's associated with an event.
              - **EndpointItemResponse** *(dict) --*

                The response that was received after the endpoint data was accepted.
                - **Message** *(string) --*

                  The custom message that's returned in the response as a result of processing the
                  endpoint data.
    """


_ClientRemoveAttributesResponseAttributesResourceTypeDef = TypedDict(
    "_ClientRemoveAttributesResponseAttributesResourceTypeDef",
    {"ApplicationId": str, "AttributeType": str, "Attributes": List[str]},
    total=False,
)


class ClientRemoveAttributesResponseAttributesResourceTypeDef(
    _ClientRemoveAttributesResponseAttributesResourceTypeDef
):
    """
    - **AttributesResource** *(dict) --*

      Provides information about the type and the names of attributes that were removed from all the
      endpoints that are associated with an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application.
    """


_ClientRemoveAttributesResponseTypeDef = TypedDict(
    "_ClientRemoveAttributesResponseTypeDef",
    {"AttributesResource": ClientRemoveAttributesResponseAttributesResourceTypeDef},
    total=False,
)


class ClientRemoveAttributesResponseTypeDef(_ClientRemoveAttributesResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **AttributesResource** *(dict) --*

        Provides information about the type and the names of attributes that were removed from all
        the endpoints that are associated with an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application.
    """


_ClientRemoveAttributesUpdateAttributesRequestTypeDef = TypedDict(
    "_ClientRemoveAttributesUpdateAttributesRequestTypeDef", {"Blacklist": List[str]}, total=False
)


class ClientRemoveAttributesUpdateAttributesRequestTypeDef(
    _ClientRemoveAttributesUpdateAttributesRequestTypeDef
):
    """
    Specifies one or more attributes to remove from all the endpoints that are associated with an
    application.
    - **Blacklist** *(list) --*

      An array of the attributes to remove from all the endpoints that are associated with the
      application. The array can specify the complete, exact name of each attribute to remove or it
      can specify a glob pattern that an attribute name must match in order for the attribute to be
      removed.
      - *(string) --*
    """


_ClientSendMessagesMessageRequestAddressesTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestAddressesTypeDef",
    {
        "BodyOverride": str,
        "ChannelType": Literal[
            "GCM",
            "APNS",
            "APNS_SANDBOX",
            "APNS_VOIP",
            "APNS_VOIP_SANDBOX",
            "ADM",
            "SMS",
            "VOICE",
            "EMAIL",
            "BAIDU",
            "CUSTOM",
        ],
        "Context": Dict[str, str],
        "RawContent": str,
        "Substitutions": Dict[str, List[str]],
        "TitleOverride": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestAddressesTypeDef(
    _ClientSendMessagesMessageRequestAddressesTypeDef
):
    pass


_ClientSendMessagesMessageRequestEndpointsTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestEndpointsTypeDef",
    {
        "BodyOverride": str,
        "Context": Dict[str, str],
        "RawContent": str,
        "Substitutions": Dict[str, List[str]],
        "TitleOverride": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestEndpointsTypeDef(
    _ClientSendMessagesMessageRequestEndpointsTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ConsolidationKey": str,
        "Data": Dict[str, str],
        "ExpiresAfter": str,
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "MD5": str,
        "RawContent": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef",
    {
        "APNSPushType": str,
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Badge": int,
        "Body": str,
        "Category": str,
        "CollapseId": str,
        "Data": Dict[str, str],
        "MediaUrl": str,
        "PreferredAuthenticationMethod": str,
        "Priority": str,
        "RawContent": str,
        "SilentPush": bool,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "ThreadId": str,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "Data": Dict[str, str],
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef",
    {"Body": str, "Substitutions": Dict[str, List[str]]},
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "Data": Dict[str, str],
        "SilentPush": bool,
        "Substitutions": Dict[str, List[str]],
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef",
    {"Data": bytes},
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef",
    {
        "HtmlPart": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef,
        "Subject": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef,
        "TextPart": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef",
    {
        "Body": str,
        "FeedbackForwardingAddress": str,
        "FromAddress": str,
        "RawEmail": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef,
        "ReplyToAddresses": List[str],
        "SimpleEmail": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef,
        "Substitutions": Dict[str, List[str]],
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "CollapseKey": str,
        "Data": Dict[str, str],
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "Priority": str,
        "RawContent": str,
        "RestrictedPackageName": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef",
    {
        "Body": str,
        "Keyword": str,
        "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"],
        "OriginationNumber": str,
        "SenderId": str,
        "Substitutions": Dict[str, List[str]],
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef",
    {
        "Body": str,
        "LanguageCode": str,
        "OriginationNumber": str,
        "Substitutions": Dict[str, List[str]],
        "VoiceId": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef
):
    pass


_ClientSendMessagesMessageRequestMessageConfigurationTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientSendMessagesMessageRequestMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientSendMessagesMessageRequestMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientSendMessagesMessageRequestMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientSendMessagesMessageRequestMessageConfigurationDefaultMessageTypeDef,
        "DefaultPushNotificationMessage": ClientSendMessagesMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef,
        "EmailMessage": ClientSendMessagesMessageRequestMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientSendMessagesMessageRequestMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientSendMessagesMessageRequestMessageConfigurationSMSMessageTypeDef,
        "VoiceMessage": ClientSendMessagesMessageRequestMessageConfigurationVoiceMessageTypeDef,
    },
    total=False,
)


class ClientSendMessagesMessageRequestMessageConfigurationTypeDef(
    _ClientSendMessagesMessageRequestMessageConfigurationTypeDef
):
    pass


_ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef(
    _ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef(
    _ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef(
    _ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef(
    _ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientSendMessagesMessageRequestTemplateConfigurationTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientSendMessagesMessageRequestTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientSendMessagesMessageRequestTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientSendMessagesMessageRequestTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientSendMessagesMessageRequestTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientSendMessagesMessageRequestTemplateConfigurationTypeDef(
    _ClientSendMessagesMessageRequestTemplateConfigurationTypeDef
):
    pass


_ClientSendMessagesMessageRequestTypeDef = TypedDict(
    "_ClientSendMessagesMessageRequestTypeDef",
    {
        "Addresses": Dict[str, ClientSendMessagesMessageRequestAddressesTypeDef],
        "Context": Dict[str, str],
        "Endpoints": Dict[str, ClientSendMessagesMessageRequestEndpointsTypeDef],
        "MessageConfiguration": ClientSendMessagesMessageRequestMessageConfigurationTypeDef,
        "TemplateConfiguration": ClientSendMessagesMessageRequestTemplateConfigurationTypeDef,
        "TraceId": str,
    },
    total=False,
)


class ClientSendMessagesMessageRequestTypeDef(_ClientSendMessagesMessageRequestTypeDef):
    """
    Specifies the configuration and other settings for a message.
    - **Addresses** *(dict) --*

      A map of key-value pairs, where each key is an address and each value is an
      AddressConfiguration object. An address can be a push notification token, a phone number, or
      an email address. You can use an AddressConfiguration object to tailor the message for an
      address by specifying settings such as content overrides and message variables.
      - *(string) --*

        - *(dict) --*

          Specifies address-based configuration settings for a message that's sent directly to an
          endpoint.
          - **BodyOverride** *(string) --*

            The message body to use instead of the default message body. This value overrides the
            default message body.
    """


_ClientSendMessagesResponseMessageResponseEndpointResultTypeDef = TypedDict(
    "_ClientSendMessagesResponseMessageResponseEndpointResultTypeDef",
    {
        "Address": str,
        "DeliveryStatus": Literal[
            "SUCCESSFUL",
            "THROTTLED",
            "TEMPORARY_FAILURE",
            "PERMANENT_FAILURE",
            "UNKNOWN_FAILURE",
            "OPT_OUT",
            "DUPLICATE",
        ],
        "MessageId": str,
        "StatusCode": int,
        "StatusMessage": str,
        "UpdatedToken": str,
    },
    total=False,
)


class ClientSendMessagesResponseMessageResponseEndpointResultTypeDef(
    _ClientSendMessagesResponseMessageResponseEndpointResultTypeDef
):
    pass


_ClientSendMessagesResponseMessageResponseResultTypeDef = TypedDict(
    "_ClientSendMessagesResponseMessageResponseResultTypeDef",
    {
        "DeliveryStatus": Literal[
            "SUCCESSFUL",
            "THROTTLED",
            "TEMPORARY_FAILURE",
            "PERMANENT_FAILURE",
            "UNKNOWN_FAILURE",
            "OPT_OUT",
            "DUPLICATE",
        ],
        "MessageId": str,
        "StatusCode": int,
        "StatusMessage": str,
        "UpdatedToken": str,
    },
    total=False,
)


class ClientSendMessagesResponseMessageResponseResultTypeDef(
    _ClientSendMessagesResponseMessageResponseResultTypeDef
):
    pass


_ClientSendMessagesResponseMessageResponseTypeDef = TypedDict(
    "_ClientSendMessagesResponseMessageResponseTypeDef",
    {
        "ApplicationId": str,
        "EndpointResult": Dict[str, ClientSendMessagesResponseMessageResponseEndpointResultTypeDef],
        "RequestId": str,
        "Result": Dict[str, ClientSendMessagesResponseMessageResponseResultTypeDef],
    },
    total=False,
)


class ClientSendMessagesResponseMessageResponseTypeDef(
    _ClientSendMessagesResponseMessageResponseTypeDef
):
    """
    - **MessageResponse** *(dict) --*

      Provides information about the results of a request to send a message to an endpoint address.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that was used to send the message.
    """


_ClientSendMessagesResponseTypeDef = TypedDict(
    "_ClientSendMessagesResponseTypeDef",
    {"MessageResponse": ClientSendMessagesResponseMessageResponseTypeDef},
    total=False,
)


class ClientSendMessagesResponseTypeDef(_ClientSendMessagesResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **MessageResponse** *(dict) --*

        Provides information about the results of a request to send a message to an endpoint
        address.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that was used to send the message.
    """


_ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef = TypedDict(
    "_ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef",
    {
        "Address": str,
        "DeliveryStatus": Literal[
            "SUCCESSFUL",
            "THROTTLED",
            "TEMPORARY_FAILURE",
            "PERMANENT_FAILURE",
            "UNKNOWN_FAILURE",
            "OPT_OUT",
            "DUPLICATE",
        ],
        "MessageId": str,
        "StatusCode": int,
        "StatusMessage": str,
        "UpdatedToken": str,
    },
    total=False,
)


class ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef(
    _ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef
):
    pass


_ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef = TypedDict(
    "_ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef",
    {
        "ApplicationId": str,
        "RequestId": str,
        "Result": Dict[
            str, Dict[str, ClientSendUsersMessagesResponseSendUsersMessageResponseResultTypeDef]
        ],
    },
    total=False,
)


class ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef(
    _ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef
):
    """
    - **SendUsersMessageResponse** *(dict) --*

      Provides information about which users and endpoints a message was sent to.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that was used to send the message.
    """


_ClientSendUsersMessagesResponseTypeDef = TypedDict(
    "_ClientSendUsersMessagesResponseTypeDef",
    {"SendUsersMessageResponse": ClientSendUsersMessagesResponseSendUsersMessageResponseTypeDef},
    total=False,
)


class ClientSendUsersMessagesResponseTypeDef(_ClientSendUsersMessagesResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **SendUsersMessageResponse** *(dict) --*

        Provides information about which users and endpoints a message was sent to.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that was used to send the message.
    """


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ConsolidationKey": str,
        "Data": Dict[str, str],
        "ExpiresAfter": str,
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "MD5": str,
        "RawContent": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef",
    {
        "APNSPushType": str,
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Badge": int,
        "Body": str,
        "Category": str,
        "CollapseId": str,
        "Data": Dict[str, str],
        "MediaUrl": str,
        "PreferredAuthenticationMethod": str,
        "Priority": str,
        "RawContent": str,
        "SilentPush": bool,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "ThreadId": str,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "Data": Dict[str, str],
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef",
    {"Body": str, "Substitutions": Dict[str, List[str]]},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "Data": Dict[str, str],
        "SilentPush": bool,
        "Substitutions": Dict[str, List[str]],
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef",
    {"Data": bytes},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef",
    {"Charset": str, "Data": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef",
    {
        "HtmlPart": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailHtmlPartTypeDef,
        "Subject": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailSubjectTypeDef,
        "TextPart": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTextPartTypeDef,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef",
    {
        "Body": str,
        "FeedbackForwardingAddress": str,
        "FromAddress": str,
        "RawEmail": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageRawEmailTypeDef,
        "ReplyToAddresses": List[str],
        "SimpleEmail": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageSimpleEmailTypeDef,
        "Substitutions": Dict[str, List[str]],
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "CollapseKey": str,
        "Data": Dict[str, str],
        "IconReference": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "Priority": str,
        "RawContent": str,
        "RestrictedPackageName": str,
        "SilentPush": bool,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Substitutions": Dict[str, List[str]],
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef",
    {
        "Body": str,
        "Keyword": str,
        "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"],
        "OriginationNumber": str,
        "SenderId": str,
        "Substitutions": Dict[str, List[str]],
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef",
    {
        "Body": str,
        "LanguageCode": str,
        "OriginationNumber": str,
        "Substitutions": Dict[str, List[str]],
        "VoiceId": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultMessageTypeDef,
        "DefaultPushNotificationMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationDefaultPushNotificationMessageTypeDef,
        "EmailMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationSMSMessageTypeDef,
        "VoiceMessage": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationVoiceMessageTypeDef,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef",
    {
        "BodyOverride": str,
        "Context": Dict[str, str],
        "RawContent": str,
        "Substitutions": Dict[str, List[str]],
        "TitleOverride": str,
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef
):
    pass


_ClientSendUsersMessagesSendUsersMessageRequestTypeDef = TypedDict(
    "_ClientSendUsersMessagesSendUsersMessageRequestTypeDef",
    {
        "Context": Dict[str, str],
        "MessageConfiguration": ClientSendUsersMessagesSendUsersMessageRequestMessageConfigurationTypeDef,
        "TemplateConfiguration": ClientSendUsersMessagesSendUsersMessageRequestTemplateConfigurationTypeDef,
        "TraceId": str,
        "Users": Dict[str, ClientSendUsersMessagesSendUsersMessageRequestUsersTypeDef],
    },
    total=False,
)


class ClientSendUsersMessagesSendUsersMessageRequestTypeDef(
    _ClientSendUsersMessagesSendUsersMessageRequestTypeDef
):
    """
    Specifies the configuration and other settings for a message to send to all the endpoints that
    are associated with a list of users.
    - **Context** *(dict) --*

      A map of custom attribute-value pairs. For a push notification, Amazon Pinpoint adds these
      attributes to the data.pinpoint object in the body of the notification payload. Amazon
      Pinpoint also provides these attributes in the events that it generates for users-messages
      deliveries.
      - *(string) --*

        - *(string) --*
    """


_ClientTagResourceTagsModelTypeDef = TypedDict(
    "_ClientTagResourceTagsModelTypeDef", {"tags": Dict[str, str]}
)


class ClientTagResourceTagsModelTypeDef(_ClientTagResourceTagsModelTypeDef):
    """
    Specifies the tags (keys and values) for an application, campaign, journey, message template, or
    segment.
    - **tags** *(dict) --***[REQUIRED]**

      A string-to-string map of key-value pairs that defines the tags for an application, campaign,
      journey, message template, or segment. Each of these resources can have a maximum of 50 tags.
      Each tag consists of a required tag key and an associated tag value. The maximum length of a
      tag key is 128 characters. The maximum length of a tag value is 256 characters.
      - *(string) --*

        - *(string) --*
    """


_RequiredClientUpdateAdmChannelADMChannelRequestTypeDef = TypedDict(
    "_RequiredClientUpdateAdmChannelADMChannelRequestTypeDef", {"ClientId": str}
)
_OptionalClientUpdateAdmChannelADMChannelRequestTypeDef = TypedDict(
    "_OptionalClientUpdateAdmChannelADMChannelRequestTypeDef",
    {"ClientSecret": str, "Enabled": bool},
    total=False,
)


class ClientUpdateAdmChannelADMChannelRequestTypeDef(
    _RequiredClientUpdateAdmChannelADMChannelRequestTypeDef,
    _OptionalClientUpdateAdmChannelADMChannelRequestTypeDef,
):
    """
    Specifies the status and settings of the ADM (Amazon Device Messaging) channel for an
    application.
    - **ClientId** *(string) --***[REQUIRED]**

      The Client ID that you received from Amazon to send messages by using ADM.
    """


_ClientUpdateAdmChannelResponseADMChannelResponseTypeDef = TypedDict(
    "_ClientUpdateAdmChannelResponseADMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateAdmChannelResponseADMChannelResponseTypeDef(
    _ClientUpdateAdmChannelResponseADMChannelResponseTypeDef
):
    """
    - **ADMChannelResponse** *(dict) --*

      Provides information about the status and settings of the ADM (Amazon Device Messaging)
      channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the ADM channel applies to.
    """


_ClientUpdateAdmChannelResponseTypeDef = TypedDict(
    "_ClientUpdateAdmChannelResponseTypeDef",
    {"ADMChannelResponse": ClientUpdateAdmChannelResponseADMChannelResponseTypeDef},
    total=False,
)


class ClientUpdateAdmChannelResponseTypeDef(_ClientUpdateAdmChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **ADMChannelResponse** *(dict) --*

        Provides information about the status and settings of the ADM (Amazon Device Messaging)
        channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the ADM channel applies to.
    """


_ClientUpdateApnsChannelAPNSChannelRequestTypeDef = TypedDict(
    "_ClientUpdateApnsChannelAPNSChannelRequestTypeDef",
    {
        "BundleId": str,
        "Certificate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "PrivateKey": str,
        "TeamId": str,
        "TokenKey": str,
        "TokenKeyId": str,
    },
    total=False,
)


class ClientUpdateApnsChannelAPNSChannelRequestTypeDef(
    _ClientUpdateApnsChannelAPNSChannelRequestTypeDef
):
    """
    Specifies the status and settings of the APNs (Apple Push Notification service) channel for an
    application.
    - **BundleId** *(string) --*

      The bundle identifier that's assigned to your iOS app. This identifier is used for APNs
      tokens.
    """


_ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef(
    _ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef
):
    """
    - **APNSChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs channel applies to.
    """


_ClientUpdateApnsChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsChannelResponseTypeDef",
    {"APNSChannelResponse": ClientUpdateApnsChannelResponseAPNSChannelResponseTypeDef},
    total=False,
)


class ClientUpdateApnsChannelResponseTypeDef(_ClientUpdateApnsChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs channel applies to.
    """


_ClientUpdateApnsSandboxChannelAPNSSandboxChannelRequestTypeDef = TypedDict(
    "_ClientUpdateApnsSandboxChannelAPNSSandboxChannelRequestTypeDef",
    {
        "BundleId": str,
        "Certificate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "PrivateKey": str,
        "TeamId": str,
        "TokenKey": str,
        "TokenKeyId": str,
    },
    total=False,
)


class ClientUpdateApnsSandboxChannelAPNSSandboxChannelRequestTypeDef(
    _ClientUpdateApnsSandboxChannelAPNSSandboxChannelRequestTypeDef
):
    """
    Specifies the status and settings of the APNs (Apple Push Notification service) sandbox channel
    for an application.
    - **BundleId** *(string) --*

      The bundle identifier that's assigned to your iOS app. This identifier is used for APNs
      tokens.
    """


_ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef(
    _ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
):
    """
    - **APNSSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) sandbox channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs sandbox channel applies to.
    """


_ClientUpdateApnsSandboxChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsSandboxChannelResponseTypeDef",
    {
        "APNSSandboxChannelResponse": ClientUpdateApnsSandboxChannelResponseAPNSSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientUpdateApnsSandboxChannelResponseTypeDef(_ClientUpdateApnsSandboxChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSSandboxChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) sandbox channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs sandbox channel applies to.
    """


_ClientUpdateApnsVoipChannelAPNSVoipChannelRequestTypeDef = TypedDict(
    "_ClientUpdateApnsVoipChannelAPNSVoipChannelRequestTypeDef",
    {
        "BundleId": str,
        "Certificate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "PrivateKey": str,
        "TeamId": str,
        "TokenKey": str,
        "TokenKeyId": str,
    },
    total=False,
)


class ClientUpdateApnsVoipChannelAPNSVoipChannelRequestTypeDef(
    _ClientUpdateApnsVoipChannelAPNSVoipChannelRequestTypeDef
):
    """
    Specifies the status and settings of the APNs (Apple Push Notification service) VoIP channel for
    an application.
    - **BundleId** *(string) --*

      The bundle identifier that's assigned to your iOS app. This identifier is used for APNs
      tokens.
    """


_ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef(
    _ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef
):
    """
    - **APNSVoipChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP channel applies to.
    """


_ClientUpdateApnsVoipChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsVoipChannelResponseTypeDef",
    {"APNSVoipChannelResponse": ClientUpdateApnsVoipChannelResponseAPNSVoipChannelResponseTypeDef},
    total=False,
)


class ClientUpdateApnsVoipChannelResponseTypeDef(_ClientUpdateApnsVoipChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSVoipChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) VoIP channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs VoIP channel applies to.
    """


_ClientUpdateApnsVoipSandboxChannelAPNSVoipSandboxChannelRequestTypeDef = TypedDict(
    "_ClientUpdateApnsVoipSandboxChannelAPNSVoipSandboxChannelRequestTypeDef",
    {
        "BundleId": str,
        "Certificate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "PrivateKey": str,
        "TeamId": str,
        "TokenKey": str,
        "TokenKeyId": str,
    },
    total=False,
)


class ClientUpdateApnsVoipSandboxChannelAPNSVoipSandboxChannelRequestTypeDef(
    _ClientUpdateApnsVoipSandboxChannelAPNSVoipSandboxChannelRequestTypeDef
):
    """
    Specifies the status and settings of the APNs (Apple Push Notification service) VoIP sandbox
    channel for an application.
    - **BundleId** *(string) --*

      The bundle identifier that's assigned to your iOS app. This identifier is used for APNs
      tokens.
    """


_ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "DefaultAuthenticationMethod": str,
        "Enabled": bool,
        "HasCredential": bool,
        "HasTokenKey": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef(
    _ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
):
    """
    - **APNSVoipSandboxChannelResponse** *(dict) --*

      Provides information about the status and settings of the APNs (Apple Push Notification
      service) VoIP sandbox channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the APNs VoIP sandbox channel applies to.
    """


_ClientUpdateApnsVoipSandboxChannelResponseTypeDef = TypedDict(
    "_ClientUpdateApnsVoipSandboxChannelResponseTypeDef",
    {
        "APNSVoipSandboxChannelResponse": ClientUpdateApnsVoipSandboxChannelResponseAPNSVoipSandboxChannelResponseTypeDef
    },
    total=False,
)


class ClientUpdateApnsVoipSandboxChannelResponseTypeDef(
    _ClientUpdateApnsVoipSandboxChannelResponseTypeDef
):
    """
    - *(dict) --*

      The request succeeded.
      - **APNSVoipSandboxChannelResponse** *(dict) --*

        Provides information about the status and settings of the APNs (Apple Push Notification
        service) VoIP sandbox channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the APNs VoIP sandbox channel applies to.
    """


_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef(
    _ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef
):
    pass


_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef(
    _ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef
):
    pass


_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef(
    _ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef
):
    pass


_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef",
    {
        "ApplicationId": str,
        "CampaignHook": ClientUpdateApplicationSettingsResponseApplicationSettingsResourceCampaignHookTypeDef,
        "LastModifiedDate": str,
        "Limits": ClientUpdateApplicationSettingsResponseApplicationSettingsResourceLimitsTypeDef,
        "QuietTime": ClientUpdateApplicationSettingsResponseApplicationSettingsResourceQuietTimeTypeDef,
    },
    total=False,
)


class ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef(
    _ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef
):
    """
    - **ApplicationSettingsResource** *(dict) --*

      Provides information about an application, including the default settings for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application. This identifier is displayed as the **Project
        ID** on the Amazon Pinpoint console.
    """


_ClientUpdateApplicationSettingsResponseTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsResponseTypeDef",
    {
        "ApplicationSettingsResource": ClientUpdateApplicationSettingsResponseApplicationSettingsResourceTypeDef
    },
    total=False,
)


class ClientUpdateApplicationSettingsResponseTypeDef(
    _ClientUpdateApplicationSettingsResponseTypeDef
):
    """
    - *(dict) --*

      The request succeeded.
      - **ApplicationSettingsResource** *(dict) --*

        Provides information about an application, including the default settings for an
        application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application. This identifier is displayed as the **Project
          ID** on the Amazon Pinpoint console.
    """


_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef(
    _ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef
):
    """
    - **CampaignHook** *(dict) --*

      The settings for the AWS Lambda function to use by default as a code hook for campaigns in the
      application. To override these settings for a specific campaign, use the Campaignresource to
      define custom Lambda function settings for the campaign.
      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.
    """


_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef(
    _ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef
):
    pass


_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef(
    _ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef
):
    pass


_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestTypeDef = TypedDict(
    "_ClientUpdateApplicationSettingsWriteApplicationSettingsRequestTypeDef",
    {
        "CampaignHook": ClientUpdateApplicationSettingsWriteApplicationSettingsRequestCampaignHookTypeDef,
        "CloudWatchMetricsEnabled": bool,
        "Limits": ClientUpdateApplicationSettingsWriteApplicationSettingsRequestLimitsTypeDef,
        "QuietTime": ClientUpdateApplicationSettingsWriteApplicationSettingsRequestQuietTimeTypeDef,
    },
    total=False,
)


class ClientUpdateApplicationSettingsWriteApplicationSettingsRequestTypeDef(
    _ClientUpdateApplicationSettingsWriteApplicationSettingsRequestTypeDef
):
    """
    Specifies the default settings for an application.
    - **CampaignHook** *(dict) --*

      The settings for the AWS Lambda function to use by default as a code hook for campaigns in the
      application. To override these settings for a specific campaign, use the Campaignresource to
      define custom Lambda function settings for the campaign.
      - **LambdaFunctionName** *(string) --*

        The name or Amazon Resource Name (ARN) of the AWS Lambda function that Amazon Pinpoint
        invokes to send messages for a campaign.
    """


_RequiredClientUpdateBaiduChannelBaiduChannelRequestTypeDef = TypedDict(
    "_RequiredClientUpdateBaiduChannelBaiduChannelRequestTypeDef", {"ApiKey": str}
)
_OptionalClientUpdateBaiduChannelBaiduChannelRequestTypeDef = TypedDict(
    "_OptionalClientUpdateBaiduChannelBaiduChannelRequestTypeDef",
    {"Enabled": bool, "SecretKey": str},
    total=False,
)


class ClientUpdateBaiduChannelBaiduChannelRequestTypeDef(
    _RequiredClientUpdateBaiduChannelBaiduChannelRequestTypeDef,
    _OptionalClientUpdateBaiduChannelBaiduChannelRequestTypeDef,
):
    """
    Specifies the status and settings of the Baidu (Baidu Cloud Push) channel for an application.
    - **ApiKey** *(string) --***[REQUIRED]**

      The API key that you received from the Baidu Cloud Push service to communicate with the
      service.
    """


_ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef = TypedDict(
    "_ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef(
    _ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef
):
    """
    - **BaiduChannelResponse** *(dict) --*

      Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel for
      an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the Baidu channel applies to.
    """


_ClientUpdateBaiduChannelResponseTypeDef = TypedDict(
    "_ClientUpdateBaiduChannelResponseTypeDef",
    {"BaiduChannelResponse": ClientUpdateBaiduChannelResponseBaiduChannelResponseTypeDef},
    total=False,
)


class ClientUpdateBaiduChannelResponseTypeDef(_ClientUpdateBaiduChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **BaiduChannelResponse** *(dict) --*

        Provides information about the status and settings of the Baidu (Baidu Cloud Push) channel
        for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the Baidu channel applies to.
    """


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef",
    {
        "Id": str,
        "MessageConfiguration": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "State": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsStateTypeDef,
        "TemplateConfiguration": ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
):
    """
    - *(dict) --*

      Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
      that's used for A/B testing of a campaign.
      - **Id** *(string) --*

        The unique identifier for the treatment.
    """


_ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseHookTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseHookTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseHookTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientUpdateCampaignResponseCampaignResponseScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientUpdateCampaignResponseCampaignResponseScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseStateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseStateTypeDef",
    {
        "CampaignStatus": Literal[
            "SCHEDULED", "EXECUTING", "PENDING_NEXT_RUN", "COMPLETED", "PAUSED", "DELETED"
        ]
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseStateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseStateTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef
):
    pass


_ClientUpdateCampaignResponseCampaignResponseTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseCampaignResponseTypeDef",
    {
        "AdditionalTreatments": List[
            ClientUpdateCampaignResponseCampaignResponseAdditionalTreatmentsTypeDef
        ],
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "DefaultState": ClientUpdateCampaignResponseCampaignResponseDefaultStateTypeDef,
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientUpdateCampaignResponseCampaignResponseHookTypeDef,
        "Id": str,
        "IsPaused": bool,
        "LastModifiedDate": str,
        "Limits": ClientUpdateCampaignResponseCampaignResponseLimitsTypeDef,
        "MessageConfiguration": ClientUpdateCampaignResponseCampaignResponseMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientUpdateCampaignResponseCampaignResponseScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "State": ClientUpdateCampaignResponseCampaignResponseStateTypeDef,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientUpdateCampaignResponseCampaignResponseTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateCampaignResponseCampaignResponseTypeDef(
    _ClientUpdateCampaignResponseCampaignResponseTypeDef
):
    """
    - **CampaignResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a campaign.
      - **AdditionalTreatments** *(list) --*

        An array of responses, one for each treatment that you defined for the campaign, in addition
        to the default treatment.
        - *(dict) --*

          Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
          that's used for A/B testing of a campaign.
          - **Id** *(string) --*

            The unique identifier for the treatment.
    """


_ClientUpdateCampaignResponseTypeDef = TypedDict(
    "_ClientUpdateCampaignResponseTypeDef",
    {"CampaignResponse": ClientUpdateCampaignResponseCampaignResponseTypeDef},
    total=False,
)


class ClientUpdateCampaignResponseTypeDef(_ClientUpdateCampaignResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **CampaignResponse** *(dict) --*

        Provides information about the status, configuration, and other settings for a campaign.
        - **AdditionalTreatments** *(list) --*

          An array of responses, one for each treatment that you defined for the campaign, in
          addition to the default treatment.
          - *(dict) --*

            Specifies the settings for a campaign treatment. A treatment is a variation of a
            campaign that's used for A/B testing of a campaign.
            - **Id** *(string) --*

              The unique identifier for the treatment.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef
):
    """
    - **ADMMessage** *(dict) --*

      The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
      message overrides the default message.
      - **Action** *(string) --*

        The action to occur if a recipient taps the push notification. Valid values are:
        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.
        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        setting uses the deep-linking features of iOS and Android.
        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef
):
    """
    - **MessageConfiguration** *(dict) --*

      The message configuration settings for the treatment.
      - **ADMMessage** *(dict) --*

        The message that the campaign sends through the ADM (Amazon Device Messaging) channel. This
        message overrides the default message.
        - **Action** *(string) --*

          The action to occur if a recipient taps the push notification. Valid values are:
          * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
          background. This is the default action.
          * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
          setting uses the deep-linking features of iOS and Android.
          * URL - The default mobile browser on the recipient's device opens and loads the web page
          at a URL that you specify.
    """


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef",
    {
        "MessageConfiguration": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsMessageConfigurationTypeDef,
        "Schedule": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsScheduleTypeDef,
        "SizePercent": int,
        "TemplateConfiguration": ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef
):
    """
    - *(dict) --*

      Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
      that's used for A/B testing of a campaign.
      - **MessageConfiguration** *(dict) --*

        The message configuration settings for the treatment.
        - **ADMMessage** *(dict) --*

          The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
          This message overrides the default message.
          - **Action** *(string) --*

            The action to occur if a recipient taps the push notification. Valid values are:
            * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
            background. This is the default action.
            * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
            setting uses the deep-linking features of iOS and Android.
            * URL - The default mobile browser on the recipient's device opens and loads the web
            page at a URL that you specify.
    """


_ClientUpdateCampaignWriteCampaignRequestHookTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestHookTypeDef",
    {"LambdaFunctionName": str, "Mode": Literal["DELIVERY", "FILTER"], "WebUrl": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestHookTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestHookTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef",
    {"Daily": int, "MaximumDuration": int, "MessagesPerSecond": int, "Total": int},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef",
    {"Body": str, "FromAddress": str, "HtmlBody": str, "Title": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageSmallIconUrl": str,
        "ImageUrl": str,
        "JsonBody": str,
        "MediaUrl": str,
        "RawContent": str,
        "SilentPush": bool,
        "TimeToLive": int,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef",
    {"Body": str, "MessageType": Literal["TRANSACTIONAL", "PROMOTIONAL"], "SenderId": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef",
    {
        "ADMMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationADMMessageTypeDef,
        "APNSMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationAPNSMessageTypeDef,
        "BaiduMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationBaiduMessageTypeDef,
        "DefaultMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationDefaultMessageTypeDef,
        "EmailMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationEmailMessageTypeDef,
        "GCMMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationGCMMessageTypeDef,
        "SMSMessage": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationSMSMessageTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str, ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsMetricsTypeDef
        ],
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef",
    {
        "Dimensions": ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterDimensionsTypeDef,
        "FilterType": Literal["SYSTEM", "ENDPOINT"],
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestScheduleTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestScheduleTypeDef",
    {
        "EndTime": str,
        "EventFilter": ClientUpdateCampaignWriteCampaignRequestScheduleEventFilterTypeDef,
        "Frequency": Literal["ONCE", "HOURLY", "DAILY", "WEEKLY", "MONTHLY", "EVENT"],
        "IsLocalTime": bool,
        "QuietTime": ClientUpdateCampaignWriteCampaignRequestScheduleQuietTimeTypeDef,
        "StartTime": str,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestScheduleTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestScheduleTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef",
    {"Name": str},
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef",
    {
        "EmailTemplate": ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationEmailTemplateTypeDef,
        "PushTemplate": ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationPushTemplateTypeDef,
        "SMSTemplate": ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationSMSTemplateTypeDef,
        "VoiceTemplate": ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationVoiceTemplateTypeDef,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef
):
    pass


_ClientUpdateCampaignWriteCampaignRequestTypeDef = TypedDict(
    "_ClientUpdateCampaignWriteCampaignRequestTypeDef",
    {
        "AdditionalTreatments": List[
            ClientUpdateCampaignWriteCampaignRequestAdditionalTreatmentsTypeDef
        ],
        "Description": str,
        "HoldoutPercent": int,
        "Hook": ClientUpdateCampaignWriteCampaignRequestHookTypeDef,
        "IsPaused": bool,
        "Limits": ClientUpdateCampaignWriteCampaignRequestLimitsTypeDef,
        "MessageConfiguration": ClientUpdateCampaignWriteCampaignRequestMessageConfigurationTypeDef,
        "Name": str,
        "Schedule": ClientUpdateCampaignWriteCampaignRequestScheduleTypeDef,
        "SegmentId": str,
        "SegmentVersion": int,
        "tags": Dict[str, str],
        "TemplateConfiguration": ClientUpdateCampaignWriteCampaignRequestTemplateConfigurationTypeDef,
        "TreatmentDescription": str,
        "TreatmentName": str,
    },
    total=False,
)


class ClientUpdateCampaignWriteCampaignRequestTypeDef(
    _ClientUpdateCampaignWriteCampaignRequestTypeDef
):
    """
    Specifies the configuration and other settings for a campaign.
    - **AdditionalTreatments** *(list) --*

      An array of requests that defines additional treatments for the campaign, in addition to the
      default treatment for the campaign.
      - *(dict) --*

        Specifies the settings for a campaign treatment. A treatment is a variation of a campaign
        that's used for A/B testing of a campaign.
        - **MessageConfiguration** *(dict) --*

          The message configuration settings for the treatment.
          - **ADMMessage** *(dict) --*

            The message that the campaign sends through the ADM (Amazon Device Messaging) channel.
            This message overrides the default message.
            - **Action** *(string) --*

              The action to occur if a recipient taps the push notification. Valid values are:
              * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
              background. This is the default action.
              * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
              setting uses the deep-linking features of iOS and Android.
              * URL - The default mobile browser on the recipient's device opens and loads the web
              page at a URL that you specify.
    """


_ClientUpdateEmailChannelEmailChannelRequestTypeDef = TypedDict(
    "_ClientUpdateEmailChannelEmailChannelRequestTypeDef",
    {"ConfigurationSet": str, "Enabled": bool, "FromAddress": str, "Identity": str, "RoleArn": str},
    total=False,
)


class ClientUpdateEmailChannelEmailChannelRequestTypeDef(
    _ClientUpdateEmailChannelEmailChannelRequestTypeDef
):
    """
    Specifies the status and settings of the email channel for an application.
    - **ConfigurationSet** *(string) --*

      The configuration set that you want to apply to email that you send through the channel by
      using the `Amazon Pinpoint Email API <emailAPIreference.html>`__ .
    """


_ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef = TypedDict(
    "_ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "ConfigurationSet": str,
        "CreationDate": str,
        "Enabled": bool,
        "FromAddress": str,
        "HasCredential": bool,
        "Id": str,
        "Identity": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "MessagesPerSecond": int,
        "Platform": str,
        "RoleArn": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef(
    _ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef
):
    """
    - **EmailChannelResponse** *(dict) --*

      Provides information about the status and settings of the email channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the email channel applies to.
    """


_ClientUpdateEmailChannelResponseTypeDef = TypedDict(
    "_ClientUpdateEmailChannelResponseTypeDef",
    {"EmailChannelResponse": ClientUpdateEmailChannelResponseEmailChannelResponseTypeDef},
    total=False,
)


class ClientUpdateEmailChannelResponseTypeDef(_ClientUpdateEmailChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **EmailChannelResponse** *(dict) --*

        Provides information about the status and settings of the email channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the email channel applies to.
    """


_ClientUpdateEmailTemplateEmailTemplateRequestTypeDef = TypedDict(
    "_ClientUpdateEmailTemplateEmailTemplateRequestTypeDef",
    {
        "DefaultSubstitutions": str,
        "HtmlPart": str,
        "Subject": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "TextPart": str,
    },
    total=False,
)


class ClientUpdateEmailTemplateEmailTemplateRequestTypeDef(
    _ClientUpdateEmailTemplateEmailTemplateRequestTypeDef
):
    """
    Specifies the content and settings for a message template that can be used in messages that are
    sent through the email channel.
    - **DefaultSubstitutions** *(string) --*

      A JSON object that specifies the default values to use for message variables in the message
      template. This object is a set of key-value pairs. Each key defines a message variable in the
      template. The corresponding value defines the default value for that variable. When you create
      a message that's based on the template, you can override these defaults with message-specific
      and address-specific variables and values.
    """


_ClientUpdateEmailTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdateEmailTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdateEmailTemplateResponseMessageBodyTypeDef(
    _ClientUpdateEmailTemplateResponseMessageBodyTypeDef
):
    """
    - **MessageBody** *(dict) --*

      Provides information about an API request or response.
      - **Message** *(string) --*

        The message that's returned from the API.
    """


_ClientUpdateEmailTemplateResponseTypeDef = TypedDict(
    "_ClientUpdateEmailTemplateResponseTypeDef",
    {"MessageBody": ClientUpdateEmailTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdateEmailTemplateResponseTypeDef(_ClientUpdateEmailTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **MessageBody** *(dict) --*

        Provides information about an API request or response.
        - **Message** *(string) --*

          The message that's returned from the API.
    """


_ClientUpdateEndpointEndpointRequestDemographicTypeDef = TypedDict(
    "_ClientUpdateEndpointEndpointRequestDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateEndpointEndpointRequestDemographicTypeDef(
    _ClientUpdateEndpointEndpointRequestDemographicTypeDef
):
    pass


_ClientUpdateEndpointEndpointRequestLocationTypeDef = TypedDict(
    "_ClientUpdateEndpointEndpointRequestLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientUpdateEndpointEndpointRequestLocationTypeDef(
    _ClientUpdateEndpointEndpointRequestLocationTypeDef
):
    pass


_ClientUpdateEndpointEndpointRequestUserTypeDef = TypedDict(
    "_ClientUpdateEndpointEndpointRequestUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientUpdateEndpointEndpointRequestUserTypeDef(
    _ClientUpdateEndpointEndpointRequestUserTypeDef
):
    pass


_ClientUpdateEndpointEndpointRequestTypeDef = TypedDict(
    "_ClientUpdateEndpointEndpointRequestTypeDef",
    {
        "Address": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": Literal[
            "GCM",
            "APNS",
            "APNS_SANDBOX",
            "APNS_VOIP",
            "APNS_VOIP_SANDBOX",
            "ADM",
            "SMS",
            "VOICE",
            "EMAIL",
            "BAIDU",
            "CUSTOM",
        ],
        "Demographic": ClientUpdateEndpointEndpointRequestDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Location": ClientUpdateEndpointEndpointRequestLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientUpdateEndpointEndpointRequestUserTypeDef,
    },
    total=False,
)


class ClientUpdateEndpointEndpointRequestTypeDef(_ClientUpdateEndpointEndpointRequestTypeDef):
    """
    Specifies the channel type and other settings for an endpoint.
    - **Address** *(string) --*

      The destination address for messages or push notifications that you send to the endpoint. The
      address varies by channel. For a push-notification channel, use the token provided by the push
      notification service, such as an Apple Push Notification service (APNs) device token or a
      Firebase Cloud Messaging (FCM) registration token. For the SMS channel, use a phone number in
      E.164 format, such as +12065550100. For the email channel, use an email address.
    """


_ClientUpdateEndpointResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdateEndpointResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdateEndpointResponseMessageBodyTypeDef(
    _ClientUpdateEndpointResponseMessageBodyTypeDef
):
    """
    - **MessageBody** *(dict) --*

      Provides information about an API request or response.
      - **Message** *(string) --*

        The message that's returned from the API.
    """


_ClientUpdateEndpointResponseTypeDef = TypedDict(
    "_ClientUpdateEndpointResponseTypeDef",
    {"MessageBody": ClientUpdateEndpointResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdateEndpointResponseTypeDef(_ClientUpdateEndpointResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **MessageBody** *(dict) --*

        Provides information about an API request or response.
        - **Message** *(string) --*

          The message that's returned from the API.
    """


_ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef",
    {
        "AppVersion": str,
        "Locale": str,
        "Make": str,
        "Model": str,
        "ModelVersion": str,
        "Platform": str,
        "PlatformVersion": str,
        "Timezone": str,
    },
    total=False,
)


class ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef(
    _ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef
):
    pass


_ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef",
    {
        "City": str,
        "Country": str,
        "Latitude": float,
        "Longitude": float,
        "PostalCode": str,
        "Region": str,
    },
    total=False,
)


class ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef(
    _ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef
):
    pass


_ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef",
    {"UserAttributes": Dict[str, List[str]], "UserId": str},
    total=False,
)


class ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef(
    _ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef
):
    pass


_ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef",
    {
        "Address": str,
        "Attributes": Dict[str, List[str]],
        "ChannelType": Literal[
            "GCM",
            "APNS",
            "APNS_SANDBOX",
            "APNS_VOIP",
            "APNS_VOIP_SANDBOX",
            "ADM",
            "SMS",
            "VOICE",
            "EMAIL",
            "BAIDU",
            "CUSTOM",
        ],
        "Demographic": ClientUpdateEndpointsBatchEndpointBatchRequestItemDemographicTypeDef,
        "EffectiveDate": str,
        "EndpointStatus": str,
        "Id": str,
        "Location": ClientUpdateEndpointsBatchEndpointBatchRequestItemLocationTypeDef,
        "Metrics": Dict[str, float],
        "OptOut": str,
        "RequestId": str,
        "User": ClientUpdateEndpointsBatchEndpointBatchRequestItemUserTypeDef,
    },
    total=False,
)


class ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef(
    _ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef
):
    """
    - *(dict) --*

      Specifies an endpoint to create or update and the settings and attributes to set or change for
      the endpoint.
      - **Address** *(string) --*

        The destination address for messages or push notifications that you send to the endpoint.
        The address varies by channel. For a push-notification channel, use the token provided by
        the push notification service, such as an Apple Push Notification service (APNs) device
        token or a Firebase Cloud Messaging (FCM) registration token. For the SMS channel, use a
        phone number in E.164 format, such as +12065550100. For the email channel, use an email
        address.
    """


_ClientUpdateEndpointsBatchEndpointBatchRequestTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchEndpointBatchRequestTypeDef",
    {"Item": List[ClientUpdateEndpointsBatchEndpointBatchRequestItemTypeDef]},
)


class ClientUpdateEndpointsBatchEndpointBatchRequestTypeDef(
    _ClientUpdateEndpointsBatchEndpointBatchRequestTypeDef
):
    """
    Specifies a batch of endpoints to create or update and the settings and attributes to set or
    change for each endpoint.
    - **Item** *(list) --***[REQUIRED]**

      An array that defines the endpoints to create or update and, for each endpoint, the property
      values to set or change. An array can contain a maximum of 100 items.
      - *(dict) --*

        Specifies an endpoint to create or update and the settings and attributes to set or change
        for the endpoint.
        - **Address** *(string) --*

          The destination address for messages or push notifications that you send to the endpoint.
          The address varies by channel. For a push-notification channel, use the token provided by
          the push notification service, such as an Apple Push Notification service (APNs) device
          token or a Firebase Cloud Messaging (FCM) registration token. For the SMS channel, use a
          phone number in E.164 format, such as +12065550100. For the email channel, use an email
          address.
    """


_ClientUpdateEndpointsBatchResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdateEndpointsBatchResponseMessageBodyTypeDef(
    _ClientUpdateEndpointsBatchResponseMessageBodyTypeDef
):
    """
    - **MessageBody** *(dict) --*

      Provides information about an API request or response.
      - **Message** *(string) --*

        The message that's returned from the API.
    """


_ClientUpdateEndpointsBatchResponseTypeDef = TypedDict(
    "_ClientUpdateEndpointsBatchResponseTypeDef",
    {"MessageBody": ClientUpdateEndpointsBatchResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdateEndpointsBatchResponseTypeDef(_ClientUpdateEndpointsBatchResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **MessageBody** *(dict) --*

        Provides information about an API request or response.
        - **Message** *(string) --*

          The message that's returned from the API.
    """


_RequiredClientUpdateGcmChannelGCMChannelRequestTypeDef = TypedDict(
    "_RequiredClientUpdateGcmChannelGCMChannelRequestTypeDef", {"ApiKey": str}
)
_OptionalClientUpdateGcmChannelGCMChannelRequestTypeDef = TypedDict(
    "_OptionalClientUpdateGcmChannelGCMChannelRequestTypeDef", {"Enabled": bool}, total=False
)


class ClientUpdateGcmChannelGCMChannelRequestTypeDef(
    _RequiredClientUpdateGcmChannelGCMChannelRequestTypeDef,
    _OptionalClientUpdateGcmChannelGCMChannelRequestTypeDef,
):
    """
    Specifies the status and settings of the GCM channel for an application. This channel enables
    Amazon Pinpoint to send push notifications through the Firebase Cloud Messaging (FCM), formerly
    Google Cloud Messaging (GCM), service.
    - **ApiKey** *(string) --***[REQUIRED]**

      The Web API Key, also referred to as an *API_KEY* or *server key* , that you received from
      Google to communicate with Google services.
    """


_ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef = TypedDict(
    "_ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Credential": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef(
    _ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef
):
    """
    - **GCMChannelResponse** *(dict) --*

      Provides information about the status and settings of the GCM channel for an application. The
      GCM channel enables Amazon Pinpoint to send push notifications through the Firebase Cloud
      Messaging (FCM), formerly Google Cloud Messaging (GCM), service.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the GCM channel applies to.
    """


_ClientUpdateGcmChannelResponseTypeDef = TypedDict(
    "_ClientUpdateGcmChannelResponseTypeDef",
    {"GCMChannelResponse": ClientUpdateGcmChannelResponseGCMChannelResponseTypeDef},
    total=False,
)


class ClientUpdateGcmChannelResponseTypeDef(_ClientUpdateGcmChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **GCMChannelResponse** *(dict) --*

        Provides information about the status and settings of the GCM channel for an application.
        The GCM channel enables Amazon Pinpoint to send push notifications through the Firebase
        Cloud Messaging (FCM), formerly Google Cloud Messaging (GCM), service.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the GCM channel applies to.
    """


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": Literal["ALL", "ANY"],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef",
    {
        "Branches": List[
            ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientUpdateJourneyResponseJourneyResponseActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef",
    {
        "ConditionalSplit": ClientUpdateJourneyResponseJourneyResponseActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientUpdateJourneyResponseJourneyResponseActivitiesEMAILTypeDef,
        "Holdout": ClientUpdateJourneyResponseJourneyResponseActivitiesHoldoutTypeDef,
        "MultiCondition": ClientUpdateJourneyResponseJourneyResponseActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientUpdateJourneyResponseJourneyResponseActivitiesRandomSplitTypeDef,
        "Wait": ClientUpdateJourneyResponseJourneyResponseActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientUpdateJourneyResponseJourneyResponseStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef
):
    pass


_ClientUpdateJourneyResponseJourneyResponseTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseJourneyResponseTypeDef",
    {
        "Activities": Dict[str, ClientUpdateJourneyResponseJourneyResponseActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientUpdateJourneyResponseJourneyResponseLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientUpdateJourneyResponseJourneyResponseQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientUpdateJourneyResponseJourneyResponseScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientUpdateJourneyResponseJourneyResponseStartConditionTypeDef,
        "State": Literal["DRAFT", "ACTIVE", "COMPLETED", "CANCELLED", "CLOSED"],
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientUpdateJourneyResponseJourneyResponseTypeDef(
    _ClientUpdateJourneyResponseJourneyResponseTypeDef
):
    """
    - **JourneyResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a journey.
      - **Activities** *(dict) --*

        The configuration and other settings for the activities that comprise the journey.
        - *(string) --*

          - *(dict) --*

            Specifies the configuration and other settings for an activity in a journey.
            - **ConditionalSplit** *(dict) --*

              The settings for a yes/no split activity. This type of activity sends participants
              down one of two paths in a journey, based on conditions that you specify.
              - **Condition** *(dict) --*

                The conditions that define the paths for the activity, and the relationship between
                the conditions.
                - **Conditions** *(list) --*

                  The conditions to evaluate for the activity.
                  - *(dict) --*

                    Specifies a condition to evaluate for an activity in a journey.
                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.
                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.
                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.
                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.
                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.
    """


_ClientUpdateJourneyResponseTypeDef = TypedDict(
    "_ClientUpdateJourneyResponseTypeDef",
    {"JourneyResponse": ClientUpdateJourneyResponseJourneyResponseTypeDef},
    total=False,
)


class ClientUpdateJourneyResponseTypeDef(_ClientUpdateJourneyResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **JourneyResponse** *(dict) --*

        Provides information about the status, configuration, and other settings for a journey.
        - **Activities** *(dict) --*

          The configuration and other settings for the activities that comprise the journey.
          - *(string) --*

            - *(dict) --*

              Specifies the configuration and other settings for an activity in a journey.
              - **ConditionalSplit** *(dict) --*

                The settings for a yes/no split activity. This type of activity sends participants
                down one of two paths in a journey, based on conditions that you specify.
                - **Condition** *(dict) --*

                  The conditions that define the paths for the activity, and the relationship
                  between the conditions.
                  - **Conditions** *(list) --*

                    The conditions to evaluate for the activity.
                    - *(dict) --*

                      Specifies a condition to evaluate for an activity in a journey.
                      - **EventCondition** *(dict) --*

                        The dimension settings for the event that's associated with the activity.
                        - **Dimensions** *(dict) --*

                          The dimensions for the event filter to use for the activity.
                          - **Attributes** *(dict) --*

                            One or more custom attributes that your application reports to Amazon
                            Pinpoint. You can use these attributes as selection criteria when you
                            create an event filter.
                            - *(string) --*

                              - *(dict) --*

                                Specifies attribute-based criteria for including or excluding
                                endpoints from a segment.
                                - **AttributeType** *(string) --*

                                  The type of segment dimension to use. Valid values are: INCLUSIVE,
                                  endpoints that match the criteria are included in the segment;
                                  and, EXCLUSIVE, endpoints that match the criteria are excluded
                                  from the segment.
    """


_ClientUpdateJourneyStateJourneyStateRequestTypeDef = TypedDict(
    "_ClientUpdateJourneyStateJourneyStateRequestTypeDef",
    {"State": Literal["DRAFT", "ACTIVE", "COMPLETED", "CANCELLED", "CLOSED"]},
    total=False,
)


class ClientUpdateJourneyStateJourneyStateRequestTypeDef(
    _ClientUpdateJourneyStateJourneyStateRequestTypeDef
):
    """
    Changes the status of a journey.
    - **State** *(string) --*

      The status of the journey. Currently, the only supported value is CANCELLED.
      If you cancel a journey, Amazon Pinpoint continues to perform activities that are currently in
      progress, until those activities are complete. Amazon Pinpoint also continues to collect and
      aggregate analytics data for those activities, until they are complete, and any activities
      that were complete when you cancelled the journey.
      After you cancel a journey, you can't add, change, or remove any activities from the journey.
      In addition, Amazon Pinpoint stops evaluating the journey and doesn't perform any activities
      that haven't started.
    """


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": Literal["ALL", "ANY"],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef",
    {
        "Branches": List[
            ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitBranchesTypeDef
        ]
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef",
    {
        "ConditionalSplit": ClientUpdateJourneyStateResponseJourneyResponseActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientUpdateJourneyStateResponseJourneyResponseActivitiesEMAILTypeDef,
        "Holdout": ClientUpdateJourneyStateResponseJourneyResponseActivitiesHoldoutTypeDef,
        "MultiCondition": ClientUpdateJourneyStateResponseJourneyResponseActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientUpdateJourneyStateResponseJourneyResponseActivitiesRandomSplitTypeDef,
        "Wait": ClientUpdateJourneyStateResponseJourneyResponseActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientUpdateJourneyStateResponseJourneyResponseStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef
):
    pass


_ClientUpdateJourneyStateResponseJourneyResponseTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseJourneyResponseTypeDef",
    {
        "Activities": Dict[str, ClientUpdateJourneyStateResponseJourneyResponseActivitiesTypeDef],
        "ApplicationId": str,
        "CreationDate": str,
        "Id": str,
        "LastModifiedDate": str,
        "Limits": ClientUpdateJourneyStateResponseJourneyResponseLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientUpdateJourneyStateResponseJourneyResponseQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientUpdateJourneyStateResponseJourneyResponseScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientUpdateJourneyStateResponseJourneyResponseStartConditionTypeDef,
        "State": Literal["DRAFT", "ACTIVE", "COMPLETED", "CANCELLED", "CLOSED"],
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientUpdateJourneyStateResponseJourneyResponseTypeDef(
    _ClientUpdateJourneyStateResponseJourneyResponseTypeDef
):
    """
    - **JourneyResponse** *(dict) --*

      Provides information about the status, configuration, and other settings for a journey.
      - **Activities** *(dict) --*

        The configuration and other settings for the activities that comprise the journey.
        - *(string) --*

          - *(dict) --*

            Specifies the configuration and other settings for an activity in a journey.
            - **ConditionalSplit** *(dict) --*

              The settings for a yes/no split activity. This type of activity sends participants
              down one of two paths in a journey, based on conditions that you specify.
              - **Condition** *(dict) --*

                The conditions that define the paths for the activity, and the relationship between
                the conditions.
                - **Conditions** *(list) --*

                  The conditions to evaluate for the activity.
                  - *(dict) --*

                    Specifies a condition to evaluate for an activity in a journey.
                    - **EventCondition** *(dict) --*

                      The dimension settings for the event that's associated with the activity.
                      - **Dimensions** *(dict) --*

                        The dimensions for the event filter to use for the activity.
                        - **Attributes** *(dict) --*

                          One or more custom attributes that your application reports to Amazon
                          Pinpoint. You can use these attributes as selection criteria when you
                          create an event filter.
                          - *(string) --*

                            - *(dict) --*

                              Specifies attribute-based criteria for including or excluding
                              endpoints from a segment.
                              - **AttributeType** *(string) --*

                                The type of segment dimension to use. Valid values are: INCLUSIVE,
                                endpoints that match the criteria are included in the segment; and,
                                EXCLUSIVE, endpoints that match the criteria are excluded from the
                                segment.
    """


_ClientUpdateJourneyStateResponseTypeDef = TypedDict(
    "_ClientUpdateJourneyStateResponseTypeDef",
    {"JourneyResponse": ClientUpdateJourneyStateResponseJourneyResponseTypeDef},
    total=False,
)


class ClientUpdateJourneyStateResponseTypeDef(_ClientUpdateJourneyStateResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **JourneyResponse** *(dict) --*

        Provides information about the status, configuration, and other settings for a journey.
        - **Activities** *(dict) --*

          The configuration and other settings for the activities that comprise the journey.
          - *(string) --*

            - *(dict) --*

              Specifies the configuration and other settings for an activity in a journey.
              - **ConditionalSplit** *(dict) --*

                The settings for a yes/no split activity. This type of activity sends participants
                down one of two paths in a journey, based on conditions that you specify.
                - **Condition** *(dict) --*

                  The conditions that define the paths for the activity, and the relationship
                  between the conditions.
                  - **Conditions** *(list) --*

                    The conditions to evaluate for the activity.
                    - *(dict) --*

                      Specifies a condition to evaluate for an activity in a journey.
                      - **EventCondition** *(dict) --*

                        The dimension settings for the event that's associated with the activity.
                        - **Dimensions** *(dict) --*

                          The dimensions for the event filter to use for the activity.
                          - **Attributes** *(dict) --*

                            One or more custom attributes that your application reports to Amazon
                            Pinpoint. You can use these attributes as selection criteria when you
                            create an event filter.
                            - *(string) --*

                              - *(dict) --*

                                Specifies attribute-based criteria for including or excluding
                                endpoints from a segment.
                                - **AttributeType** *(string) --*

                                  The type of segment dimension to use. Valid values are: INCLUSIVE,
                                  endpoints that match the criteria are included in the segment;
                                  and, EXCLUSIVE, endpoints that match the criteria are excluded
                                  from the segment.
    """


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef",
    {
        "EventCondition": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef",
    {
        "Conditions": List[
            ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionConditionsTypeDef
        ],
        "Operator": Literal["ALL", "ANY"],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef",
    {
        "Condition": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitConditionTypeDef,
        "EvaluationWaitTime": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitEvaluationWaitTimeTypeDef,
        "FalseActivity": str,
        "TrueActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef",
    {"FromAddress": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef",
    {
        "MessageConfig": ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILMessageConfigTypeDef,
        "NextActivity": str,
        "TemplateName": str,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsAttributesTypeDef,
        ],
        "EventType": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsEventTypeTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsMetricsTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef",
    {
        "Dimensions": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionDimensionsTypeDef,
        "MessageActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsDemographicTypeDef,
        "Location": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef",
    {
        "EventCondition": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionEventConditionTypeDef,
        "SegmentCondition": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentConditionTypeDef,
        "SegmentDimensions": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionSegmentDimensionsTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef",
    {
        "Condition": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesConditionTypeDef,
        "NextActivity": str,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef",
    {
        "Branches": List[
            ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionBranchesTypeDef
        ],
        "DefaultActivity": str,
        "EvaluationWaitTime": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionEvaluationWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef",
    {"NextActivity": str, "Percentage": int},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef",
    {"Branches": List[ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitBranchesTypeDef]},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef",
    {"WaitFor": str, "WaitUntil": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef",
    {
        "NextActivity": str,
        "WaitTime": ClientUpdateJourneyWriteJourneyRequestActivitiesWaitWaitTimeTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef",
    {
        "ConditionalSplit": ClientUpdateJourneyWriteJourneyRequestActivitiesConditionalSplitTypeDef,
        "Description": str,
        "EMAIL": ClientUpdateJourneyWriteJourneyRequestActivitiesEMAILTypeDef,
        "Holdout": ClientUpdateJourneyWriteJourneyRequestActivitiesHoldoutTypeDef,
        "MultiCondition": ClientUpdateJourneyWriteJourneyRequestActivitiesMultiConditionTypeDef,
        "RandomSplit": ClientUpdateJourneyWriteJourneyRequestActivitiesRandomSplitTypeDef,
        "Wait": ClientUpdateJourneyWriteJourneyRequestActivitiesWaitTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef",
    {"DailyCap": int, "EndpointReentryCap": int, "MessagesPerSecond": int},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef",
    {"End": str, "Start": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef",
    {"EndTime": datetime, "StartTime": datetime, "Timezone": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef",
    {"SegmentId": str},
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef",
    {
        "Description": str,
        "SegmentStartCondition": ClientUpdateJourneyWriteJourneyRequestStartConditionSegmentStartConditionTypeDef,
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef(
    _ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef
):
    pass


_ClientUpdateJourneyWriteJourneyRequestTypeDef = TypedDict(
    "_ClientUpdateJourneyWriteJourneyRequestTypeDef",
    {
        "Activities": Dict[str, ClientUpdateJourneyWriteJourneyRequestActivitiesTypeDef],
        "CreationDate": str,
        "LastModifiedDate": str,
        "Limits": ClientUpdateJourneyWriteJourneyRequestLimitsTypeDef,
        "LocalTime": bool,
        "Name": str,
        "QuietTime": ClientUpdateJourneyWriteJourneyRequestQuietTimeTypeDef,
        "RefreshFrequency": str,
        "Schedule": ClientUpdateJourneyWriteJourneyRequestScheduleTypeDef,
        "StartActivity": str,
        "StartCondition": ClientUpdateJourneyWriteJourneyRequestStartConditionTypeDef,
        "State": Literal["DRAFT", "ACTIVE", "COMPLETED", "CANCELLED", "CLOSED"],
    },
    total=False,
)


class ClientUpdateJourneyWriteJourneyRequestTypeDef(_ClientUpdateJourneyWriteJourneyRequestTypeDef):
    """
    Specifies the configuration and other settings for a journey.
    - **Activities** *(dict) --*

      The configuration and other settings for the activities that comprise the journey.
      - *(string) --*

        - *(dict) --*

          Specifies the configuration and other settings for an activity in a journey.
          - **ConditionalSplit** *(dict) --*

            The settings for a yes/no split activity. This type of activity sends participants down
            one of two paths in a journey, based on conditions that you specify.
            - **Condition** *(dict) --*

              The conditions that define the paths for the activity, and the relationship between
              the conditions.
              - **Conditions** *(list) --*

                The conditions to evaluate for the activity.
                - *(dict) --*

                  Specifies a condition to evaluate for an activity in a journey.
                  - **EventCondition** *(dict) --*

                    The dimension settings for the event that's associated with the activity.
                    - **Dimensions** *(dict) --***[REQUIRED]**

                      The dimensions for the event filter to use for the activity.
                      - **Attributes** *(dict) --*

                        One or more custom attributes that your application reports to Amazon
                        Pinpoint. You can use these attributes as selection criteria when you create
                        an event filter.
                        - *(string) --*

                          - *(dict) --*

                            Specifies attribute-based criteria for including or excluding endpoints
                            from a segment.
                            - **AttributeType** *(string) --*

                              The type of segment dimension to use. Valid values are: INCLUSIVE,
                              endpoints that match the criteria are included in the segment; and,
                              EXCLUSIVE, endpoints that match the criteria are excluded from the
                              segment.
    """


_ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef
):
    """
    - **ADM** *(dict) --*

      The message template to use for the ADM (Amazon Device Messaging) channel. This message
      template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).
      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:
        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.
        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.
        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.
    """


_ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "MediaUrl": str,
        "RawContent": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef
):
    pass


_ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef
):
    pass


_ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef
):
    pass


_ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef",
    {
        "Action": Literal["OPEN_APP", "DEEP_LINK", "URL"],
        "Body": str,
        "ImageIconUrl": str,
        "ImageUrl": str,
        "RawContent": str,
        "SmallImageIconUrl": str,
        "Sound": str,
        "Title": str,
        "Url": str,
    },
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef
):
    pass


_ClientUpdatePushTemplatePushNotificationTemplateRequestTypeDef = TypedDict(
    "_ClientUpdatePushTemplatePushNotificationTemplateRequestTypeDef",
    {
        "ADM": ClientUpdatePushTemplatePushNotificationTemplateRequestADMTypeDef,
        "APNS": ClientUpdatePushTemplatePushNotificationTemplateRequestAPNSTypeDef,
        "Baidu": ClientUpdatePushTemplatePushNotificationTemplateRequestBaiduTypeDef,
        "Default": ClientUpdatePushTemplatePushNotificationTemplateRequestDefaultTypeDef,
        "DefaultSubstitutions": str,
        "GCM": ClientUpdatePushTemplatePushNotificationTemplateRequestGCMTypeDef,
        "tags": Dict[str, str],
        "TemplateDescription": str,
    },
    total=False,
)


class ClientUpdatePushTemplatePushNotificationTemplateRequestTypeDef(
    _ClientUpdatePushTemplatePushNotificationTemplateRequestTypeDef
):
    """
    Updates an existing message template that you can use in messages that are sent through a push
    notification channel.
    - **ADM** *(dict) --*

      The message template to use for the ADM (Amazon Device Messaging) channel. This message
      template overrides the default template for push notification channels
      (DefaultPushNotificationTemplate).
      - **Action** *(string) --*

        The action to occur if a recipient taps a push notification that's based on the message
        template. Valid values are:
        * OPEN_APP - Your app opens or it becomes the foreground app if it was sent to the
        background. This is the default action.
        * DEEP_LINK - Your app opens and displays a designated user interface in the app. This
        action uses the deep-linking features of the Android platform.
        * URL - The default mobile browser on the recipient's device opens and loads the web page at
        a URL that you specify.
    """


_ClientUpdatePushTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdatePushTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdatePushTemplateResponseMessageBodyTypeDef(
    _ClientUpdatePushTemplateResponseMessageBodyTypeDef
):
    """
    - **MessageBody** *(dict) --*

      Provides information about an API request or response.
      - **Message** *(string) --*

        The message that's returned from the API.
    """


_ClientUpdatePushTemplateResponseTypeDef = TypedDict(
    "_ClientUpdatePushTemplateResponseTypeDef",
    {"MessageBody": ClientUpdatePushTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdatePushTemplateResponseTypeDef(_ClientUpdatePushTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **MessageBody** *(dict) --*

        Provides information about an API request or response.
        - **Message** *(string) --*

          The message that's returned from the API.
    """


_ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef",
    {"Recency": ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateSegmentResponseSegmentResponseDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateSegmentResponseSegmentResponseDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef",
    {
        "Attributes": Dict[
            str, ClientUpdateSegmentResponseSegmentResponseDimensionsAttributesTypeDef
        ],
        "Behavior": ClientUpdateSegmentResponseSegmentResponseDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateSegmentResponseSegmentResponseDimensionsDemographicTypeDef,
        "Location": ClientUpdateSegmentResponseSegmentResponseDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientUpdateSegmentResponseSegmentResponseDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientUpdateSegmentResponseSegmentResponseDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef",
    {
        "ChannelCounts": Dict[str, int],
        "ExternalId": str,
        "Format": Literal["CSV", "JSON"],
        "RoleArn": str,
        "S3Url": str,
        "Size": int,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str,
            ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsMetricsTypeDef,
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": Literal["ALL", "ANY", "NONE"],
        "Type": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef",
    {
        "Groups": List[ClientUpdateSegmentResponseSegmentResponseSegmentGroupsGroupsTypeDef],
        "Include": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef
):
    pass


_ClientUpdateSegmentResponseSegmentResponseTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseSegmentResponseTypeDef",
    {
        "ApplicationId": str,
        "Arn": str,
        "CreationDate": str,
        "Dimensions": ClientUpdateSegmentResponseSegmentResponseDimensionsTypeDef,
        "Id": str,
        "ImportDefinition": ClientUpdateSegmentResponseSegmentResponseImportDefinitionTypeDef,
        "LastModifiedDate": str,
        "Name": str,
        "SegmentGroups": ClientUpdateSegmentResponseSegmentResponseSegmentGroupsTypeDef,
        "SegmentType": Literal["DIMENSIONAL", "IMPORT"],
        "tags": Dict[str, str],
        "Version": int,
    },
    total=False,
)


class ClientUpdateSegmentResponseSegmentResponseTypeDef(
    _ClientUpdateSegmentResponseSegmentResponseTypeDef
):
    """
    - **SegmentResponse** *(dict) --*

      Provides information about the configuration, dimension, and other settings for a segment.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the segment is associated with.
    """


_ClientUpdateSegmentResponseTypeDef = TypedDict(
    "_ClientUpdateSegmentResponseTypeDef",
    {"SegmentResponse": ClientUpdateSegmentResponseSegmentResponseTypeDef},
    total=False,
)


class ClientUpdateSegmentResponseTypeDef(_ClientUpdateSegmentResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **SegmentResponse** *(dict) --*

        Provides information about the configuration, dimension, and other settings for a segment.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the segment is associated with.
    """


_ClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef",
    {"Recency": ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorRecencyTypeDef},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateSegmentWriteSegmentRequestDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateSegmentWriteSegmentRequestDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef",
    {
        "Attributes": Dict[str, ClientUpdateSegmentWriteSegmentRequestDimensionsAttributesTypeDef],
        "Behavior": ClientUpdateSegmentWriteSegmentRequestDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateSegmentWriteSegmentRequestDimensionsDemographicTypeDef,
        "Location": ClientUpdateSegmentWriteSegmentRequestDimensionsLocationTypeDef,
        "Metrics": Dict[str, ClientUpdateSegmentWriteSegmentRequestDimensionsMetricsTypeDef],
        "UserAttributes": Dict[
            str, ClientUpdateSegmentWriteSegmentRequestDimensionsUserAttributesTypeDef
        ],
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef
):
    """
    - **Dimensions** *(dict) --*

      The criteria that define the dimensions for the segment.
      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.
        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.
            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.
    """


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef",
    {
        "Duration": Literal["HR_24", "DAY_7", "DAY_14", "DAY_30"],
        "RecencyType": Literal["ACTIVE", "INACTIVE"],
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef",
    {
        "Recency": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorRecencyTypeDef
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef",
    {
        "AppVersion": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicAppVersionTypeDef,
        "Channel": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicChannelTypeDef,
        "DeviceType": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicDeviceTypeTypeDef,
        "Make": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicMakeTypeDef,
        "Model": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicModelTypeDef,
        "Platform": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicPlatformTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef",
    {"DimensionType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef",
    {"Latitude": float, "Longitude": float},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef",
    {
        "Coordinates": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointCoordinatesTypeDef,
        "RangeInKilometers": float,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef",
    {
        "Country": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationCountryTypeDef,
        "GPSPoint": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationGPSPointTypeDef,
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef",
    {"ComparisonOperator": str, "Value": float},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef",
    {"AttributeType": Literal["INCLUSIVE", "EXCLUSIVE"], "Values": List[str]},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef",
    {
        "Attributes": Dict[
            str,
            ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsAttributesTypeDef,
        ],
        "Behavior": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsBehaviorTypeDef,
        "Demographic": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsDemographicTypeDef,
        "Location": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsLocationTypeDef,
        "Metrics": Dict[
            str, ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsMetricsTypeDef
        ],
        "UserAttributes": Dict[
            str,
            ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsUserAttributesTypeDef,
        ],
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef",
    {"Id": str, "Version": int},
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef",
    {
        "Dimensions": List[
            ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsDimensionsTypeDef
        ],
        "SourceSegments": List[
            ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsSourceSegmentsTypeDef
        ],
        "SourceType": Literal["ALL", "ANY", "NONE"],
        "Type": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef",
    {
        "Groups": List[ClientUpdateSegmentWriteSegmentRequestSegmentGroupsGroupsTypeDef],
        "Include": Literal["ALL", "ANY", "NONE"],
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef(
    _ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef
):
    pass


_ClientUpdateSegmentWriteSegmentRequestTypeDef = TypedDict(
    "_ClientUpdateSegmentWriteSegmentRequestTypeDef",
    {
        "Dimensions": ClientUpdateSegmentWriteSegmentRequestDimensionsTypeDef,
        "Name": str,
        "SegmentGroups": ClientUpdateSegmentWriteSegmentRequestSegmentGroupsTypeDef,
        "tags": Dict[str, str],
    },
    total=False,
)


class ClientUpdateSegmentWriteSegmentRequestTypeDef(_ClientUpdateSegmentWriteSegmentRequestTypeDef):
    """
    Specifies the configuration, dimension, and other settings for a segment. A WriteSegmentRequest
    object can include a Dimensions object or a SegmentGroups object, but not both.
    - **Dimensions** *(dict) --*

      The criteria that define the dimensions for the segment.
      - **Attributes** *(dict) --*

        One or more custom attributes to use as criteria for the segment.
        - *(string) --*

          - *(dict) --*

            Specifies attribute-based criteria for including or excluding endpoints from a segment.
            - **AttributeType** *(string) --*

              The type of segment dimension to use. Valid values are: INCLUSIVE, endpoints that
              match the criteria are included in the segment; and, EXCLUSIVE, endpoints that match
              the criteria are excluded from the segment.
    """


_ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef = TypedDict(
    "_ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "PromotionalMessagesPerSecond": int,
        "SenderId": str,
        "ShortCode": str,
        "TransactionalMessagesPerSecond": int,
        "Version": int,
    },
    total=False,
)


class ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef(
    _ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef
):
    """
    - **SMSChannelResponse** *(dict) --*

      Provides information about the status and settings of the SMS channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the SMS channel applies to.
    """


_ClientUpdateSmsChannelResponseTypeDef = TypedDict(
    "_ClientUpdateSmsChannelResponseTypeDef",
    {"SMSChannelResponse": ClientUpdateSmsChannelResponseSMSChannelResponseTypeDef},
    total=False,
)


class ClientUpdateSmsChannelResponseTypeDef(_ClientUpdateSmsChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **SMSChannelResponse** *(dict) --*

        Provides information about the status and settings of the SMS channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the SMS channel applies to.
    """


_ClientUpdateSmsChannelSMSChannelRequestTypeDef = TypedDict(
    "_ClientUpdateSmsChannelSMSChannelRequestTypeDef",
    {"Enabled": bool, "SenderId": str, "ShortCode": str},
    total=False,
)


class ClientUpdateSmsChannelSMSChannelRequestTypeDef(
    _ClientUpdateSmsChannelSMSChannelRequestTypeDef
):
    """
    Specifies the status and settings of the SMS channel for an application.
    - **Enabled** *(boolean) --*

      Specifies whether to enable the SMS channel for the application.
    """


_ClientUpdateSmsTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdateSmsTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdateSmsTemplateResponseMessageBodyTypeDef(
    _ClientUpdateSmsTemplateResponseMessageBodyTypeDef
):
    """
    - **MessageBody** *(dict) --*

      Provides information about an API request or response.
      - **Message** *(string) --*

        The message that's returned from the API.
    """


_ClientUpdateSmsTemplateResponseTypeDef = TypedDict(
    "_ClientUpdateSmsTemplateResponseTypeDef",
    {"MessageBody": ClientUpdateSmsTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdateSmsTemplateResponseTypeDef(_ClientUpdateSmsTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **MessageBody** *(dict) --*

        Provides information about an API request or response.
        - **Message** *(string) --*

          The message that's returned from the API.
    """


_ClientUpdateSmsTemplateSMSTemplateRequestTypeDef = TypedDict(
    "_ClientUpdateSmsTemplateSMSTemplateRequestTypeDef",
    {"Body": str, "DefaultSubstitutions": str, "tags": Dict[str, str], "TemplateDescription": str},
    total=False,
)


class ClientUpdateSmsTemplateSMSTemplateRequestTypeDef(
    _ClientUpdateSmsTemplateSMSTemplateRequestTypeDef
):
    """
    Specifies the content and settings for a message template that can be used in text messages that
    are sent through the SMS channel.
    - **Body** *(string) --*

      The message body to use in text messages that are based on the message template.
    """


_ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef = TypedDict(
    "_ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef",
    {
        "ApplicationId": str,
        "CreationDate": str,
        "Enabled": bool,
        "HasCredential": bool,
        "Id": str,
        "IsArchived": bool,
        "LastModifiedBy": str,
        "LastModifiedDate": str,
        "Platform": str,
        "Version": int,
    },
    total=False,
)


class ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef(
    _ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef
):
    """
    - **VoiceChannelResponse** *(dict) --*

      Provides information about the status and settings of the voice channel for an application.
      - **ApplicationId** *(string) --*

        The unique identifier for the application that the voice channel applies to.
    """


_ClientUpdateVoiceChannelResponseTypeDef = TypedDict(
    "_ClientUpdateVoiceChannelResponseTypeDef",
    {"VoiceChannelResponse": ClientUpdateVoiceChannelResponseVoiceChannelResponseTypeDef},
    total=False,
)


class ClientUpdateVoiceChannelResponseTypeDef(_ClientUpdateVoiceChannelResponseTypeDef):
    """
    - *(dict) --*

      The request succeeded.
      - **VoiceChannelResponse** *(dict) --*

        Provides information about the status and settings of the voice channel for an application.
        - **ApplicationId** *(string) --*

          The unique identifier for the application that the voice channel applies to.
    """


_ClientUpdateVoiceChannelVoiceChannelRequestTypeDef = TypedDict(
    "_ClientUpdateVoiceChannelVoiceChannelRequestTypeDef", {"Enabled": bool}, total=False
)


class ClientUpdateVoiceChannelVoiceChannelRequestTypeDef(
    _ClientUpdateVoiceChannelVoiceChannelRequestTypeDef
):
    """
    Specifies the status and settings of the voice channel for an application.
    - **Enabled** *(boolean) --*

      Specifies whether to enable the voice channel for the application.
    """


_ClientUpdateVoiceTemplateResponseMessageBodyTypeDef = TypedDict(
    "_ClientUpdateVoiceTemplateResponseMessageBodyTypeDef",
    {"Message": str, "RequestID": str},
    total=False,
)


class ClientUpdateVoiceTemplateResponseMessageBodyTypeDef(
    _ClientUpdateVoiceTemplateResponseMessageBodyTypeDef
):
    """
    - **MessageBody** *(dict) --*

      Provides information about an API request or response.
      - **Message** *(string) --*

        The message that's returned from the API.
    """


_ClientUpdateVoiceTemplateResponseTypeDef = TypedDict(
    "_ClientUpdateVoiceTemplateResponseTypeDef",
    {"MessageBody": ClientUpdateVoiceTemplateResponseMessageBodyTypeDef},
    total=False,
)


class ClientUpdateVoiceTemplateResponseTypeDef(_ClientUpdateVoiceTemplateResponseTypeDef):
    """
    - *(dict) --*

      The request was accepted for processing. Processing may not be complete.
      - **MessageBody** *(dict) --*

        Provides information about an API request or response.
        - **Message** *(string) --*

          The message that's returned from the API.
    """


_ClientUpdateVoiceTemplateVoiceTemplateRequestTypeDef = TypedDict(
    "_ClientUpdateVoiceTemplateVoiceTemplateRequestTypeDef",
    {
        "Body": str,
        "DefaultSubstitutions": str,
        "LanguageCode": str,
        "tags": Dict[str, str],
        "TemplateDescription": str,
        "VoiceId": str,
    },
    total=False,
)


class ClientUpdateVoiceTemplateVoiceTemplateRequestTypeDef(
    _ClientUpdateVoiceTemplateVoiceTemplateRequestTypeDef
):
    """
    Specifies the content and settings for a message template that can be used in messages that are
    sent through the voice channel.
    - **Body** *(string) --*

      The text of the script to use in messages that are based on the message template, in plain
      text format.
    """
